#****************************************************************************
#MODIS_37092.t
#
#Description: MOD 9 SMF file
#
#
#Team-unique Header:
#  This software is developed by the MODIS Science Data Support
#  Team for the National Aeronautics and Space Administration,
#  Goddard Space Flight Center, under contract NAS5-32373.
#
#Revision History
#   0.1  November(?), 1995
#        Original Development
#        Paul Fisher/SDST
#        
#   0.2  April 17, 1996
#        Modified for V1 Metadata
#        Paul Fisher/SDST
#
#   0.3  May 23, 1996
#        Integrate old and new stuff for pntr.c
#	 Y-T Lau/NASA-GSFC/UMD
#
#   0.4  November 18, 1996
#        Enhanced for MOD14 L3 Version 1 delivery to SDST.
#        Paul Fisher/SSAI/NASA's GSFC Code 923
#
#   1.0  February 17, 1998
#	 Modified to MOD09 L2 2.1 DAAC patch.
#        Paul Fisher/SSAI/NASA's GSFC Code 923
#
#References and Credits
#  Written by Paul S. Fisher 
#             Research and Data Systems Corporation
#             SAIC/GSC MODIS Support Office
#             7501 Forbes Blvd
#             Seabrook MD 20706  
#
#
#END
#*****************************************************************************
%INSTR = MODIS
%LABEL = MODIS
%SEED = 37092

MODIS_A_C_GEOLOC %sThe coarse resolution geolocation will be read out of the %s file if it cannot be reconstructed from the 1km geolocation product.
MODIS_A_NO_REFLECTANCE %sThe input L1B data has been collected in night mode.  The reflectance product will not be produced for this granule. %s
MODIS_A_PCF_FILE %sInformative: using PCF file '%s'
MODIS_A_PROCESSING %sInformative: currently processing file %s
MODIS_A_PGE_VERSION %sRunning PGE version: %s.
MODIS_A_AOTR_PASS %sInformative: currently operating in aerosol retrieval mode
MODIS_A_AOTU_PASS %sInformative: currently operating in aerosol correction mode
MODIS_A_AOTR_END %sInformative: finished with aerosol retrieval, interpolating aerosols
MODIS_A_AOTU_END %sInformative: finished with aerosol correction mode
MODIS_A_CLDSHD_START %sInformative: in cloud shadow algorithm
MODIS_A_CLDSHD_END %sInformative: finished with cloud shadow algorithm

MODIS_E_CMG_IO %s%s
MODIS_E_CMG_MEMORY %s%s
MODIS_E_CMG_CREATE %s%s
MODIS_E_CMG_TRANSFER %s%s
MODIS_E_CLOUD_SHADOW %sError determining cloud shadow
MODIS_E_AOT_INTERPOLATION %sError in routine aot_interpolation, one or more AOT product SDSs will be uninterpolated
MODIS_E_VALIDATION_METADATA %sError writing validation site metadata to coarse product.  All validation site information will not be available. %s
MODIS_E_UNCODED_QA %sQA class has not been coded into summation routine.  Needs code fix. %s
MODIS_E_NO_OUTPUT %sInput granules and specified tile do not overlap. %s
MODIS_E_OPEN_GEN_FILE %sError opening file. %s
MODIS_E_FILE_READ_ERROR %sError reading file. %s
MODIS_E_CLOSE_GEN_FILE %sError closing file. %s
MODIS_E_CLOSE_HDF_FILE %s%s
MODIS_E_HDF_READ %s%s
MODIS_E_HDF_CREATE %s%s
MODIS_E_LHDF_ERROR %sLHDF error. %s
MODIS_E_HDF_ERROR %sHDF error. %s
MODIS_E_FILE_WRITE_ERROR %sError writing file: %s.
MODIS_E_NULL_INPUT %sNull input sent to function: %s.
MODIS_E_BAD_PARAMETER_READ %sUnable to read parameter %s from PCF file, using default value.
MODIS_E_OBS_ERROR %sError in obsgrid library functions: %s.
MODIS_E_LBIN_ERROR %sError in lbin library functions: %s.
MODIS_E_BUF_ERROR %sError in buf library functions: %s.
MODIS_E_BAD_ENUM %sImproper enumeration parameters passed to function %s.
MODIS_E_SETECSFROMPCF_FAIL %sSetECSfromPCF failed.  ECS metadata will not be written correctly to %s.
MODIS_E_DATE_FAIL %sFailure adding date attributes to file. %s
MODIS_E_SREFL_FINISH %sError exit from srefl2gr.  Output file not correct.  %s
MODIS_E_SREFL_ERROR %sError in surface reflectance process (srefl2gr): %s.
MODIS_E_SREFL_WV_ANCIL %sUsing ancillary data instead of the MODIS water vapor product: %s.
MODIS_E_INPUT_NOMATCH %sInput files do not correspond to each other: %s
MODIS_E_NO_WATER_VAPOR %sNo water vapor input data available. %s
MODIS_E_FILE_MISSING %s%s.
MODIS_E_SREPORT_FAIL %sError writing to status report: %s.
MODIS_E_CALLOC_FAIL %sCalloc allocation error. %s
MODIS_E_FUNCTION_ERROR %s%s.
MODIS_E_TEMP_DELETE %sError deleting temporary buf file: logical %s.
MODIS_E_MEM_FAILURE %sMemory allocation failure: %s
MODIS_E_BAD_SYSTEM_TIME %s %s
MODIS_E_NULL_STRING %sCharacter array %s has not been allocated any memory.
MODIS_E_SDP_METADATA %sFailure from %s, ECS metadata will not be written correctly.
MODIS_E_SDP_ERROR %sFailure from SDP toolkit in function %s.
MODIS_E_GETREF_FAIL %sFailure to get filename from the PCF file. %s.
MODIS_E_GETUR_FAIL %sFailure to get UR from the PCF file. %s.
MODIS_E_BAD_INPUT_PARAMETER %s%s
MODIS_E_GETFILEINFO %sUnable to retrieve file information: %s. 
MODIS_E_GET_METADATA %s%s.
MODIS_E_GETCONFIG_FAIL %sFailure to get command line parameter %s from PCF file.
MODIS_E_OPEN_HDF_FILE %sError opening HDF file %s: 
MODIS_E_LHD3_ERROR %s%s
MODIS_E_FIRE_LEVTHREE %s%s
MODIS_E_STAGING_ERROR %sA differing number of MODIS product granules have been staged for some input file types.  %s
MODIS_E_BAD_TIME_CONV %s%s
MODIS_E_STAGE_MISMATCH %s%s
MODIS_E_FILE_ACCESS %sError accessing file: %s.
MODIS_E_BAD_FILE %s%s
MODIS_E_SMF_ERROR %sSMF message string too long.  The next error message will be truncated to (PGS_SMF_MAX_MSG_SIZE-1) bytes.  This may be a coding error.
MODIS_E_HDFEOS_FAILURE %sFailure in HDF-EOS from function %s.
MODIS_E_HDF_FAILURE %sHDF failure from function %s.
MODIS_E_BAD_GEOLOCATION %sBad geolocation data, %s.
MODIS_E_SKIP_GRANULE %sFatal granule error %s.  Processing will continue with the next output granule.
MODIS_E_SKIP_SREFL250 %sGranule error %s.  Processing will continue without the 250m bands.
MODIS_E_SKIP_SREFL500 %sGranule error %s.  Processing will continue without the 500m bands.
MODIS_E_SKIP_FIRE %sGranule error %s.  MOD09 processing will continue without MOD14.
MODIS_E_BAD_CLOUD %sGranule error %s.  All processing will continue without MOD35.
MODIS_E_BAD_OZONE %sGranule error %s.  All processing will continue without MOD07 using ancillary data (if available).
MODIS_E_BAD_WV %sGranule error %s.  All processing will continue without MOD05 using ancillary data (if available).
MODIS_E_SREF_GRAN_NOT_PRDCD %sL2 surface reflectance granule not created:
MODIS_E_SREFCRS_GRAN_NOT_PRDCD %sL2 coarse resolution surface reflectance granule not created:
MODIS_E_SREF_GRAN_ERROR %sGranule error, From this point on the L2 surface reflectance granule contains no or faulty data: %s
MODIS_E_SREFCRS_GRAN_ERROR %sGranule error.  From this point on the L2 coarse resolution surface reflectance granule contains no or faulty data: %s
MODIS_E_FIRE_GRAN_ERROR %sGranule error.  From this point on the L2 fire granule contains no or faulty data: %s
MODIS_E_ALL_GRAN_BAD %sL2 granules contains no or faulty data: %s
MODIS_E_BAD_FILE_FORMAT %sImproper file format: %s.
MODIS_E_INTERP_ERROR %sError interpolating: %s
MODIS_E_SREFL_L2GRAN %sL2 surface reflectance granule not created successfully, this could be a problem writing ECS metadata: %s
MODIS_E_SREFLCRS_L2GRAN %sL2 coarse resolution surface reflectance granule not created successfully, this could be a problem writing ECS metadata: %s
MODIS_E_FIRE_L2GRAN %sL2 fire granule not created successfully, this could be a problem writing ECS metadata: %s
MODIS_E_GET_SDP_METADATA %sFailure reading ECS metadata from file %s.
MODIS_E_GETNUM_FILES %sFailure in SDP function PGS_PC_GetNumberOfFiles, Logical: %s.
MODIS_E_DAO_FAIL %sMatching DAO file is not available for %s.
MODIS_E_BAD_GRID %sGridded input data is not in the correct Integerized Sinusoidal projection or the tile dimensions are not 1200 square pixels. %s
MODIS_E_BAD_LANDCOVER %sUnable to access land cover information: %s
MODIS_E_BAD_MCF %s%s in MCFs, make sure the correct MCFs are staged; will use internally generated ESDTs
MODIS_E_PCF_MCF_MISMATCH %sSatelliteInstrument value in PCF doesn't match MCFs ShortName values; will use internally generated ESDTs %s
MODIS_E_BOUND_COORD %s%s


MODIS_F_CODING_ERROR %s%s.
MODIS_F_GET_SDP_METADATA %sFailure reading ECS metadata from file %s.
MODIS_F_GETFILEINFO %sUnable to retrieve file information: %s. 
MODIS_F_BAD_COMMAND_LINE %sImproper command line syntax.  %s.
MODIS_F_BAD_FILE_FORMAT %sImproper file format: %s.
MODIS_F_FILE_READ_ERROR %sError reading file: %s.
MODIS_F_FILE_WRITE_ERROR %sError writing file: %s.
MODIS_F_BAD_PARAMETER_READ %sUnable to read parameter %s from PCF file.
MODIS_F_IMPROPER_RESOLUTION %s%s is not a proper input resolution.
MODIS_F_SREFL_ERROR %sError in surface reflectance process (srefl2gr): %s.
MODIS_F_INPUT_NOMATCH %sProduct input files do not correspond to each other: %s
MODIS_F_BAD_PCF_FILE %sError in PCF file structure. %s
MODIS_F_FUNCTION_ERROR %s%s
MODIS_F_BAD_BAND_SELECTION %sFatal Error. %s
MODIS_F_SDP_ERROR %sFailure from SDP toolkit in function %s.
MODIS_F_BRDFCOEF_ERROR %sBRDF coefficient error: %s
MODIS_F_MEM_FAILURE %sExecutable halted.  Memory allocation failure: %s
MODIS_F_OPEN_GEN_FILE %sExecutable halted.  Fatal error opening file %s.
MODIS_F_OPEN_TEMP_FILE %sExecutable halted.  Fatal error opening file %s.
MODIS_F_OPEN_INTRM_FILE %sExecutable halted.  Fatal error opening file %s.
MODIS_F_CLOSE_GEN_FILE %sExecutable halted.  Fatal error closing file %s.
MODIS_F_CLOSE_TEMP_FILE %sExecutable halted.  Fatal error closing file %s.
MODIS_F_CLOSE_INTRM_FILE %sExecutable halted.  Fatal error closing file %s.
MODIS_F_CALLOC_FAIL %sExecutable halted.  Calloc allocation error: %s.
MODIS_F_MALLOC_FAIL %sExecutable halted.  Malloc allocation error: %s.
MODIS_F_NONCOMPT_INPUT %sExecutable halted.  No compatible input files %s
MODIS_F_REALLOC_FAIL %sExecutable halted.  Memory reallocation error: %s.
MODIS_F_COMPILE_TIME_ERROR %s%s
MODIS_F_MEM_FREE_FAIL 
           %sExecutable halted.  Unable to free memory structure %s
MODIS_F_MEM_ZERO 
           %sExecutable halted.  Fatal error initializing memory block 
           or structure to zero: %s.
MODIS_F_GETREF_FAIL %sFailure to get reference ID from PCF file. %s.
MODIS_F_GETCONFIG_FAIL %sFailure to get command line parameter %s from PCF file.
MODIS_F_LEVEL1B_READ %sFailure reading L1B data. %s.
MODIS_F_OPEN_HDF_FILE %sExecutable halted.  Error opening HDF file %s: 
MODIS_F_GETNUM_FILES %sFailure in SDP function PGS_PC_GetNumberOfFiles, Logical: %s.
MODIS_F_NO_PROCESS_SPECIFIED %sNo products were specified for processing within the PCF file; neither the fire product or any individual reflective bands.  %s
MODIS_F_ANCILLARY_DATA_ERROR %sTwo ancillary data files bracketing the granule time must be staged %s.

MODIS_S_SUCCESS MODIS %sModule successful. %s.
MODIS_S_SREFL_L2GRAN %sL2 surface reflectance granule created successfully: %s
MODIS_S_SREFLCRS_L2GRAN %sL2 coarse resolution surface reflectance granule created successfully: %s
MODIS_S_FIRE_L2GRAN %sL2 fire granule created successfully: %s

MODIS_W_SDP_METADATA %sWithin %s.
MODIS_W_GET_METADATA %s%s.
MODIS_W_SREFL_ERROR %sWarning from surface reflectance process (srefl2gr): %s.
MODIS_W_SREFL_WV_ANCIL %sUsing ancillary data instead of the MODIS water vapor product: %s.
MODIS_W_SREFL_ANCIL %sUnable to read ancillary data file: %s.
MODIS_W_FUNCTIONALITY_NOT_AVAIL %s%s
MODIS_W_FILE_MISSING %s%s.
MODIS_W_INFORMATION %s Warning ... %s.
MODIS_W_FUNCTION_ERROR %s%s.
MODIS_W_BAD_PROCESSING_TIME %sUnable to retrieve %s from the PCF.  Comparison will not be performed.
MODIS_W_OUT_OF_ORBIT %sInput granules with a range beginning time of %s do not occur within the expected input orbit.  These granules will not be processed.
MODIS_W_BOUND_COORD %s Bounding Coordinates missing from input metadata, estimating using GRING parameters. %s



