#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include "modis_srefl.h"
#include "protos.h"
#include "PGS_PC.h"

#define T3_WAVENUMBER           2639.78    /* in cm^-1 */   /* FOR BAND 20 */
#define M_PI                    3.14159265358979323846
#define K                       16.68                  /* solar irradiance, in mW/(m^2 cm^-1) */
#define RANGEBEGINNINGDATETIMEDEFAULT "RANGEBEGINNINGDATETIME not read from input file"
/*enum{NOMODEL, SMKL, SMKH, DSST, URBP, URBC, MODELS};   /  * 31-OCT-05 */

/* All these externs refer to global.h */
extern d_ancillary daoozone;  
extern d_ancillary gdasozone;
extern d_ancillary daospres;
extern d_ancillary daowv;
extern d_ancillary daotmp;
extern d_ancillary daouwnd;
extern d_ancillary daovwnd;
extern d_ancillary avg_z; 
extern int32 locator500[NBSCANS_500M*NBSPOTS_500M];
extern int32 locator250[NBSCANS_250M*NBSPOTS_250M];  
extern int32 locator500_250[NBSCANS_250M*NBSPOTS_250M];  
extern float **Rho_ra_term, **Rho_r_term, **Step1_term, **Step2_term, **Step3_term, **SRA_term, **btau;
extern float **hkmRho_ra_term, **hkmRho_r_term, **hkmStep1_term, **hkmStep2_term, **hkmStep3_term, **hkmSRA_term;
extern float **qkmRho_ra_term, **qkmRho_r_term, **qkmStep1_term, **qkmStep2_term, **qkmStep3_term, **qkmSRA_term;
extern d_sds **sds_outputlist;
extern int currentlyopen, current_n_CMGwindows,n_ret;
extern int make_this_cmg[3];
extern char CMG_lgid_template[256];
extern float leftlon;
extern input_metadata **CMGmetadata;
extern commands_t commands;
extern int n_bands_res[3]; /* 250m, 500m, 1km */
extern float32 ALPHAF, BETAF, GAMMAF, DELTAF, MIRAFTOG, MIRAFTIG, TATOG, TATIG, ROGT;
extern input_metadata *metadata;
extern output_type_t output_type[ALLBANDS];
extern aerosol_retr_rej_t aotr_struct;
extern int newl1bformat, l1b_needs_aggregation, band26corr;
extern PGSt_double orbit_start_tai, orbit_end_tai;
extern int sat_type;
extern float32 *sref[7];  /* Simulated reflectance arrays.  Simulation is performed for 73 values of
	                     relative azimuth phi ranging from 0 to 180, for 22 values of solar and
	                     viewing zenith angles ranging from x to y, and for 10 values of aerosol
	                     optical thickness. */
extern float32 *ta_tab[7];      /* transmission */
extern float32 Sra_tab[7][10];  /* surface albedo */

extern float32 tauray[NBANDS];
extern float32 oztransa[NBANDS];
extern float32 wvtransa[NBANDS],wvtransb[NBANDS],wvtransc[NBANDS];
extern float32 ogtransa0[NBANDS],ogtransa1[NBANDS];
extern float32 ogtransb0[NBANDS],ogtransb1[NBANDS];
extern float32 ogtransc0[NBANDS],ogtransc1[NBANDS];
extern float32 nbfi[NTS][NXX],tsmax[NTS][NXX],tsmin[NTS][NXX];
extern float32 ttv[NTS][NXX],nbfic[NTS][NXX];
extern float32 tts[NTS];
extern int indts[NTS];

extern float32 rolutt[NBANDS][NPR][NAOT][8000];
extern float32 transt[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbt[NBANDS][NPR][NAOT];    /* for now */
extern float32 roluttSMKL[NBANDS][NPR][NAOT][8000];
extern float32 transtSMKL[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtSMKL[NBANDS][NPR][NAOT];  
extern float32 roluttSMKH[NBANDS][NPR][NAOT][8000];
extern float32 transtSMKH[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtSMKH[NBANDS][NPR][NAOT];   
extern float32 roluttDUST[NBANDS][NPR][NAOT][8000];
extern float32 transtDUST[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtDUST[NBANDS][NPR][NAOT];  
extern float32 roluttURBPOL[NBANDS][NPR][NAOT][8000];
extern float32 transtURBPOL[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtURBPOL[NBANDS][NPR][NAOT];  
extern float32 roluttURBCLN[NBANDS][NPR][NAOT][8000];
extern float32 transtURBCLN[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtURBCLN[NBANDS][NPR][NAOT];  

/* make these global to this file */
float xtsmin=0.0F;
float xtsstep=4.0F;
float xtvmin=2.84090F;
float xtvstep=(6.52107-2.84090);
float tpres[7] = {1050.0F, 1013.0F, 900.0F, 800.0F, 700.0F, 600.0F, 500.0F};
float OLDerelc[16] =  {0.6, -1.0,  0.3, -1.0, -1.0, -1.0,  1.0,  0.192632, 0.241579, 0.312632, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0}; /* for OLD model LUT */
/* 31-MAY-06: erelc[6] changed from 1.0 to 2.0 */
float erelc[16] =  {1.0, -1.0, 0.515,-1.0, -1.0, -1.0, 2.0,  0.3905,   0.475,    0.578,    -1.0, -1.0, -1.0, -1.0, -1.0, -1.0};  /* for NEW model LUTs */
float erelco[16] = {1.0,  0.5, -2.0, -2.0, -0.5, -2.0, -0.5, -2.0,     -2.0,     -2.0,      -2.0, -2.0, -2.0,  1.0,  0.75, 0.5};   /* for oceans */
/*float aot550nm[16] = {0.01,0.05,0.10,0.15,0.20,0.30,0.40,0.60,0.80,1.00,1.20,1.40,1.60,1.80,2.00}; OLD */
float aot550nm[NAOT] = {0.01,0.05,0.10,0.15,0.20,0.30,0.40,0.60,0.80,1.00,1.20,1.40,1.60,1.80,2.00,2.30,2.60,3.00,3.50,4.00,4.50,5.00};

float tgo_array[16][NBSPOTS_1KM*NBSCANS_1KM];   /* yes, wads of memory...  so sorry */
float roatm_array[16][NBSPOTS_1KM*NBSCANS_1KM];
float ttatmg_array[16][NBSPOTS_1KM*NBSCANS_1KM];
float satm_array[16][NBSPOTS_1KM*NBSCANS_1KM];
float xrorayp_array[16][NBSPOTS_1KM*NBSCANS_1KM];
int MYSCAN = 8;
int MYINDEX = 1290;

t_atmospars atmos;
static float32 c550_to_band1 = 0.8287F; /* 0.646 um */
static float32 c550_to_band2 = 0.5807F; /* 0.856 um */
static float32 c550_to_band3 = 1.2003F; /* 0.466 um */
static float32 c550_to_band4 = 0.9940F; /* 0.554 um */
static float32 c550_to_band5 = 0.3669F; /* 1.242 um */
static float32 c550_to_band6 = 0.2565F; /* 1.629 um */
static float32 c550_to_band7 = 0.1666F; /* 2.115 um */
float dsol;
int bad_geoloc;
int do_climatology = 0;   /* for now */

/* 11-MAY-04: center wavelength values for each band/detector (in microns) */
float64 aqua_lambdas[BANDPROCESS-BAND20+1][10] = {

/*BAND20   */ {3.78026F, 3.78026F, 3.78026F, 3.78026F, 3.78026F, 3.78024F, 3.78021F, 3.78023F, 3.78028F, 3.78028F},
/*BAND21   */ {3.98180F, 3.98180F, 3.98181F, 3.98180F, 3.98180F, 3.98179F, 3.98180F, 3.98182F, 3.98182F, 3.98182F},
/*BAND22   */ {3.97204F, 3.97204F, 3.97206F, 3.97206F, 3.97206F, 3.97205F, 3.97206F, 3.97206F, 3.97205F, 3.97205F},
/*BAND23   */ {4.06165F, 4.06165F, 4.06162F, 4.06161F, 4.06165F, 4.06164F, 4.06162F, 4.06164F, 4.06164F, 4.06164F}, 
/*BAND24      {4.44825F, 4.44825F, 4.44825F, 4.44827F, 4.44828F, 4.44836F, 4.44846F, 4.44843F, 4.44848F, 4.44848F}, NOT CURRENTLY USED*/
/*BAND25      {4.52629F, 4.52629F, 4.52637F, 4.52635F, 4.52631F, 4.52631F, 4.52632F, 4.52633F, 4.52635F, 4.52635F}, NOT CURRENTLY USED*/
/*BAND26   */ {0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F},
/*BAND27      {6.78680F, 6.78655F, 6.78654F, 6.78667F, 6.78691F, 6.78703F, 6.78704F, 6.78702F, 6.78716F, 6.78716F}, NOT CURRENTLY USED*/
/*BAND28      {7.34949F, 7.34949F, 7.34938F, 7.34928F, 7.34932F, 7.34937F, 7.34945F, 7.34948F, 7.34943F, 7.34943F}, NOT CURRENTLY USED*/
/*BAND29   */ {8.55534F, 8.55534F, 8.55534F, 8.55529F, 8.55531F, 8.55525F, 8.55537F, 8.55548F, 8.55561F, 8.55559F},
/*BAND30      {9.72422F, 9.72422F, 9.72432F, 9.72449F, 9.72430F, 9.72404F, 9.72393F, 9.72390F, 9.72389F, 9.72389F}, NOT CURRENTLY USED*/
/*BAND31   */ {11.02626F, 11.02626F, 11.02630F, 11.02631F, 11.02618F, 11.02643F, 11.02607F, 11.02663F, 11.02635F, 11.02635F},
/*BAND32   */ {12.04236F, 12.04236F, 12.04235F, 12.04233F, 12.04233F, 12.04239F, 12.04241F, 12.04221F, 12.04257F, 12.04257F}
/*BAND33      {13.36490F, 13.36482F, 13.36478F, 13.36481F, 13.36483F, 13.36484F, 13.36482F, 13.36478F, 13.36478F, 13.36478F}, NOT CURRENTLY USED*/
/*BAND34      {13.68598F, 13.68598F, 13.68595F, 13.68589F, 13.68593F, 13.68591F, 13.68588F, 13.68597F, 13.68612F, 13.68612F}, NOT CURRENTLY USED*/
/*BAND35      {13.92526F, 13.92526F, 13.92520F, 13.92528F, 13.92526F, 13.92530F, 13.92528F, 13.92524F, 13.92539F, 13.92539F}, NOT CURRENTLY USED*/
/*BAND36      {14.21550F, 14.21546F, 14.21551F, 14.21543F, 14.21466F, 14.21545F, 14.21532F, 14.21553F, 14.21535F, 14.21535F}, NOT CURRENTLY USED*/
/*BANDPROCESS*/};

float64 terra_lambdas[BANDPROCESS-BAND20+1][10] = {

/*BAND20   */ {3.78821F, 3.78821F, 3.78824F, 3.78827F, 3.78825F, 3.78818F, 3.78823F, 3.78827F, 3.78824F, 3.78827F},
/*BAND21   */ {3.99215F, 3.99215F, 3.99215F, 3.99217F, 3.99218F, 3.99216F, 3.99214F, 3.99219F, 3.99216F, 3.99220F},
/*BAND22   */ {3.97194F, 3.97194F, 3.97192F, 3.97193F, 3.97197F, 3.97199F, 3.97199F, 3.97198F, 3.97198F, 3.97202F},
/*BAND23   */ {4.05673F, 4.05673F, 4.05675F, 4.05671F, 4.05672F, 4.05672F, 4.05670F, 4.05672F, 4.05674F, 4.05675F}, 
/*BAND24      {4.47321F, 4.47321F, 4.47321F, 4.47321F, 4.47321F, 4.47323F, 4.47323F, 4.47322F, 4.47322F, 4.47323F}, NOT CURRENTLY USED*/
/*BAND25      {4.54540F, 4.54540F, 4.54537F, 4.54537F, 4.54537F, 4.54537F, 4.54537F, 4.54537F, 4.54537F, 4.54538F}, NOT CURRENTLY USED*/
/*BAND26   */ {0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F, 0.00000F},
/*BAND27      {6.77069F, 6.77039F, 6.77009F, 6.77025F, 6.77036F, 6.77053F, 6.77073F, 6.77083F, 6.77089F, 6.77089F}, NOT CURRENTLY USED*/
/*BAND28      {7.34287F, 7.34285F, 7.34286F, 7.34289F, 7.34298F, 7.34291F, 7.34290F, 7.34286F, 7.34285F, 7.34285F}, NOT CURRENTLY USED*/
/*BAND29   */ {8.52901F, 8.52890F, 8.52885F, 8.52887F, 8.52893F, 8.52884F, 8.52890F, 8.52884F, 8.52884F, 8.52884F},
/*BAND30      {9.73440F, 9.73425F, 9.73438F, 9.73429F, 9.73439F, 9.73429F, 9.73433F, 9.73434F, 9.73439F, 9.73439F}, NOT CURRENTLY USED*/
/*BAND31   */ {11.01875F, 11.01875F, 11.01875F, 11.01903F, 11.01903F, 11.01903F, 11.01913F, 11.01913F, 11.01954F, 11.01876F},
/*BAND32   */ {12.03199F, 12.03199F, 12.03241F, 12.03247F, 12.03237F, 12.03237F, 12.03187F, 12.03228F, 12.03193F, 12.03193F}
/*BAND33      {13.36462F, 13.36537F, 13.36484F, 13.36566F, 13.36531F, 13.36515F, 13.36554F, 13.36535F, 13.36485F, 13.36496F}, NOT CURRENTLY USED*/
/*BAND34      {13.68308F, 13.68308F, 13.68416F, 13.68358F, 13.68317F, 13.68291F, 13.68325F, 13.68349F, 13.68349F, 13.68418F}, NOT CURRENTLY USED*/
/*BAND35      {13.91308F, 13.91308F, 13.91308F, 13.91336F, 13.91320F, 13.91345F, 13.91322F, 13.91407F, 13.91407F, 13.91255F}, NOT CURRENTLY USED*/
/*BAND36      {14.19389F, 14.19550F, 14.19666F, 14.19530F, 14.19663F, 14.19652F, 14.19709F, 14.19445F, 14.19639F, 14.19461F}, NOT CURRENTLY USED*/
/*BANDPROCESS*/};

int time_point;   /* 13-APR-06: just to make sure whatever time point we're on can be accessed by other routines in this file */

int atmospheric_correction(int AOTR_flag, dims_struct ***inputs, dims_struct ***outputs, int n_timepoints)
/*
!C****************************************************************************

!Routine: atmospheric_correction()

!Description: The main atmospheric correction module of the program

!Input Parameters:
  int AOTR_flag               to generate AOT (=1) or to use AOT in atm correction (=0)
  dims_struct ***inputs       the time-sequenced inputs
  int n_timepoints            the number of timepoints
 
!Input/Output Parameters:
  dims_struct ***outputs       
  
!Output Parameters:
  none

!Returns:
  none
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    Variable "inputs" is meant to contain data (all metadata, filenames and 
    PCF version numbers) about all L1B inputs, geolocation and cloudmask 
    files -- sorted into temporal order.  This routine does the following
    processing upon each time-point:
        1) opens all time-sensitive inputs (time-insensitive inputs, such as
	   LUTs, should be opened earlier)
	2) opens the appropriate outputs
	3) calls atmcorrect()
	4) closes all inputs and outputs.

!END**************************************************************************/
{
int i,j,tp;   /* time-point */
extern t_atmospars atmos;
dims_struct **local_input, **local_output;
int ret, n_scans, n_scans_corrected, n_linesperscan, nlines_1km, ncols_1km, local_process_bands[BANDPROCESS];
extern int32 process_bands[BANDPROCESS];
int32 start[3], dims[3], which;
long total_bytes;
uint16 *memory;
char lgid[40];
char source[200];
char remarks[200];
char report[2000];
char location[50]="atmcor.c, atmospheric_correction";
char time[25];
int band_numbers[BANDPROCESS];
int day_or_night;
float *fcoarse;
int nblines, nbcols;
int total_1km_pixels, total_pixels;
int get_day_night(char *daynightflag);
char msg[256] = {'\0'};
char scantxt[4];
double om, d;
int32 julianday;
int scan_day;
extern float dsol;
qavals_t *qavalues;
int32 highsolarzenith;
char formatstring[15];
int index500m;
int bandindex;
int files_are_bad;
extern int32 scans_per_gran;

void night_coarse_output(dims_struct *rad1km_input, dims_struct *geo_input, dims_struct *output, int *local_process_bands);
void setattr_wrapper_array(PGSt_MET_handle handle, char *namestring, void **value);
PGSt_SMF_status get_inputpointers(input_metadata *metadata, dims_struct **inputs);
void pop_inputpointers(input_metadata *metadata, dims_struct **inputs);
int process_metadata(int local_process_bands[], qavals_t *qavalues, dims_struct **outputs, 
                     dims_struct *rad1km_input, dims_struct *geo_input, input_metadata *metadata, int n_scans);
int night_process_metadata(int local_process_bands[], qavals_t *qavalues, dims_struct *outputs, 
                           dims_struct *rad1km_input, dims_struct *geo_input, input_metadata *metadata, int n_scans);
int atmcorrect(int AOTR_flag, dims_struct **local_input, dims_struct **local_output, int scan_number, int total_1km_pixels, 
               int *local_process_bands, float *fcoarse, int32 *highsolarzenith, qavals_t *qavalues);
void writeQAattributes(dims_struct *outputs, int sds_index);
void readwriteStateQAattributes(int32 stateqa_sds, int32 fine_sdid, int32 coarse_sdid, long n_lines);
int32 format_to_int32(char *format);
int check_inputs(int day_or_night, int AOTR_flag, dims_struct **inputs, int local_process_bands[]);

/* get memory for coarse-resolution buffers */
if(NBSCANS_1KM % SREFL_COARSESIZE == 0) nblines = NBSCANS_1KM/SREFL_COARSESIZE;
else nblines=((int32)(NBSCANS_1KM/SREFL_COARSESIZE))+1;
nbcols = ((int32)(NBSPOTS_1KM/SREFL_COARSESIZE)) +1;
get_memory((void **)&fcoarse, DFNT_FLOAT, nblines*nbcols);

initatmospars(&atmos);
if /*(AOTR_flag == 0)*/(AOTR_flag != 1) {
   qavalues = (qavals_t *)malloc(sizeof(qavals_t));
   initqavalues(qavalues);
   }
   
/* get memory for local I/O structures */
get_input_str_1D_memory(&local_input, ALL_L1B_FILES);
get_input_str_1D_memory(&local_output, 2);

scan_day = 0;

if (commands.use_modaot == 0) do_climatology = 1;

if (AOTR_flag == 1) modsmf(MODIS_A_AOTR_PASS, " ", location);
else                modsmf(MODIS_A_AOTU_PASS, " ", location);

for (tp = 0; tp < n_timepoints; tp++) {

   time_point = tp;  /* 13-APR-06 */

   /* Make entirely LOCAL version of process_bands; do NOT overwrite 
      the global version of process_bands */
   for(i=0;i<BANDPROCESS;i++) local_process_bands[i] = process_bands[i]; 

   /* and reset these bastards (global) */
   bandindex = 0;
   n_bands_res[0] = n_bands_res[1] = n_bands_res[2] = bandindex;
   for (i=0;i<BAND8;i++) {
       if ((i==BAND1_500M)||(i==BAND1_1KM))bandindex++;
       if (process_bands[i] == 1) n_bands_res[bandindex]++;
       }

   /* if AOTR == 1, set local_process_bands to skip processing of 250m data */
   if (AOTR_flag == 1) {
      local_process_bands[BAND1_250M] = 0; 
      local_process_bands[BAND2_250M] = 0; 
      }

   /* make local copies of the inputs... */
   for(i=0;i<ALL_L1B_FILES;i++)  {   /* for each L1B input */
       structcpy((local_input[i]), (inputs[i][tp]) );
     }
  
   /* get day_or_night (1 for day or both, 0 for night or undefined) */
   day_or_night = get_day_night(local_input[RAD1_FILE]->xxxxx->daynightflag);
   
   /* make real sure all rbdt's for this time-point have been read; adjust local_process_bands accordingly */
   files_are_bad = check_inputs(day_or_night, AOTR_flag, local_input, local_process_bands);
     
   if (files_are_bad) {
      /*  Why doesn't this work?
      close_io_struct2(local_input, ALL_L1B_FILES); 
      close_io_struct2(local_output, 2);   */
      continue;
      }
   
   /* Get dsol. */
   julianday = getjulianday(local_input[RAD1_FILE]->xxxxx->rbdt);
   om=(0.9856*(julianday-4))*PI_180;
   d=(1.0-0.01673*cos(om));
   dsol=(float)(1.0/(d*d));
 
   /* init the full-resolution file name */
   if (local_output[0]->filename != NULL) {
       free(local_output[0]->filename);
       local_output[0]->filename = (char *)NULL;
       }
  
   /* SDstart, open up the inputs: get nblines/nbcols */
   if (open_inputs(local_input, &nlines_1km, &ncols_1km, local_process_bands) == 1)  {
        sprintf(msg, "No input L1B granule containing a RANGEBEGINNINGDATETIME of %s was staged; will skip time-point", local_input[RAD1_FILE]->xxxxx->rbdt);
        modsmf((PGSt_SMF_code)MODIS_E_STAGE_MISMATCH, msg, location);
	continue;
      }
      
   for(j=0;j<ALL_L1B_FILES;j++) 
       for(i=0;i<BANDPROCESS;i++) 
           if (local_input[j]->band_name[i] != -1) band_numbers[i] = local_input[j]->band_name[i];

   sprintf(report, "Processing the following files, time %s:\n\0", local_input[RAD1_FILE]->xxxxx->rbdt);
   for(i=0;i<ALL_L1B_FILES;i++) {
     if (local_input[i]->OK == 0) {
        sprintf(report+strlen(report), "LUN %d, version %d, file %s\n\0", 
            local_input[i]->lun, local_input[i]->ver, local_input[i]->filename);
        sprintf(msg, "'%s', LUN %ld, version %d", 
	         local_input[i]->filename, local_input[i]->lun, local_input[i]->ver);
        modsmf(MODIS_A_PROCESSING, msg, location);
	    }
       }
   PGS_SMF_GenerateStatusReport(report);

   band26corr = 0;   /* assume band26 IS NOT already corrected */
   strcpy(formatstring, "4.0.5\0");  /* 4.0.5 as of 02-JUL-02, pers. comm., Farida Adimi, MCST */
   /*printf("version %d: %d\n", local_input[RAD1_FILE]->xxxxx->int_pgeversion, format_to_int32(formatstring));*/
   if (local_input[RAD1_FILE]->xxxxx->int_pgeversion >= format_to_int32(formatstring)) {
      band26corr = 1;      
      modsmf(MODIS_W_INFORMATION, "L1B version indicates band 26 has already been corrected"
                                  ", will NOT correct band 26", location);
      }

   /* get ancillary data (this puts ancillary data filenames into inputpointers too) */
   get_ancillary_data(AOTR_flag, local_input[RAD1_FILE]->xxxxx->rbdt);   /* RAD1_FILE is mandatory */
   /*if (daoozone.wasread) printf("OZONE %f\n", daoozone.data[0]);*/
   
   /* get L1B inputpointers etc into "metadata"; these will later be copied into output file metadata */
   if /*(AOTR_flag == 0)*/(AOTR_flag != 1) get_inputpointers(metadata, local_input);
   
   if (!day_or_night) {  /* at night, special night-time processing... */
     if /*(AOTR_flag == 0)*/  /*(AOTR_flag != 1)*/ (AOTR_flag == 2) {   /* if we are NOT doing AOT retrieval */
         if (commands.coarse_product == 1) {
         if (open_coarse_outputs(RCOARSE, &local_output[1], local_input[RAD1_FILE]->ver, nlines_1km, ncols_1km, 
                                 local_process_bands, band_numbers, day_or_night))  {
             sprintf(msg, "Executable halted.  Error opening Coarse Resolution Surface Reflectance HDF file, time %s", local_input[RAD1_FILE]->xxxxx->rbdt);
             modsmf((PGSt_SMF_code)MODIS_F_OPEN_HDF_FILE, msg, location);
 	     continue;
             }

          night_coarse_output(local_input[RAD1_FILE], local_input[GEO_FILE], local_output[1], local_process_bands);

          /* take care of global (core/archive) metadata */
          night_process_metadata(local_process_bands, qavalues, local_output[1], local_input[RAD1_FILE], local_input[GEO_FILE], metadata, 0);

          /* Close output file */
          close_HDF_interface(local_output[1]);
	  }
        }  /* if (AOTR_flag)  */
	 
     }  /*  if (!day_or_night) */
   else {/* day-time */
     if (open_outputs(AOTR_flag, REF, &local_output[0], local_input[GEO_FILE], nlines_1km, ncols_1km, local_process_bands, 
                      band_numbers))  {
          sprintf(msg, " -- Surface Reflectance HDF file, time %s", local_input[RAD1_FILE]->xxxxx->rbdt);
          modsmf((PGSt_SMF_code)MODIS_F_OPEN_HDF_FILE, msg, location);
	  continue;
        }
      if (/*AOTR_flag == 0*/ /*AOTR_flag != 1*/  AOTR_flag == 2 ) {   /* if we are NOT doing AOT retrieval */
        if (commands.coarse_product == 1) {
        if (open_coarse_outputs(RCOARSE, &local_output[1], local_input[RAD1_FILE]->ver, nlines_1km, ncols_1km, 
                                local_process_bands, band_numbers, day_or_night))  {
             sprintf(msg, "Executable halted.  Error opening Coarse Resolution Surface Reflectance HDF file, time %s", local_input[RAD1_FILE]->xxxxx->rbdt);
             modsmf((PGSt_SMF_code)MODIS_F_OPEN_HDF_FILE, msg, location);
	     continue;
           }
	   }
        }  /* if (AOTR_flag)  */

     /* Get memory for a scan */
     total_1km_pixels = NBSCANS_1KM*local_input[RAD1_FILE]->nbcols;
     get_scan_memory(AOTR_flag, local_input, local_output, total_1km_pixels, local_process_bands);
  
     n_scans = local_input[RAD1_FILE]->nblines/NBSCANS_1KM;  /* RAD1_FILE is mandatory */
     if ((scans_per_gran > 1)&&(scans_per_gran < n_scans))
         n_scans = scans_per_gran;
	 
     n_scans_corrected = 0;
     highsolarzenith = 0;
     
     /* Here do the actual atm correction and I/O */
     for(i=0;i<n_scans;i++) {

           ret = atmcorrect(AOTR_flag, local_input, local_output, i, total_1km_pixels, local_process_bands, fcoarse,  
	                    &highsolarzenith, qavalues); 
           if (ret == 0) n_scans_corrected++;

	   if (commands.makegcm == 1) {
	      if (AOTR_flag == 1)      which_ids(local_input[GEO_FILE]->data[0]);
	      else if (AOTR_flag == 2) update_ids(scan_day, local_input, local_output[0]);
	      scan_day++;
	      }
         }

     free_scan_memory(AOTR_flag, local_input, local_output, local_process_bands);
     
     /* 12-NOV-03: write all QA-related metadata */
     if /*(AOTR_flag == 0)*/ /*(AOTR_flag != 1)*/ (AOTR_flag == 2){
         sprintf(scantxt, "%d\0", n_scans);
         if(SDsetattr(local_output[0]->sdid, "Number of instrument scans\0", DFNT_CHAR, 4, (void *)scantxt)){
              sprintf(msg, "Unable to write 'Number of instrument scans' as global metadata");
              modsmf(MODIS_E_LHDF_ERROR, msg, location);
              }   
         writeQAattributes(local_output[0], (int)AOTCM);
         writeQAattributes(local_output[0], (int)AOTQA);
         writeQAattributes(local_output[0], (int)QKMQA);
         writeQAattributes(local_output[0], (int)HKMQA);
         writeQAattributes(local_output[0], (int)OKMQA);
         readwriteStateQAattributes(local_output[0]->sdsid[STATE], local_output[0]->sdid, local_output[1]->sdid, (long)n_scans);

         /* 03-NOV-05: More stuff for AOT SDSs */
         sprintf(remarks, "0 = no AOTR, 1 = SMKL, 2 = SMKH, 3 = DUST, 4 = URBANPOLU, 5 = URBANCLEAN\0");
         if(SDsetattr(local_output[0]->sdsid[AOT_M], "Model values\0", DFNT_CHAR, strlen(remarks), (void *)remarks)){
              sprintf(msg, "Unable to write 'Model values' as metadata to Aerosol Model SDS");
              modsmf(MODIS_E_LHDF_ERROR, msg, location);
              }   
         sprintf(remarks, "SDS actually contains chosen model residual values, scaled by 100000\0");
         if(SDsetattr(local_output[0]->sdsid[AOT_1], "Note\0", DFNT_CHAR, strlen(remarks), (void *)remarks)){
              sprintf(msg, "Unable to write 'Note' as metadata to AOT Band 1 SDS");
              modsmf(MODIS_E_LHDF_ERROR, msg, location);
              }   
         sprintf(remarks, "SDS actually contains angstrom exponent values, scaled by 1000\0");
         if(SDsetattr(local_output[0]->sdsid[AOT_8], "Note\0", DFNT_CHAR, strlen(remarks), (void *)remarks)){
              sprintf(msg, "Unable to write 'Note' as metadata to AOT Band 8 SDS");
              modsmf(MODIS_E_LHDF_ERROR, msg, location);
              }   
	 
	 }

     /* take care of global (core/archive) metadata */
     if /*(AOTR_flag == 0)*/(AOTR_flag != 1) {
          qavalues->highsolarzenith = highsolarzenith;
          process_metadata(local_process_bands, qavalues, local_output, local_input[RAD1_FILE], local_input[GEO_FILE], metadata, n_scans_corrected);
	  }

     /* Close all output files */
     close_HDF_interface(local_output[0]);
     if /*(AOTR_flag == 0)*/ /*(AOTR_flag != 1)*/ (AOTR_flag == 2) close_HDF_interface(local_output[1]);
  
     }  /*  if (day) */ 

   /* now POP the L1B inputpointers off of "metadata", so the orbit-constant part of the inputpointers is all that's left */
   if /*(AOTR_flag == 0)*/(AOTR_flag != 1) pop_inputpointers(metadata, local_input);

   /* Close all input files */
   for(i=0;i<ALL_L1B_FILES;i++) close_HDF_interface(local_input[i]);

   /* make non-local copies of the outputs... */
   for(i=0;i<2;i++)  {   /* for each output */
       structcpy((outputs[i][tp]), (local_output[i]) );
     }

   }  /* for (tp = 0; tp < n_timepoints; tp ++) */
  

/* free memory for local I/O structures... */
close_io_struct2(local_input, ALL_L1B_FILES); 
close_io_struct2(local_output, 2);   

free(fcoarse);

if /*(AOTR_flag == 0)*/(AOTR_flag != 1) free(qavalues);

if (AOTR_flag == 1) modsmf(MODIS_A_AOTR_END, " ", location);
else                modsmf(MODIS_A_AOTU_END, " ", location);

return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int check_inputs(int dayflag, int AOTR_flag, dims_struct **inputs, int local_process_bands[])
{
int i, ret = 0;
char rbdt[30] = "default\0";
char msg[300] = "\0";
char location[50]="atmcor.c, check_inputs";
extern int AT_SCF;

for(i=0;i<ALL_L1B_FILES;i++)  {   /* for each L1B input */
      if ( strcmp(RANGEBEGINNINGDATETIMEDEFAULT, inputs[i]->xxxxx->rbdt) ) strcpy(rbdt, inputs[i]->xxxxx->rbdt);
       }

if ( !strcmp(rbdt, "default\0")) {
   modsmf(MODIS_E_FUNCTION_ERROR, "Error in input file staging", location);
   return(-1);
    }

if (AT_SCF == 1) {   /* at the SCF -- ONLY -- we can get away with skipping the 500m inputs and just processing 1km inputs */ 
   if (( !strcmp(inputs[RAD1_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) ) || 
   /*    ( (dayflag == 1) &&  ( !strcmp(inputs[RAD500_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) )    )     || */
       ( !strcmp(inputs[GEO_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) )) {
      sprintf(msg, "No input granule containing a RANGEBEGINNINGDATETIME of %s "
                   "and either L1B data (MOD02) or geolocation information (MOD03) was staged.", rbdt);
      modsmf(MODIS_E_STAGE_MISMATCH, msg, location);
      modsmf(MODIS_E_STAGE_MISMATCH, "No granule with the above RANGEBEGINNINGDATETIME will be produced.", location);
      return(1);
       }
    }
else  {
   if (( !strcmp(inputs[RAD1_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) ) || 
       ( (dayflag == 1) &&  ( !strcmp(inputs[RAD500_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) )    )     || 
       ( !strcmp(inputs[GEO_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) )) {
      sprintf(msg, "No input granule containing a RANGEBEGINNINGDATETIME of %s "
                   "and either L1B data (MOD02) or geolocation information (MOD03) was staged.", rbdt);
      modsmf(MODIS_E_STAGE_MISMATCH, msg, location);
      modsmf(MODIS_E_STAGE_MISMATCH, "No granule with the above RANGEBEGINNINGDATETIME will be produced.", location);
      return(1);
       }
  }

    
if ( !strcmp(inputs[RAD500_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) ) {
   for(i=0;i<7;i++)local_process_bands[BAND1_500M+i] = 0; 
   n_bands_res[1] = 0;
   sprintf(msg, "No input 500m L1B granule containing a RANGEBEGINNINGDATETIME of %s was staged. "
                "No 500m reflectance bands with this start time will be processed", rbdt);
   modsmf(MODIS_E_STAGE_MISMATCH, msg, location);
   }
       
if ( !strcmp(inputs[RAD250_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) ) {
   local_process_bands[BAND1_250M] = 0; 
   local_process_bands[BAND2_250M] = 0; 
   n_bands_res[0] = 0;
   sprintf(msg, "No input 250m L1B granule containing a RANGEBEGINNINGDATETIME of %s was staged. "
                "No 250m reflectance bands with this start time will be processed", rbdt);
   modsmf(MODIS_E_STAGE_MISMATCH, msg, location);
   }
       
if ( !strcmp(inputs[CLD_FILE]->xxxxx->rbdt, RANGEBEGINNINGDATETIMEDEFAULT) ) {
   sprintf(msg, "MOD35 cloud mask missing.  Processing will continue using the internal cloud mask for granule %s", rbdt);
   modsmf(MODIS_E_STAGE_MISMATCH, msg, location);
   }
/*printf("%s\n", rbdt);*/

return(ret);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int get_a_scan(int AOTR_flag, dims_struct **local_input, dims_struct **local_output, int *local_process_bands, int scan_number)
/*
!C****************************************************************************

!Routine: get_a_scan()

!Description: Routine which reads one scan's worth of data from all inputs.

!Input Parameters:
  int AOTR_flag               to generate AOT (=1) or to use AOT in atm correction (=0)
  dims_struct **input         the input
  
!Input/Output Parameters:
  dims_struct **outputs       in the second pass (AOT=0), we need to read AOT from the OUTPUTS. 
  
!Output Parameters:
  none

!Returns:
  0 for success
  nonzero, bad read from inputs.
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END**************************************************************************/
{
int i, which;
long k, offset, base_offset, offset_incr;  /* 13-APR-06 */
int total_n_pixels, dex;
int32 ret = 0;
int32 start3[3], dims3[3];
int32 start2[2], dims2[2];
/*extern output_type_t output_type[ALLBANDS];  GLOBAL */
/* new, 31-MAR-06 */
extern float tgo_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float roatm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float ttatmg_array[16][NBSPOTS_1KM*NBSCANS_1KM];
extern float satm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
int16 local_data[NBSPOTS_1KM*NBSCANS_1KM]; 
int read_parameter(float parameter[16][NBSPOTS_1KM*NBSCANS_1KM], int n_pixels, long base_offset, long offset_incr, 
                    dims_struct *local_output, int index, int32 *start, int32 *dims);

total_n_pixels = NBSPOTS_1KM*NBSCANS_1KM;
offset_incr = (long)((local_input[RAD1_FILE]->nblines /*- NBSCANS_1KM*/)*NBSPOTS_1KM*2);
/*printf("read nblines = %d\n", local_input[RAD1_FILE]->nblines);*/

     for(i=0;i<BANDPROCESS;i++) {
/*if (i==BAND3_500M)printf("process band = %d\n", local_process_bands[i]);*/
         if (local_process_bands[i] != 1) continue;
         if (i < BAND1_500M) {
	       if (AOTR_flag!=2)continue;  /* 08-FEB-05 */
               which = RAD250_FILE;
               start3[0] = local_input[which]->sds_offset[i];
               dims3[0] = 1;
	       start3[1] = scan_number*NBSCANS_250M;
	       dims3[1] = NBSCANS_250M;
	       start3[2] = 0;
	       dims3[2] = local_input[which]->nbcols;
	  	       }
         else if (i < BAND1_1KM) {
               which = RAD500_FILE;
               start3[0] = local_input[which]->sds_offset[i];
               dims3[0] = 1;
	       start3[1] = scan_number*NBSCANS_500M;
	       dims3[1] = NBSCANS_500M;
	       start3[2] = 0;
	       dims3[2] = local_input[which]->nbcols;
	       }
         else {
               which = RAD1_FILE;
               start3[0] = local_input[which]->sds_offset[i];
               dims3[0] = 1;
	       start3[1] = scan_number*NBSCANS_1KM;
	       dims3[1] = NBSCANS_1KM;
	       start3[2] = 0;
	       dims3[2] = local_input[which]->nbcols;
               }
         ret |= SDreaddata(local_input[which]->sdsid[i], start3, NULL, dims3, (VOID *)local_input[which]->data[i]);
/*if (AOTR_flag==0)printf("ret = %d, %d: band %d, %p\n", ret, which, i, local_input[which]->data[i]);*/
        }
	  
     which = GEO_FILE;
     for(i=0;i<local_input[which]->n_sds;i++) {
	  start2[0] = scan_number*NBSCANS_1KM;
	  dims2[0] = NBSCANS_1KM;
	  start2[1] = 0;
	  dims2[1] = local_input[which]->nbcols;
          ret |= SDreaddata(local_input[which]->sdsid[i], start2, NULL, dims2, (VOID *)local_input[which]->data[i]);
	  }
	  
     which = CLD_FILE;
     for(i=0;i<local_input[which]->n_sds;i++) {
          start3[0] = local_input[which]->sds_offset[i];
          dims3[0] = 1;
	  start3[1] = scan_number*NBSCANS_1KM;
	  dims3[1] = NBSCANS_1KM;
	  start3[2] = 0;
	  dims3[2] = local_input[which]->nbcols;
          ret |= SDreaddata(local_input[which]->sdsid[i], start3, NULL, dims3, (VOID *)local_input[which]->data[i]);
          }
	 
     if /*(AOTR_flag == 0)*/(AOTR_flag != 1) {
        for (i=AOT_1;i<SURFP;i++) 
             ret |= SDreaddata(local_output[0]->sdsid[i], start2, NULL, dims2, (VOID *)local_output[0]->data[i]);
        ret |= SDreaddata(local_output[0]->sdsid[AOTQA], start2, NULL, dims2, (VOID *)local_output[0]->data[AOTQA]);
        ret |= SDreaddata(local_output[0]->sdsid[AOTCM], start2, NULL, dims2, (VOID *)local_output[0]->data[AOTCM]);
 
        /* 31-MAR-06: Read in all the transmission, path radiance, spherical albedo data -- AND tgo_array data */
#ifdef TOTEMP
        for(i=0;i<TEMPS;i++) {   /* 13-APR-06 */
	    fseek(local_output[0]->temp_fd[i], 0L, SEEK_SET);
	    }
	base_offset = start2[0]*NBSPOTS_1KM*2;
#endif

        dex = TRBAND1;
#ifdef TOTEMP
        dex = TRANS;
#endif
        read_parameter(ttatmg_array, total_n_pixels, base_offset, offset_incr, local_output[0], dex, start2, dims2);
      
        dex = PRBAND1;
#ifdef TOTEMP
        dex = PATHR;
#endif
        read_parameter(roatm_array, total_n_pixels, base_offset, offset_incr, local_output[0], dex, start2, dims2);

        dex = SABAND1;
#ifdef TOTEMP
        dex = SPHER;
#endif
        read_parameter(satm_array, total_n_pixels, base_offset, offset_incr, local_output[0], dex, start2, dims2);

        dex = TGBAND1;
#ifdef TOTEMP
        dex = GASTR;
#endif
        read_parameter(tgo_array, total_n_pixels, base_offset, offset_incr, local_output[0], dex, start2, dims2);

	 }
return(ret);	  
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int read_parameter(float parameter[16][NBSPOTS_1KM*NBSCANS_1KM], int n_pixels, long base_offset, long offset_incr, 
                    dims_struct *local_output, int index, int32 *start, int32 *dims)
/*
!C****************************************************************************

!Routine: read_parameter()

!Description: Routine which reads the TR/PR/SA/GT parameters from outputs.

!Input Parameters:
  float **parameter           what is being read (dims 16 by n_pixels)
  int n_pixels
  
!Input/Output Parameters:
  dims_struct *local_output   is updated

!Output Parameters:
  none

!Returns:
  0 success
  1 problem
  
!Revision History:
  Revision 1.0  26-APR-2006
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
 
!END**************************************************************************/
{
long offset;
float *pntr;
PGSt_IO_Gen_FileHandle *fd;
int16 *local_data, *ipntr, value;
int i, ret;
long k;

#ifdef TOTEMP
      fd = local_output->temp_fd[index];
#endif

      local_data = (int16 *)malloc( NBSPOTS_1KM*NBSCANS_1KM*sizeof(int16));  
      offset = base_offset;	

      for(i=0;i<16;i++) {

#ifdef TOTEMP
	 if (offset > 0L) fseek(fd, offset, SEEK_SET);
	 ret = fread(local_data, 2, n_pixels, fd);
         if (ret == n_pixels) ret = 0;
	 offset += offset_incr;
#else
         ret = (int)SDreaddata(local_output->sdsid[index+i], start, NULL, dims, (VOID *)local_data);
#endif

         
         pntr = parameter[i];
         ipntr = local_data;
         for(k=0L;k<n_pixels;k++) {
            value = *ipntr++;
            *pntr++ = (float)value*0.0001F;
/*if ((start[0] == MYSCAN*10)&&(k == MYINDEX)&&(i==0)) 
          printf("read BAND 1** %f %d \n", (float)value*0.0001F, value);*/
              }

          }

      free(local_data);

return(ret);

}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int write_a_scan(int AOTR_flag, dims_struct **local_input, dims_struct **local_output, int *local_process_bands, int scan_number)
/*
!C****************************************************************************

!Routine: write_a_scan()

!Description: Routine which writes one scan's worth of data to all outputs.

!Input Parameters:
  int AOTR_flag               to generate AOT (=1) or to use AOT in atm correction (=0)
  dims_struct **input         the input
  
!Input/Output Parameters:
  dims_struct **outputs       
  
!Output Parameters:
  none

!Returns:
  none
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END**************************************************************************/
{
int i, j, which, factor, ret;
long k, offset, base_offset, offset_incr;  /* 13-APR-06 */
int total_n_pixels;
int32 start2[2], dims2[2];
int32 ostart[2], odims[2];
int32 qstart2[2], qdims2[2];
int32 nblines, nbcols;
/*extern output_type_t output_type[ALLBANDS];  GLOBAL */
uint16 *asdf;
int16 local_data[NBSPOTS_1KM*NBSCANS_1KM];
int make_full, make_coarse;
int n_scans, n_linesperscan, nblines_1km, ncols_1km;
char source[356];
char lgid[40];
uint32 *xxxxx;
void make_coarse_qa_and_cm(dims_struct *local_input, int nlines_fine, int nbcols_fine, 
                           int factor, int nlines_coarse, int nbcols_coarse, dims_struct *local_output);
/* new, 26-APR-06 */
int dex;
int write_parameter(float parameter[16][NBSPOTS_1KM*NBSCANS_1KM], int n_pixels, long base_offset, long offset_incr, 
                    dims_struct *local_output, int index, int32 *start, int32 *dims);

/* new, 31-MAR-06 */
extern float tgo_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float roatm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float ttatmg_array[16][NBSPOTS_1KM*NBSCANS_1KM];
extern float satm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 

if(NBSCANS_1KM % SREFL_COARSESIZE == 0) nblines = NBSCANS_1KM/SREFL_COARSESIZE;
else nblines=((int32)(NBSCANS_1KM/SREFL_COARSESIZE))+1;
nbcols = ((int32)(NBSPOTS_1KM/SREFL_COARSESIZE)) +1;

nblines_1km = local_input[RAD1_FILE]->nblines;
/*printf("write nblines = %d\n", local_input[RAD1_FILE]->nblines);*/

ostart[1] = 0;
odims[0] = nblines;
odims[1] = nbcols;

make_full = make_coarse = 0;
total_n_pixels = NBSPOTS_1KM*NBSCANS_1KM;

if /*(AOTR_flag == 0)*/(AOTR_flag != 1) {
     for(i=0;i<BANDPROCESS;i++) {

         if (local_output[0]->sdsid[i] != -1) make_full = 1;
 	 if ((commands.coarse_product == 1) && 
             (local_output[1]->sdsid[i] != -1) &&   /* 15-FEB-05 */
	     (AOTR_flag == 2) ) make_coarse = 1;
         if((make_full == 0)&&(make_coarse == 0)) continue;


         if (local_process_bands[i] != 1) continue;
         if (i < BAND1_500M) {
	       if (AOTR_flag!=2)continue;  /* 08-FEB-05 */
               which = RAD250_FILE;
	       start2[0] = scan_number*NBSCANS_250M;
	       dims2[0] = NBSCANS_250M;
	       start2[1] = 0;
	       dims2[1] = local_input[which]->nbcols;
	  	       }
         else if (i < BAND1_1KM) {
               which = RAD500_FILE;
	       start2[0] = scan_number*NBSCANS_500M;
	       dims2[0] = NBSCANS_500M;
	       start2[1] = 0;
	       dims2[1] = local_input[which]->nbcols;
	       }
         else {
               which = RAD1_FILE;
	       start2[0] = scan_number*NBSCANS_1KM;
	       dims2[0] = NBSCANS_1KM;
	       start2[1] = 0;
	       dims2[1] = local_input[which]->nbcols;
               }
         if ((make_full) && ((output_type[i].FC == FCBOTH)||(output_type[i].FC == FINE_ONLY))) {
	       /*printf("%d %d %d %p\n", i, dims2[0]*dims2[1], local_output[0]->sdsid[i], local_output[0]->data[i]);*/
               SDwritedata(local_output[0]->sdsid[i], start2, NULL, dims2, (VOID *)local_output[0]->data[i]);
	       

		  }
         /* make into coarse rez... */
	 if ((which == RAD1_FILE) && (make_coarse)) {
            if ((output_type[i].FC == COARSE_ONLY)||(output_type[i].FC == FCBOTH)) {
	        if (local_output[0]->type[i] == DFNT_INT16)
	            coarsen(local_output[0]->data[i], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[i]);
	        else if (local_output[0]->type[i] == DFNT_UINT16)
	            ucoarsen(local_output[0]->data[i], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[i]);

                if (i==BAND8) /* corrected band8 data is written TO THE INPUTS */
		    coarsen(local_input[RAD1_FILE]->data[i], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[i]);

	        ostart[0] = scan_number*nblines;
                SDwritedata(local_output[1]->sdsid[i], ostart, NULL, odims, (VOID *)local_output[1]->data[i]);
	        }
	      } 
        }

       for (i=BAND20ALB;i<TRBAND1;i++) {
	  if (make_coarse) {
            if ((output_type[i].FC == COARSE_ONLY)||(output_type[i].FC == FCBOTH)) {
	       if (i == BAND20ALB) {  /* SURFP and other ancillary data have already been "coarsened" */
	           if (local_output[0]->type[i] == DFNT_INT16)
	            coarsen(local_output[0]->data[i], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[i]);
	           else if (local_output[0]->type[i] == DFNT_UINT16)
	            ucoarsen(local_output[0]->data[i], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[i]);
		   }
	       if ((i == AOT_8) || (i == AOT_M)) { 
	           if (local_output[0]->type[i] == DFNT_INT16)
	            coarsen(local_output[0]->data[i], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[i]);
	           else if (local_output[0]->type[i] == DFNT_UINT16)
	            ucoarsen(local_output[0]->data[i], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[i]);
	           else if (local_output[0]->type[i] == DFNT_UINT8)
	            u8coarsen(local_output[0]->data[i], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[i]);
		   }
	       if (i == CRSQA)  
	            make_coarse_qa_and_cm(local_output[0], NBSCANS_1KM, local_input[which]->nbcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]);
		    
	       ostart[0] = scan_number*nblines;
	       /*printf("-> %d %d %p\n", i, local_output[1]->sdsid[i],  local_output[1]->data[i]);*/
               SDwritedata(local_output[1]->sdsid[i], ostart, NULL, odims, (VOID *)local_output[1]->data[i]);
	       /*printf("OK\n");*/
	      }
	    }
	  factor = 1;
	  if (i==QKMQA) {
	      factor = 4;
	     }
	  else if (i==HKMQA) {
	      factor = 2;
	     }
	     
	  qstart2[0] = scan_number*NBSCANS_1KM*factor;
	  qdims2[0] = NBSCANS_1KM*factor;
	  qstart2[1] = 0;
	  qdims2[1] = local_input[which]->nbcols*factor;
          if ((output_type[i].FC == FINE_ONLY)||(output_type[i].FC == FCBOTH)) {
	     /* 19-MAR-04:  YES! overwrite the first-pass stuff...we will need to write out AOTs during BOTH passes,
                            since routine newLUT_check_correction() sets the AOT in overcorrected pixels to zero and we want that written
		            out.  But remember -- now the AOTCM SDS will have 500m clouds (it didn't before).
	     if((i==AOT_1)||(i==AOT_3)||(i==AOT_8)||(i==AOTCM)||(i==AOTQA)||(i==WATERVAPOR)) continue;    / * do NOT overwrite first-pass stuff... */
	     
/*if (i==HKMQA) {
    xxxxx = (uint32 *)local_output[0]->data[i]; 
    printf("%d %d %d\n", scan_number, qdims2[1],    xxxxx[2710] );
    }*/
            SDwritedata(local_output[0]->sdsid[i], qstart2, NULL, qdims2, (VOID *)local_output[0]->data[i]);

	    }

         }


   }
	 	  	 
if (AOTR_flag == 1) {     
      which = RAD1_FILE;
      start2[0] = scan_number*NBSCANS_1KM;
      dims2[0] = NBSCANS_1KM;
      start2[1] = 0;
      dims2[1] = local_input[which]->nbcols;
      for (i=AOT_1;i<SURFP;i++) {
          SDwritedata(local_output[0]->sdsid[i], start2, NULL, dims2, (VOID *)local_output[0]->data[i]);
	     }
      SDwritedata(local_output[0]->sdsid[AOTCM], start2, NULL, dims2, (VOID *)local_output[0]->data[AOTCM]);
      SDwritedata(local_output[0]->sdsid[AOTQA], start2, NULL, dims2, (VOID *)local_output[0]->data[AOTQA]);
      SDwritedata(local_output[0]->sdsid[WATERVAPOR], start2, NULL, dims2, (VOID *)local_output[0]->data[WATERVAPOR]);
      
      /* 31-MAR-06: Write out all the transmission, path radiance, spherical albedo data -- AND tgo_array data */
#ifdef TOTEMP
      for(i=0;i<TEMPS;i++) {   /* 13-APR-06 */
	  fseek(local_output[0]->temp_fd[i], 0L, SEEK_SET);
	  }
      base_offset = start2[0]*NBSPOTS_1KM*2;
      offset_incr = (long)((nblines_1km /*- NBSCANS_1KM*/)*NBSPOTS_1KM*2);  /* minus one scan b/c fwrite advances the fp */
#endif
      
      dex = TRBAND1;
#ifdef TOTEMP
      dex = TRANS;
#endif
      write_parameter(ttatmg_array, total_n_pixels, base_offset, offset_incr, local_output[0], dex, start2, dims2);
      
      dex = PRBAND1;
#ifdef TOTEMP
      dex = PATHR;
#endif
      write_parameter(roatm_array, total_n_pixels, base_offset, offset_incr, local_output[0], dex, start2, dims2);

      dex = SABAND1;
#ifdef TOTEMP
      dex = SPHER;
#endif
      write_parameter(satm_array, total_n_pixels, base_offset, offset_incr, local_output[0], dex, start2, dims2);

      dex = TGBAND1;
#ifdef TOTEMP
      dex = GASTR;
#endif
      write_parameter(tgo_array, total_n_pixels, base_offset, offset_incr, local_output[0], dex, start2, dims2);

	}  
return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int write_parameter(float parameter[16][NBSPOTS_1KM*NBSCANS_1KM], int n_pixels, long base_offset, long offset_incr, 
                    dims_struct *local_output, int index, int32 *start, int32 *dims)
/*
!C****************************************************************************

!Routine: write_parameter()

!Description: Routine which writes the TR/PR/SA/GT parameters to outputs.

!Input Parameters:
  float **parameter           what is being written (dims 16 by n_pixels)
  int n_pixels
  
!Input/Output Parameters:
  dims_struct *local_output   is updated

!Output Parameters:
  none

!Returns:
  0 success
  1 problem
  
!Revision History:
  Revision 1.0  26-APR-2006
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
 
!END**************************************************************************/
{
long offset;
float value, *pntr;
PGSt_IO_Gen_FileHandle *fd;
int16 *local_data, *ipntr;
int i, ret;
long k;

#ifdef TOTEMP
      fd = local_output->temp_fd[index];
#endif

      local_data = (int16 *)malloc( NBSPOTS_1KM*NBSCANS_1KM*sizeof(int16));  
      offset = base_offset;	
      for(i=0;i<16;i++) {

         /*for(k=0L;k<n_pixels;k++) local_data[k] = (int16)(parameter[i][k]*10000.0F);*/
         
         pntr = parameter[i];
         ipntr = local_data;
         for(k=0L;k<n_pixels;k++) {
            value = *pntr++;
            *ipntr++ = (int16)(value*10000.0F);
/*if ((start[0] == MYSCAN*10)&&(k == MYINDEX)&&(i==0)) 
          printf("write BAND 1** %d %f \n", (int16)(value*10000.0F), value);*/
              }
         

#ifdef TOTEMP
	 if (offset > 0L) fseek(fd, offset, SEEK_SET);
	 ret = fwrite(local_data, 2, n_pixels, fd);
         if (ret == n_pixels) ret = 0;
	 offset += offset_incr;
#else
         ret = (int)SDwritedata(local_output->sdsid[index+i], start, NULL, dims, (VOID *)local_data);
#endif
          }

      free(local_data);

return(ret);

}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int get_scan_memory(int AOTR_flag, dims_struct **local_input, dims_struct **local_output, int total_1km_pixels, int *local_process_bands)
/*
!C****************************************************************************

!Routine: get_scan_memory()

!Description: Routine which gets memory for one scan's worth of data.

!Input Parameters:
  int AOTR_flag               to generate AOT (=1) or to use AOT in atm correction (=0)
  dims_struct **input         the input
  
!Input/Output Parameters:
  dims_struct **outputs       
  
!Output Parameters:
  none

!Returns:
  none
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
     Calls routine get_memory(), which has its own error messages.

!END**************************************************************************/
{
int i, which, total_pixels, ret;
/*extern output_type_t output_type[ALLBANDS];  THIS IS GLOBAL */
extern int n_bands_res[3]; /* 250m, 500m, 1km   THIS IS GLOBAL. */

/*printf("Start, get_scan_memory, AOTR_flag = %d, stateqa = %p\n", AOTR_flag, local_output[0]->data[STATE]);*/

     for(i=0;i<BANDPROCESS;i++) {

         if (local_process_bands[i] != 1) continue;
         if (i < BAND1_500M) {
               which = RAD250_FILE;
               total_pixels = total_1km_pixels*16;
	       }
         else if (i < BAND1_1KM) {
               which = RAD500_FILE;
               total_pixels = total_1km_pixels*4;
	       }
         else {
               which = RAD1_FILE;
               total_pixels = total_1km_pixels;
               }
         get_memory(&(local_input[which]->data[i]), local_input[which]->type[i], total_pixels);
	 if ((i==BAND18)||(i==BAND19))
             get_memory(&(local_output[0]->data[i]), DFNT_FLOAT, total_pixels);
	 else
             get_memory(&(local_output[0]->data[i]), local_output[0]->type[i], total_pixels);
	 /*if (which==RAD1_FILE)printf("%d in %d out %d\n", i, local_input[which]->type[i], local_output[0]->type[i]);*/
        }
	  
     total_pixels = total_1km_pixels;
     which = GEO_FILE;
     for(i=0;i<local_input[which]->n_sds;i++) 
          get_memory(&(local_input[which]->data[i]), local_input[which]->type[i], total_pixels);
	  
     which = CLD_FILE;
     for(i=0;i<local_input[which]->n_sds;i++) 
          get_memory(&(local_input[which]->data[i]), local_input[which]->type[i], total_pixels);
   
     if (AOTR_flag == 1) {
        for (i=AOT_1;i<SURFP;i++) 
             get_memory(&(local_output[0]->data[i]), local_output[0]->type[i], total_pixels);

        get_memory(&(local_output[0]->data[AOTCM]), local_output[0]->type[AOTCM], total_pixels);
        get_memory(&(local_output[0]->data[AOTQA]), local_output[0]->type[AOTQA], total_pixels);
        get_memory(&(local_output[0]->data[HKMQA]), output_type[HKMQA].type, 4*total_pixels);  /* we need 500m QA! */
        /*printf("%p %d\n",local_output[0]->data[HKMQA], local_output[0]->type[HKMQA]);*/

	/* Memory for bands 18 and 19 must be available during AOTR, even though bands 18 and 19 will NOT be written anywhere */
        if (local_output[0]->data[BAND18] == NULL) get_memory(&(local_output[0]->data[BAND18]), DFNT_FLOAT, total_pixels);
        if (local_output[0]->data[BAND19] == NULL) get_memory(&(local_output[0]->data[BAND19]), DFNT_FLOAT, total_pixels);
        if (local_output[0]->data[WATERVAPOR] == NULL) get_memory(&(local_output[0]->data[WATERVAPOR]), local_output[0]->type[WATERVAPOR], total_pixels);

	/* And we need memory for band 20 albedo. */
        if (local_output[0]->data[BAND20ALB] == NULL) get_memory(&(local_output[0]->data[BAND20ALB]), DFNT_INT16, total_pixels);

	/* And we need memory for State QA (20-DEC-05). */
        get_memory(&(local_output[0]->data[STATE]), DFNT_UINT16, total_pixels);
	
	 }
     else {
        for (i=BAND20ALB;i<TRBAND1;i++) {
           if ((i==CRSQA)||(i==CRSCM)||(i==WATERVAPOR))continue;
           if (i==QKMQA) {
	       if (n_bands_res[0] > 0) ret = get_memory(&(local_output[0]->data[i]), local_output[0]->type[i], 16*total_pixels);
	       }
           else if (i==HKMQA) {
	       if (n_bands_res[1] > 0) ret = get_memory(&(local_output[0]->data[i]), local_output[0]->type[i], 4*total_pixels);
	       }
           else ret = get_memory(&(local_output[0]->data[i]), local_output[0]->type[i], total_pixels);
	   
	   	
             }
	  }
/*printf("Get Memory: Pass: %d,  %p - QKM; %p - HKM; %p - 1KM \n", AOTR_flag, local_output[0]->data[QKMQA], local_output[0]->data[HKMQA], local_output[0]->data[OKMQA]);
 */
     /* this is for the coarse file */
     if /*(AOTR_flag == 0)*/ /*(AOTR_flag != 1)*/ (AOTR_flag == 2) {
       for (i=BAND1_1KM;i<BAND8;i++) { 
           if (local_process_bands[i] != 1) continue;
           get_memory(&(local_output[1]->data[i]), local_output[1]->type[i], local_output[1]->nbcols*2);
/* printf("%d: %d %d %d %p\n", i, output_type[i].FC, local_output[1]->type[i], local_output[1]->sdsid[i], local_output[1]->data[i]);*/
        }
 
       for (i=BAND8;i<BANDPROCESS;i++) {
          if ((local_process_bands[i] == 1)    &&    /* local_process_bands is valid only up to BANDPROCESS */
             ((output_type[i].FC == COARSE_ONLY)||(output_type[i].FC == FCBOTH))) {
             get_memory(&(local_output[1]->data[i]), local_output[1]->type[i], local_output[1]->nbcols*2);
	     }
         }
       for (i=BAND20ALB;i<TRBAND1;i++) {
          if ((output_type[i].FC == COARSE_ONLY)||(output_type[i].FC == FCBOTH)) {
            get_memory(&(local_output[1]->data[i]), local_output[1]->type[i], local_output[1]->nbcols*2);
/* printf("%d: %d %d %d %p\n", (i==OZONE), output_type[i].FC, local_output[1]->type[i], local_output[1]->sdsid[i], local_output[1]->data[i]);*/
             }
         }
     }
/*printf("End, get_scan_memory, AOTR_flag = %d, stateqa = %p\n", AOTR_flag, local_output[0]->data[STATE]);*/
return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int free_scan_memory(int AOTR_flag, dims_struct **local_input, dims_struct **local_output, int *local_process_bands)
/*
!C****************************************************************************

!Routine: free_scan_memory()

!Description: Routine which frees memory for one scan's worth of data.

!Input Parameters:
  int AOTR_flag               to generate AOT (=1) or to use AOT in atm correction (=0)
  dims_struct **input         the input
  
!Input/Output Parameters:
  dims_struct **outputs       
  
!Output Parameters:
  none

!Returns:
  none
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes:  

    03-DEC-04: very important to set pointers to NULL after freeing 

!END**************************************************************************/
{
int i, which;
/*extern output_type_t output_type[ALLBANDS]; GLOBAL */

/*printf("Start, free_scan_memory, AOTR_flag = %d, stateqa = %p\n", AOTR_flag, local_output[0]->data[STATE]);*/

     for(i=0;i<BANDPROCESS;i++) {

         if (local_process_bands[i] != 1) continue;
         if (i < BAND1_500M) {
               which = RAD250_FILE;
	       }
         else if (i < BAND1_1KM) {
               which = RAD500_FILE;
 	       }
         else {
               which = RAD1_FILE;
                }
         free(local_input[which]->data[i]);
	 local_input[which]->data[i] = NULL;
         if (local_output[0]->data[i] != NULL) {
	     free(local_output[0]->data[i]);
	     local_output[0]->data[i]=NULL;
	     }
        }
	  
     which = GEO_FILE;
     for(i=0;i<local_input[which]->n_sds;i++) {
           free(local_input[which]->data[i]);
           local_input[which]->data[i]=NULL;
	  }

     which = CLD_FILE;
     for(i=0;i<local_input[which]->n_sds;i++) {
           free(local_input[which]->data[i]);
           local_input[which]->data[i]=NULL;
	  }
   
     if (AOTR_flag == 1) {
        for (i=AOT_1;i<SURFP;i++) {
             free(local_output[0]->data[i]);
	     local_output[0]->data[i]=NULL;

	     }
        free(local_output[0]->data[AOTCM]);
	local_output[0]->data[AOTCM] = NULL;
        free(local_output[0]->data[AOTQA]);
	local_output[0]->data[AOTQA] = NULL;
        free(local_output[0]->data[HKMQA]);
	local_output[0]->data[HKMQA] = NULL;
	/* new, 20-DEC-05 */
        free(local_output[0]->data[STATE]);
	local_output[0]->data[STATE] = NULL;
	  }
     else {
        for (i=BAND20ALB;i<TRBAND1;i++) {
/*printf("free %d %p\n", i, local_output[0]->data[i]);*/
             if (local_output[0]->data[i] != NULL) free(local_output[0]->data[i]);		
             local_output[0]->data[i] = NULL;  
	    }

         }
     if /*(AOTR_flag == 0)*/ /*(AOTR_flag != 1)*/(AOTR_flag == 2) {
       for (i=BAND1_1KM;i<BAND8;i++) {
          if (local_process_bands[i] != 1) continue;
          if (local_output[1]->data[i] != NULL) free(local_output[1]->data[i]);
          local_output[1]->data[i] = NULL;		
         }
 
       for (i=BAND8;i<BANDPROCESS;i++) {
          if ((local_process_bands[i] == 1)    &&    /* local_process_bands is valid only up to  BANDPROCESS */
             ((output_type[i].FC == COARSE_ONLY)||(output_type[i].FC == FCBOTH))) {
             if (local_output[1]->data[i] != NULL) free(local_output[1]->data[i]);
             local_output[1]->data[i] = NULL;		
	     }
         }
       for (i=BAND20ALB;i<TRBAND1;i++) {
          if ((output_type[i].FC == COARSE_ONLY)||(output_type[i].FC == FCBOTH)) {
             if (local_output[1]->data[i] != NULL) free(local_output[1]->data[i]);
             local_output[1]->data[i] = NULL;		
	     }
         }
     }
/*printf("End, free_scan_memory, AOTR_flag = %d, stateqa = %p\n", AOTR_flag, local_output[0]->data[STATE]);*/
return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int atmcorrect(int AOTR_flag, dims_struct **local_input, dims_struct **local_output, int scan_number, int total_1km_pixels, 
               int *local_process_bands, float *fcoarse, int32 *highsolarzenith, qavals_t *qavalues)
/*
!C****************************************************************************

!Routine: atmcorrect()

!Description: The primary (main, principal, central, most important) atmospheric correction module.

!Input Parameters:
  int AOTR_flag               to generate AOT (=1) or to use AOT in atm correction (=0)
  dims_struct **input         the input
  
!Input/Output Parameters:
  dims_struct **outputs       
  
!Output Parameters:
  none

!Returns:
  none
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    Works on one scan at a time.  Calls get_a_scan() (above), processes a scan,
    then calls write_a_scan() (above).  Here's the rough sequence:
         get_a_scan()
	 scale_angle_data()         scales and sets up all geolocation data 
	 check_geolocation()      
         map_ancillary_data()       gets and scales all ancillary data
	 set_height_pressure()  
	 atmcor_extra()             corrects all the "extra" stuff, the thermal bands and bands 8 and 26
	 split_window_s_temp()      gets surface temperature from bands 31 and 32
	 band18_19_water_vapor()    gets H2O from bands 18 and 19
	 get_band20_albedo()     
	 map_variable_data()        calculates step1, step2, step3 atmospheric variables at 1km
	 half_km_copy()             copies and...  
	 half_km_interp()             ... interpolates the step_n variables into 500m and 250m
	 correct_with_new_LUTs()    applies these variables to radiance data
	 get_internal_cloud_mask()  
	 aerosol_retrieval()   
	 redo_fire_mask()           redoes the fire mask AND the cloud mask
	 count_quality()            sums up all QA data
	 make_coarse_resolution_output() 
	 write_a_scan()              writes both fine resolution and coarse resolution.
	
    All routines (except map_ancillary_data()) are in this file.
    
!END**************************************************************************/
{

/* This stuff should have been read in routine init_processing() (modis_srefl.c). */
extern int use_avg_z;
extern float32 Sra_tab[7][10];
extern float32 *sref[7];
extern float32 *ta_tab[7];

/*extern int32 locator500[], locator500_250[]; These are global */
int i, j, ii, index1km, index250m, index500m, indexcr, onekm_row, onekm_col, xrow, xcol;
float *lat, *lon, *olat, *olon;
float sz[NBSCANS_1KM*NBSPOTS_1KM];
float vz[NBSCANS_1KM*NBSPOTS_1KM];
float sa[NBSCANS_1KM*NBSPOTS_1KM];
float va[NBSCANS_1KM*NBSPOTS_1KM];
float fO3[NBSCANS_1KM*NBSPOTS_1KM];
float fwv[NBSCANS_1KM*NBSPOTS_1KM];
float fsp[NBSCANS_1KM*NBSPOTS_1KM];
float fslp[NBSCANS_1KM*NBSPOTS_1KM];  /* new, 12-JUN-06 */
float ft2m[NBSCANS_1KM*NBSPOTS_1KM];
float fmus[NBSCANS_1KM*NBSPOTS_1KM];
float fmuv[NBSCANS_1KM*NBSPOTS_1KM];
float ffsfv[NBSCANS_1KM*NBSPOTS_1KM];
float airmass[NBSCANS_1KM*NBSPOTS_1KM];
float airmassXwater[NBSCANS_1KM*NBSPOTS_1KM];
float hkmfmus[NBSCANS_500M*NBSPOTS_500M];
float qkmfmus[NBSCANS_250M*NBSPOTS_250M];
float fuw[NBSCANS_1KM*NBSPOTS_1KM];
float fvw[NBSCANS_1KM*NBSPOTS_1KM];
float NCEPwv[NBSCANS_1KM*NBSPOTS_1KM];
float rhog[NBSCANS_1KM*NBSPOTS_1KM];
float fsrftmp[NBSCANS_1KM*NBSPOTS_1KM];

float tmp500band[7][NBSCANS_500M*NBSPOTS_500M];
float tmp1kband[7][NBSCANS_1KM*NBSPOTS_1KM];
int16 band26[NBSCANS_1KM*NBSPOTS_1KM];

uint16 *band31, *band32;

int16 *tmpAOT1, *tmpAOT3;
uint16 *stateqa, *sqc250m, *aotcm;
uint32 *sqc1km, *sqc500m;
uint8 *ls, *aotqa, *oz;
int8 *cldmask;
int n_rec;

/* This stuff should have space allocated for it already, in routine init_processing() (modis_srefl.c), but needs to
   be calculated new for each scan. */
extern float **Rho_ra_term, **Rho_r_term, **Step1_term, **Step2_term, **Step3_term, **SRA_term, **btau;
extern float **hkmRho_ra_term, **hkmRho_r_term, **hkmStep1_term, **hkmStep2_term, **hkmStep3_term, **hkmSRA_term;
extern float **qkmRho_ra_term, **qkmRho_r_term, **qkmStep1_term, **qkmStep2_term, **qkmStep3_term, **qkmSRA_term;
extern int n_bands_res[3]; /* 250m, 500m, 1km */

float inv_fmus, inv_500m_fmus, inv_250m_fmus, inv_fmuv, inv_ftarget;
int16 *tmpAOT;
int nblines, nbcols, onekm_or_500m, bandindex;
int32 iline, isamp;
float32 rowfactor, colfactor;
float32 tau_a[7], n, aot550;
float32 H2O, AOT1, AOT3, O3, taup_r;
float32 tmpf, S_r, S_r0, ftemp, ftemphalf, tghalfH2O, uCO2, uO2, uCH4, uNO2, exp1, exp2;
int32 n_angles, newflag, atmvar_index;
float32 td_r,td_a,ratio_Dd;
float fTOA, rho_ra_minus_rho_r;
int16 *tmp_output;
int16 **tmp_outputs;
uint16 *tmp_input;
uint16 **tmp1KM_inputs, **tmp500M_inputs, **tmp250M_inputs;
uint16 *aot_one, *aot_three;
uint16 *tmp16_input;
uint8 *tmpAOTQA, *tmpu8_input;
int CIRRUS, SNOW;
extern int bad_geoloc;

#if defined IRIS4 || defined LINUX
#define local_chand local_chand_
#endif
float xrorayp, xtaur;

/*extern output_type_t output_type[ALLBANDS]; GLOBAL */
extern int do_climatology;
int local_clim_flag;

float xxx, pres, solzol, volzol, fee, vodka, zoneo;
float32 *offset, *scale;
float tgofill, roatmfill, ttatmgfill, satmfill, xroraypfill;

float split_window_s_temp(float fb31, float fb32, float fmuv);
int get_a_scan(int AOTR_flag, dims_struct **local_input, dims_struct **local_output, int *local_process_bands, int scan_number);
int write_a_scan(int AOTR_flag, dims_struct **local_input, dims_struct **local_output, int *local_process_bands, int scan_number);
int make_coarse_resolution_output(dims_struct **output, float *lat, float *lon, float *sz, float *vz, float *ffsfv, int nb1kmcols, int nblines, 
                                  int nbcols, float *fcoarse, float *fO3, float *fwv, float *fsp, float *fslp, float *ft2m, float *NCEPwv, 
				  float *fuw, float *fvw);
int scale_angle_data(dims_struct *input, float *sz, float *vz, float *sa, float *va, float *fmus, float *fmuv, float *ffsfv, float *airmass);
int map_variable_data(int AOTR_flag, float *fsp, float *fwv, float *fO3, float *airmass, float *sz, float *vz, float *fmus, float *fmuv, float *ffsfv, 
                      float **tau, float **Rho_ra_term, float **Rho_r_term, float **Step1_term, float **Step2_term, float **Step3_term, 
		      float **SRA_term);
void half_km_copy(float **c_consts, float **consts, int onekm_or_500m);
void half_km_interp(float **c_consts, float **consts, int onekm_or_500m);
void atmcor_extra(int scan_number, int band, dims_struct *tmp_input, dims_struct *tmp_output, float *sz, float *vz, float *lat, float *lon, 
                  float *fmus, float *fmuv, float *ffsfv, float *spres, float *sa, float *va, float *fuw, float *fvw, float *rhog,
		  int16 *band26);
void band18_19_water_vapor(int scan_number, float *band18, float *band19, float *fmus, float *fmuv, float *fwv, int total_1km_pixels);
void get_band20_albedo(uint16 *band20, uint16 *band21, uint16 *band31, uint16 *band32, int16 *band20albedo,
                       float *fmus, float *fmuv, float *fwv, uint16 *stateqa, int total_1km_pixels, int scan_number);
int check_geolocation(int scan_number, float *lat, float *lon, float *sz, float *vz, float *sa, float *va, int32 *highsolarzenith);
void get_internal_cloud_mask(int scan_number, int AOTR_flag, dims_struct *local_input, dims_struct *local_output, 
                             float tmp500band[7][NBSCANS_500M*NBSPOTS_500M], float tmp1kband[7][NBSCANS_1KM*NBSPOTS_1KM], float *ft2m, float *fmuv, 
			     float *spres, float *fsrftmp, int16 *band26, int use_intcm_as_MOD35);
void aerosol_retrieval(int scan_number, float tmp500band[7][NBSCANS_500M*NBSPOTS_500M], float tmp1kband[7][NBSCANS_1KM*NBSPOTS_1KM], 
                       dims_struct *output, dims_struct **input, float *sz, float *vz, float *lat, float *lon, float *fmus, float *fmuv, 
		       float *ffsfv, float *spres, float *sa, float *va, float *fsrftmp, float *ft2m, float *rhog, float *airmassXwater,
		       float *fwv, float *foz, uint8 *aotmodel);
void redo_fire_mask(int scan, dims_struct *local_output, float tmp1kband[7][NBSCANS_1KM*NBSPOTS_1KM], float tmp5band[7][NBSCANS_500M*NBSPOTS_500M], 
                    float *rhog, float *airtemp, float *surftemp, float *fmuv);
int write_AOT(dims_struct **local_input, dims_struct **local_output, int *local_process_bands, int scan_number);

int newLUT_check_correction(int scan_number, int total_1km_pixels, float *fsp, float *fwv, float *fO3, float *airmass, float *sz, float *vz, 
                     float *fmus, float *fmuv, float *ffsfv, uint16 **tmp1KM_inputs, uint16 **tmp500M_inputs, uint16 **tmp250M_inputs, 
		     uint32 *sqc1km, uint32 *sqc500m, uint16 *sqc250m, float32 *oneoffsets, float32 *onescales, float32 *fiveoffsets, 
		     float32 *fivescales, float32 *twooffsets, float32 *twoscales, int16 *data[ALLBANDS], uint8 *tmpAOTQA, uint16 *stateqa,
		     uint8 *aotmodel);
int correct_with_new_LUTs(int scan_number, int AOTR_flag, int rez, void *sqc, int total_1km_pixels, dims_struct *local_input, dims_struct *local_output, 
                          float tmp500band[7][NBSCANS_500M*NBSPOTS_500M], float tmp1kband[7][NBSCANS_1KM*NBSPOTS_1KM], float *sz, float *vz, float *fmus, 
			  float *ffsfv, int16 *aotone, int16 *aotthree, int16 *aoteight, float *fwv, float *fO3, float *fsp, uint16 *stateqa, 
			  uint8 *aotmodel);
int get_parameter_fill_values(int band, float *sz, float *vz, float *phi, float *wv, float *oz, float *pres, float *toa, 
                              float *tgofill, float *roatmfill, float *ttatmgfill, float *satmfill, float *xroraypfill);


if(NBSCANS_1KM % SREFL_COARSESIZE == 0) nblines = NBSCANS_1KM/SREFL_COARSESIZE;
else nblines=((int32)(NBSCANS_1KM/SREFL_COARSESIZE))+1;
nbcols = ((int32)(NBSPOTS_1KM/SREFL_COARSESIZE)) +1;

bad_geoloc = 0;

/* Init with user's wishes */
local_clim_flag = do_climatology;

inv_ftarget = 1.0F/(cosf(TERMINATORSZ*DEG2RAD));

/* get scans */
get_a_scan(AOTR_flag, local_input, local_output, local_process_bands, scan_number);

/* This is for my sanity -- feel free to delete... *  /
printf("%04d ", scan_number*10);
printf("\b\b\b\b\b");
fflush(stdout);
*/	

sqc250m = local_output[0]->data[QKMQA];
sqc1km  = local_output[0]->data[OKMQA];
sqc500m = local_output[0]->data[HKMQA];
stateqa = local_output[0]->data[STATE];
memset(stateqa,'\0',NBSCANS_1KM * NBSPOTS_1KM * sizeof(uint16));

if /*(AOTR_flag == 0)*/(AOTR_flag != 1) {
   tmpAOT1 = local_output[0]->data[AOT_1];
   tmpAOT3 = local_output[0]->data[AOT_3];

   aotqa   = local_output[0]->data[AOTQA];
   aotcm   = local_output[0]->data[AOTCM];

   if (n_bands_res[0] > 0){ /* sqc250m should be Non-Null if AOTR_flag != 1, and Null otherwise */
       memset(sqc250m,'\0',NBSCANS_250M * NBSPOTS_250M * sizeof(uint16));
       }
   if (n_bands_res[2] > 0){ /* same for sqc1km */      
       memset(sqc1km,'\0',NBSCANS_1KM * NBSPOTS_1KM * sizeof(uint32));
       }
}
else {
   aotqa   = local_output[0]->data[AOTQA];
   memset(aotqa,'\0', NBSCANS_1KM * NBSPOTS_1KM * sizeof(uint8));
   aotcm   = local_output[0]->data[AOTCM];
   memset(aotcm,'\0', NBSCANS_1KM * NBSPOTS_1KM * sizeof(uint16));

   memset(local_output[0]->data[AOT_1],'\0', NBSCANS_1KM * NBSPOTS_1KM * sizeof(uint16));
   memset(local_output[0]->data[AOT_3],'\0', NBSCANS_1KM * NBSPOTS_1KM * sizeof(uint16));
   }

if (n_bands_res[1] > 0){    /* sqc500m should be Non-Null regardless of the pass */
   memset(sqc500m,'\0',NBSCANS_500M * NBSPOTS_500M * sizeof(uint32));
   }

  /* Get land/sea mask into stateqa */
  ls = local_input[GEO_FILE]->data[7];
  for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) stateqa[i] |= (ls[i] << 3);	  
  
  /* Get all angles scaled and ready to use */
  scale_angle_data(local_input[GEO_FILE], sz, vz, sa, va, fmus, fmuv, ffsfv, airmass);

  lat = local_input[GEO_FILE]->data[0];
  lon = local_input[GEO_FILE]->data[1];
  olat = local_output[0]->data[LAT];
  olon = local_output[0]->data[LON];

  /*if ((scan_number < 110)&&(scan_number > 90))lat[863] = -190.0F;   Test of bad-geolocation detector */

  /* Check the geolocation: if it's no good, skip scan */ 
  bad_geoloc = check_geolocation(scan_number, lat, lon, sz, vz, sa, va, highsolarzenith);

  /* Map the ancillary data into scan space */
  map_ancillary_data(lat, lon, total_1km_pixels, fO3, fwv, fsp, ft2m, fuw, fvw, local_process_bands, sqc250m, sqc500m, sqc1km);

  /* For some strange reason, local_output[0]->data[OZONE] is nonNULL.  But that's good!  We need it to get O3 data into the CMG (23-APR-04). */
  oz = local_output[0]->data[OZONE];
  if (oz != NULL)  /* make sure first */
      for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) 
          oz[i] = (uint8)(fO3[i]*400.0F);
  

  /* Fix the surface pressure and make it into atms */
  if (!use_avg_z) set_height_pressure(lat, lon, local_input[GEO_FILE]->data[2], fsp, fslp);

  /* Correct the "extra" bands, the thermal bands and bands 8 and 26. */
  for (i=BAND8;i<BANDPROCESS;i++) {
     atmcor_extra(scan_number, i, local_input[RAD1_FILE], local_output[0], sz, vz, lat, lon, fmus, fmuv, ffsfv, fsp, sa, va, fuw, fvw, rhog, band26);
      }

  /* Get surface temperature */
  band31 = local_input[RAD1_FILE]->data[BAND31];
  band32 = local_input[RAD1_FILE]->data[BAND32];
  for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) {
      fsrftmp[i] = split_window_s_temp(((float)band31[i])/100.0F, ((float)band32[i])/100.0F, fmuv[i]);
  }

  /* Fix the water vapor. */
  /* but save the NCEP wv first: */
  for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) NCEPwv[i] = fwv[i];
  band18_19_water_vapor(scan_number, local_output[0]->data[BAND18], local_output[0]->data[BAND19], fmus, fmuv, fwv, total_1km_pixels);
  
  if (AOTR_flag != 1) {
   tmp1KM_inputs = (uint16 **)local_input[RAD1_FILE]->data;
   offset = (float32 *)local_input[RAD1_FILE]->refoffset;
   scale = (float32 *)local_input[RAD1_FILE]->refscale;

   /* 14-JUN-05: need to do this here */
   for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) {
      if (aotqa[i] == 19) {
	  tmpAOT1[i] = AOT1_FILL;  /* this should not be necessary if AOT is not being retrieved */
	  tmpAOT3[i] = AOT3_FILL;
	  
	  pres = fsp[i]*1013.0F;
	  solzol = sz[i];
	  volzol = vz[i];
	  fee = ffsfv[i];
	  vodka = fwv[i];
	  zoneo = fO3[i];
	  
	  for(j=0;j<16;j++) {
	      xxx = (float)(tmp1KM_inputs[BAND1_1KM+j][i]);
              xxx = (((xxx - offset[BAND1_1KM+j])*scale[BAND1_1KM+j])/fmus[i]);
	  
	      /* but this is necessary */
	      if (solzol > 0.0)
	         get_parameter_fill_values(j+1, &solzol, &volzol, &fee, &vodka, &zoneo, &pres, 
	                                   &xxx, &tgofill, &roatmfill, &ttatmgfill, &satmfill, &xroraypfill);
              else {
                 ttatmgfill = 1.0;
                 roatmfill = 0.0;
                 satmfill = 0.0;
                 tgofill = 1.0;
                 xroraypfill = 0.0;
	         }
	      ttatmg_array[j][i] = ttatmgfill;
	      roatm_array[j][i] = roatmfill;
	      satm_array[j][i] = satmfill;
	      tgo_array[j][i] = tgofill;
	      xrorayp_array[j][i] = xroraypfill;
	     }
          }
       }	  
   }


  /* get airmassXwater, which is now (31-MAR-04) used in aerosol_retrieval() */
  for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) airmassXwater[i] = airmass[i]*fwv[i];

  /* Get band20 albedo */
  get_band20_albedo(local_input[RAD1_FILE]->data[BAND20], local_input[RAD1_FILE]->data[BAND21], local_input[RAD1_FILE]->data[BAND31], 
                    local_input[RAD1_FILE]->data[BAND32], local_output[0]->data[BAND20ALB], fmus, fmuv, fwv, stateqa, total_1km_pixels, scan_number);

  /* Get MOD35 cloudmask into State QA */
  if (local_input[CLD_FILE]->n_sds > 0) {
      cldmask = local_input[CLD_FILE]->data[0];
      for (index1km=0;index1km<total_1km_pixels;index1km++) {   
          if(cldmask[index1km] & IISCLOUDSET) {
	      if(!(cldmask[index1km] & IISKMCLOUD)) 
	           stateqa[index1km] |= OISCLOUD1KM;
		   
              else if ((cldmask[index1km] & IISKMMIXED)==IISKMMIXEDA)
	           stateqa[index1km] |= OISMIXED1KM;
		   
              if(!(cldmask[index1km] & CMASKSNOWICE)) stateqa[index1km] |= OSNOWICE;
	   }
       }
   }
   /* Get MOD35 cloudmask into 250m qa */       
   if ( /*(AOTR_flag == 0)*/ (AOTR_flag != 1)&&(n_bands_res[0] > 0)&&(local_input[CLD_FILE]->n_sds > 0)) {
      cldmask = local_input[CLD_FILE]->data[0];
      index250m = 0;
      for (index1km=0;index1km<total_1km_pixels;index1km++) {   
          if(cldmask[index1km] & IISCLOUDSET) {
	      if(!(cldmask[index1km] & IISKMCLOUD)) 
	          for(i=0;i<16;i++){
	              sqc250m[locator250[index250m]]=OISCLOUD250M;
	              index250m++;
	              }
		   
              else if ((cldmask[index1km] & IISKMMIXED)==IISKMMIXEDA)
	          for(i=0;i<16;i++){
	              sqc250m[locator250[index250m]]=OISMIXED1KM;
	              index250m++;
	              }
	      else index250m += 16;
	   }
	   else index250m += 16;
       }

   }

if (AOTR_flag == 1) 
   for (index1km=0;index1km<total_1km_pixels;index1km++) 
       aotcm[index1km] |= QACLIMATOLOGY;               /* 25-APR-05: Set all these to climatology explicitly -- and unset as AOT is retrieved/interpolated */


/* Get internal CM, etc., into State QA if 2nd pass */
if (AOTR_flag != 1) {
    for (index1km=0;index1km<total_1km_pixels;index1km++) {
    
       onekm_row = index1km/NBSPOTS_1KM;
       onekm_col = index1km%NBSPOTS_1KM;
       
       if(aotcm[index1km]%2 != 0){
           if (local_input[CLD_FILE]->n_sds == -1) stateqa[index1km]|=OISCLOUD1KM; /* "MOD35" cloud mask */
           stateqa[index1km]|=QAINTCM;                                             /* internal cloud mask */	               
             }

      /* get CIRRUS and SNOW in there too */
      CIRRUS = (aotcm[index1km]&0x0c00);
      if(CIRRUS != 0)
           stateqa[index1km] |= (CIRRUS>>2);
             
      SNOW = (aotcm[index1km]&0x0010);
      if(SNOW != 0)
           stateqa[index1km] |= QAINTSNOW;  /* internal snow mask */
             

      /* ...and get AOT information into State QA */

      if (   (aotcm[index1km]&QACLIMATOLOGY) != 0) {  /* 25-APR-05 */
      
            stateqa[index1km] = stateqa[index1km] & ~QAHIGHAEROSOL;  /* Clear State QA AOT quality bits */

	       }
      else{       
/*            rho_ra_minus_rho_r = Rho_ra_term[BAND4][index1km] - Rho_r_term[BAND4][index1km]; */

/*  01-MAY-06: xrorayp_array[][] in the 2nd pass will not NECESSARILY have meaningful values.
 *  Do not do this:
 *
 *          rho_ra_minus_rho_r = roatm_array[BAND4][index1km] - xrorayp_array[BAND4][index1km]; 
 *  do this instead */

            xtaur=tauray[BAND4]*fsp[index1km];
            local_chand(&(ffsfv[index1km]),&(fmuv[index1km]),&(fmus[index1km]),&xtaur,&xrorayp);

            rho_ra_minus_rho_r = roatm_array[BAND4][index1km] - xrorayp; 

            if (rho_ra_minus_rho_r < RMR_AVEAEROSOL) stateqa[index1km] |= QALOWAEROSOL;
            else if (rho_ra_minus_rho_r < RMR_HIGHAEROSOL) stateqa[index1km] |= QAAVEAEROSOL;
            else stateqa[index1km] |= QAHIGHAEROSOL;
	    
            /* 07-MAR-03 */
            if (aotqa[index1km] == 3) {  /* saturation; if saturated, rho_ra_minus_rho_r will be small */
               stateqa[index1km] |= QAHIGHAEROSOL;
	      }
            }   /* if(aotqa[index1km] != 15) */ 
	    

        } /* for (index1km=0;index1km<total_1km_pixels;index1km++) */
    } /* if (AOTR_flag == 0) */
         

index500m=0;
for (index1km=0;index1km<total_1km_pixels;index1km++) {
  
    /* Put full-resolution lat/lon into output */
    if /*(AOTR_flag == 0)*/(AOTR_flag != 1) {
        olat[index1km] = lat[index1km];
        olon[index1km] = lon[index1km];
        }
	
    /* Get half-KM resolution fmus */
    if (n_bands_res[1] > 0) {   /* HKM */
       for (ii=0;ii<4;ii++) {
           hkmfmus[locator500[index500m]]=fmus[index1km];
	   index500m++;
          }
        }
   }

index250m=0;
if (n_bands_res[0] > 0) {   /* and QKM */
      for (index500m=0;index500m<total_1km_pixels*4;index500m++) {
          for (ii=0;ii<4;ii++) {
              qkmfmus[locator500_250[index250m]]=hkmfmus[index500m];
	      index250m++;
             }
          }
      }

/* Now do the correction of bands 1 through 7 at the different resolutions. */
if (n_bands_res[2] > 0)   /* 1km MUST come first */
   correct_with_new_LUTs(scan_number, AOTR_flag, 1, (void *)sqc1km, total_1km_pixels, local_input[RAD1_FILE], local_output[0], NULL, tmp1kband, 
                         sz, vz, fmus, ffsfv, local_output[0]->data[AOT_1], local_output[0]->data[AOT_3], local_output[0]->data[AOT_8], fwv, 
			 fO3, fsp, stateqa, local_output[0]->data[AOT_M]); 

if ((n_bands_res[1] > 0) && (AOTR_flag != 1))
   correct_with_new_LUTs(scan_number, AOTR_flag, 2, (void *)sqc500m, total_1km_pixels, local_input[RAD500_FILE], local_output[0], tmp500band, NULL,
                         sz, vz, fmus, ffsfv, local_output[0]->data[AOT_1], local_output[0]->data[AOT_3], local_output[0]->data[AOT_8], fwv, 
			 fO3, fsp, stateqa, local_output[0]->data[AOT_M]); 

if ((n_bands_res[0] > 0) && (AOTR_flag == 2))
   correct_with_new_LUTs(scan_number, AOTR_flag, 4, (void *)sqc250m, total_1km_pixels, local_input[RAD250_FILE], local_output[0], NULL, NULL,
                         sz, vz, fmus, ffsfv, local_output[0]->data[AOT_1], local_output[0]->data[AOT_3], local_output[0]->data[AOT_8], fwv, 
			 fO3, fsp, stateqa, local_output[0]->data[AOT_M]); 
			 

/*    if ((scan_number==8)&&(AOTR_flag != 1))  {
       tmp_input = local_input[RAD1_FILE]->data[BAND3_1KM];
       tmp_output = local_output[0]->data[BAND3_1KM];
       printf(" *** %d %d \n", tmp_input[(4*1354)+1154], tmp_output[(4*1354)+1154]);
       } */

if /*(AOTR_flag == 0)*  /(AOTR_flag != 1)*/ (0==1) {



     /* 18-MAR-04: check 1km atm correction with AOT: if it is bad, redo it */
     tmp1KM_inputs = (uint16 **)local_input[RAD1_FILE]->data;
     tmp500M_inputs = (uint16 **)local_input[RAD500_FILE]->data;
     tmp250M_inputs = (uint16 **)local_input[RAD250_FILE]->data;
     tmp_outputs = (int16 **)local_output[0]->data;
     tmpAOTQA = (uint8 *)local_output[0]->data[AOTQA];
     
     if (n_bands_res[1] > 0) {
     
        n_rec = newLUT_check_correction(scan_number, total_1km_pixels, fsp, fwv, fO3, airmass, sz, vz, fmus, fmuv, ffsfv, 
                              tmp1KM_inputs, tmp500M_inputs, tmp250M_inputs, sqc1km, sqc500m, sqc250m, 
			      local_input[RAD1_FILE]->refoffset, local_input[RAD1_FILE]->refscale,  
			      local_input[RAD500_FILE]->refoffset, local_input[RAD500_FILE]->refscale, 
			      local_input[RAD250_FILE]->refoffset, local_input[RAD250_FILE]->refscale, tmp_outputs, tmpAOTQA, stateqa,
			      local_output[0]->data[AOT_M]); 

              }  
     }

if (AOTR_flag == 1) {
        /* get internal cloud mask. */
        get_internal_cloud_mask(scan_number, AOTR_flag, local_input[RAD1_FILE], local_output[0], tmp500band, tmp1kband, ft2m, fmuv, fsp, 
	                        fsrftmp, band26, (local_input[CLD_FILE]->n_sds == -1));


       /* here we have to reset the trans, path rad, SA arrays New 31-MAR-06 * / 
       for(i=0;i<16;i++) {
         for(j=0;j<NBSCANS_1KM*NBSPOTS_1KM;j++) {
            ttatmg_array[i][j] = -1.0F;
            roatm_array[i][j] = -1.0F;
            satm_array[i][j] = -1.0F;
            }
         }
        I think we might actually need to hold on to these data values. 
	The aerosol retrieval algorithm resets these values where aerosols have been retreived.
	Where aerosols have NOT been retrieved, these values should be overwritten during
	interpolation.  BUT IF THEY AREN'T -- we need to hang onto the pre-AOTR values. */

        /* here/now, do aerosol retrieval */
        aerosol_retrieval(scan_number, tmp500band, tmp1kband, local_output[0], local_input, sz, vz, lat, lon, fmus, fmuv, ffsfv, 
	                  fsp, sa, va, fsrftmp, ft2m, rhog, airmassXwater, fwv, fO3, local_output[0]->data[AOT_M]);

    }
     
else {
        redo_fire_mask(scan_number, local_output[0], tmp1kband, tmp500band, rhog, ft2m, fsrftmp, fmuv);
	
	/* 04-FEB-05: here, need to put out AOT and AOTQA, AOTCM if AOTR_flag == 0 */
	if (AOTR_flag == 0) write_AOT(local_input, local_output, local_process_bands, scan_number);
	
        count_quality((int32 *)local_process_bands, local_output[0], qavalues, commands.process_sea, commands.ref_lamc);
    }
    
/* Put out all the coarse-resolution ozone, water vapor, etc. */
if (/*(AOTR_flag == 0)*/ /*(AOTR_flag != 1)*/ (AOTR_flag == 2)&&(commands.coarse_product == 1))
     make_coarse_resolution_output(local_output, lat, lon, sz, vz, ffsfv, local_input[GEO_FILE]->nbcols, nblines, nbcols, 
                                   fcoarse, fO3, fwv, fsp, fslp, ft2m, NCEPwv, fuw, fvw);


/* write scans */
if (AOTR_flag == 1) {
    tmp16_input = local_output[0]->data[WATERVAPOR];
    for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) 
       tmp16_input[i] = (uint16)(fwv[i]*100.0F);
       }


/* 15-JUN-05: set bit 13 of the State QA if pixel is adjacent to cloud */
if (AOTR_flag == 2) {
   for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) {
       if ((aotcm[i]&0x0200) != 0) {    /* adjacent */
            stateqa[i] |= 0x2000;
          }
       }
    }
    
write_a_scan(AOTR_flag, local_input, local_output, local_process_bands, scan_number);


if (bad_geoloc != 0) return(1);
else return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int get_value_(int *band, int *preslev, int *aotlev, int *index, float *result)
{
/* Completely experimental */
extern float32 rolutt[NBANDS][NPR][NAOT][8000];
extern float32 nbfic[NTS][NXX];
int i,j,k,l;

i = *band;
j = *preslev;
k = *aotlev;
l = *index;

i--;
j--;
k--;
l--;

/*   *result =  *( *(nbfic + j) + (j*2) + i)  ;*/


*result =  *( *(   *(   *(   rolutt + l) + (l*2)  + k)  + (k*2)   + j) + (j*2) + i)  ;


return(1);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int write_AOT(dims_struct **local_input, dims_struct **local_output, int *local_process_bands, int scan_number)
/*
!C****************************************************************************

!Routine: write_AOT()

!Description: Routine which writes out the new, updated AOT.

!Input Parameters:
  dims_struct **input         the input
  
!Input/Output Parameters:
  dims_struct **outputs       
  
!Output Parameters:
  none

!Returns:
  none
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END**************************************************************************/
{
int i, which;
int32 start2[2], dims2[2];
int32 nblines, nbcols;
/*extern output_type_t output_type[ALLBANDS];  GLOBAL */
	 	  	 
      which = RAD1_FILE;
      start2[0] = scan_number*NBSCANS_1KM;
      dims2[0] = NBSCANS_1KM;
      start2[1] = 0;
      dims2[1] = local_input[which]->nbcols;
      for (i=AOT_1;i<SURFP;i++) {
          SDwritedata(local_output[0]->sdsid[i], start2, NULL, dims2, (VOID *)local_output[0]->data[i]);
	     }
      SDwritedata(local_output[0]->sdsid[AOTCM], start2, NULL, dims2, (VOID *)local_output[0]->data[AOTCM]);
      SDwritedata(local_output[0]->sdsid[AOTQA], start2, NULL, dims2, (VOID *)local_output[0]->data[AOTQA]);
     
	  
return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int newLUT_check_correction(int scan_number, int total_1km_pixels, float *fsp, float *fwv, float *fO3, float *airmass, float *sz, float *vz, 
                     float *fmus, float *fmuv, float *ffsfv, uint16 **tmp1KM_inputs, uint16 **tmp500M_inputs, uint16 **tmp250M_inputs, 
		     uint32 *sqc1km, uint32 *sqc500m, uint16 *sqc250m, float32 *oneoffsets, float32 *onescales, float32 *fiveoffsets, 
		     float32 *fivescales, float32 *twooffsets, float32 *twoscales, int16 *data[ALLBANDS], uint8 *tmpAOTQA, uint16 *stateqa,
		     uint8 *aotmodel)
{
int ii, i, n, ib, n_recorrected, spots, onekm_row, onekm_col, onekm_index, rez, fhm_row, fhm_col, qkm_row, qkm_col;
int startband, endband, qkm_index;
float32 tmp_output;
uint32 qcvalue;
uint8 model;
int16 THRESHOLD = 10;
float32 spres, ts, tv, fsfv, uwv, uoz, uncorrected, corrected, invfmus, checkcor;
float aot, angexp;
int8 corrected_already[NBSPOTS_1KM*NBSCANS_1KM];  /* corrected already HERE, that is, already checked */
#if defined IRIS4 || defined LINUX
#define atmcorlamb2 atmcorlamb2_
#define atmcorocea2 atmcorocea2_
#endif
float tgo,roatm,ttatmg,satm,xrorayp;
extern float tgo_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float roatm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float ttatmg_array[16][NBSPOTS_1KM*NBSCANS_1KM];
extern float satm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
float newLUT_correction(float TOA, float tgo, float roatm, float ttatmg, float satm);
char err_msg[80];
int retval;
char location[100]="atmcor.c, newLUT_check_correction";

rez = 2;
 
startband = BAND1_500M;
endband = BAND1_1KM;
spots = NBSPOTS_500M;

for(ii=0;ii<total_1km_pixels;ii++) corrected_already[ii] = 0;

for(ii=0;ii<total_1km_pixels*rez*rez;ii++) {   /* for all 500m pixels */
    fhm_row = ii/spots;
    fhm_col = ii%spots;
    onekm_row = fhm_row/rez;
    onekm_col = fhm_col/rez;
    onekm_index = onekm_row*NBSPOTS_1KM + onekm_col;
    invfmus = 1.0F/fmus[onekm_index];
  
    qcvalue = sqc500m[ii];

    if ((qcvalue&ATMCORR500) != 0) { /* new, 05-MAY-05; check_correction only if the data has actually been corrected... */
    
       if (data[startband+2][ii] < THRESHOLD) {

          if (corrected_already[onekm_index] == 0) {   /* correct the 1km data */

             sqc1km[onekm_index] = (uint32)0;
       
             spres = fsp[onekm_index]*1013.0F;
             uwv = fwv[onekm_index];
             uoz = fO3[onekm_index];
             ts = sz[onekm_index];
             tv = vz[onekm_index];
             fsfv = ffsfv[onekm_index];
             aot = angexp = 0.000060F;        /* you can't give it an AOT of zero */
	     model = aotmodel[onekm_index];

/*if ((scan_number == MYSCAN)&&(onekm_index == MYINDEX)) 
   printf("newLUT_check_correction, %f %f %f %f %f %f %f %d\n", ts,tv,fsfv,spres,uoz,uwv, invfmus, stateqa[onekm_index]);*/
 
             for(i=BAND1_1KM;i<BAND8;i++) {   /* re-correct the 1km data with zero AOT */
       
                ib = (i-BAND1_1KM)+1;
                uncorrected = (((float32)tmp1KM_inputs[i][onekm_index] - oneoffsets[i])*onescales[i])*invfmus;
		
		retval = 0;	
		if (ACTUALLANDCHECK(stateqa[onekm_index])) {
		   switch (model) {
		     case(NOMODEL):
		     case(SMKL):
                        atmcorlamb2(&ts,&tv,&fsfv,&aot,&ib,&spres,tpres,
                           aot550nm,roluttSMKL,transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtSMKL,
                           tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,&uoz,&uwv,tauray,
                           ogtransa0,ogtransa1,ogtransb0,ogtransb1,ogtransc0,ogtransc1,
                           wvtransa,wvtransb,wvtransc,oztransa,     
     	                   &uncorrected,&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);
			break;
		     case(SMKH):
                        atmcorlamb2(&ts,&tv,&fsfv,&aot,&ib,&spres,tpres,
                           aot550nm,roluttSMKH,transtSMKH,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtSMKH,
                           tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,&uoz,&uwv,tauray,
                           ogtransa0,ogtransa1,ogtransb0,ogtransb1,ogtransc0,ogtransc1,
                           wvtransa,wvtransb,wvtransc,oztransa,     
     	                   &uncorrected,&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);
			break;
		     case(DSST):
                        atmcorlamb2(&ts,&tv,&fsfv,&aot,&ib,&spres,tpres,
                           aot550nm,roluttDUST,transtDUST,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtDUST,
                           tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,&uoz,&uwv,tauray,
                           ogtransa0,ogtransa1,ogtransb0,ogtransb1,ogtransc0,ogtransc1,
                           wvtransa,wvtransb,wvtransc,oztransa,     
     	                   &uncorrected,&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);
			break;
		     case(URBP):
                        atmcorlamb2(&ts,&tv,&fsfv,&aot,&ib,&spres,tpres,
                           aot550nm,roluttURBPOL,transtURBPOL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBPOL,
                           tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,&uoz,&uwv,tauray,
                           ogtransa0,ogtransa1,ogtransb0,ogtransb1,ogtransc0,ogtransc1,
                           wvtransa,wvtransb,wvtransc,oztransa,     
     	                   &uncorrected,&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);
			break;
		     case(URBC):
                        atmcorlamb2(&ts,&tv,&fsfv,&aot,&ib,&spres,tpres,
                           aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBCLN,
                           tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,&uoz,&uwv,tauray,
                           ogtransa0,ogtransa1,ogtransb0,ogtransb1,ogtransc0,ogtransc1,
                           wvtransa,wvtransb,wvtransc,oztransa,     
     	                   &uncorrected,&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);
			break;
	             default:
                        printf("Error: anomalous value for 'model' (%d): cannot continue \n", model);
                        exit(-2);
			break;
	           }

                  }
	      
	      else {
                atmcorocea2(&ts,&tv,&fsfv,&aot,&ib,&spres,tpres,
                        aot550nm,roluttURBCLN,
                        transt,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
                        sphalbtURBCLN,
                        tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                        &uoz,&uwv,tauray,
                        ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                        ogtransc0,ogtransc1,
                        wvtransa,wvtransb,wvtransc,oztransa,     
     	                &uncorrected,&corrected,&angexp,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
		}
	        if(retval != 0) {
                     sprintf(msg, "Error: message '%s' from routine atmcorlamb2: cannot continue \n", err_msg);
                     modsmf(MODIS_F_FUNCTION_ERROR, msg, location);
 		   }

/*checkcor = newLUT_correction(uncorrected, tgo, roatm, ttatmg, satm);		 
if ( fabs(checkcor - corrected) > 1e-3) {
printf("ERROR1\n");
exit(0);
   }*/

	         data[i][onekm_index] = (int16)(((float64)corrected*(float64)REFSCALE)+0.5F);
		     
 	         tgo_array[i-BAND1_1KM][onekm_index] = tgo;
 	         roatm_array[i-BAND1_1KM][onekm_index] = roatm;
 	         ttatmg_array[i-BAND1_1KM][onekm_index] = ttatmg;
 	         satm_array[i-BAND1_1KM][onekm_index] = satm;
	         xrorayp_array[i-BAND1_1KM][onekm_index] = xrorayp;	
                  }
	        corrected_already[onekm_index] = 1;
               } 
       
          /* Now apply the arrays to the 500m data... */
       
          sqc500m[ii] = (uint32)0;
          for(i=startband;i<endband;i++) {
              uncorrected = (((float32)tmp500M_inputs[i][ii] - fiveoffsets[i])*fivescales[i])*invfmus;	

              tgo = tgo_array[i-startband][onekm_index];
              roatm = roatm_array[i-startband][onekm_index];
              satm = satm_array[i-startband][onekm_index];
              ttatmg = ttatmg_array[i-startband][onekm_index];
              tmp_output = newLUT_correction(uncorrected, tgo, roatm, ttatmg, satm);

              data[i][ii] = (int16)(((float64)tmp_output*(float64)REFSCALE)+0.5F);
              }

          /* and to the 250m data... */		      
          if (n_bands_res[0] > 0) {
             for (qkm_row=(fhm_row*2);qkm_row<((fhm_row*2) + 2);qkm_row++) {
                for (qkm_col=(fhm_col*2);qkm_col<((fhm_col*2) + 2);qkm_col++) {
                   qkm_index = qkm_row*NBSPOTS_250M + qkm_col;
                   sqc250m[qkm_index] = (uint16)0;
		   
		   for(i=BAND1_250M;i<=BAND2_250M;i++) {
                      uncorrected = (((float32)tmp250M_inputs[i][qkm_index] - twooffsets[i])*twoscales[i])*invfmus;	

                      tgo = tgo_array[i-BAND1_250M][onekm_index];
                      roatm = roatm_array[i-BAND1_250M][onekm_index];
                      satm = satm_array[i-BAND1_250M][onekm_index];
                      ttatmg = ttatmg_array[i-BAND1_250M][onekm_index];		   
		      tmp_output = newLUT_correction(uncorrected, tgo, roatm, ttatmg, satm);
		   
                      data[i][qkm_index] = (int16)(((float64)tmp_output*(float64)REFSCALE)+0.5F);
                        }
                  }
               }
             }
	     
          if ((data[AOT_1][onekm_index] != 0) || (data[AOT_3][onekm_index] != 0) || (data[AOT_8][onekm_index] != 0)) {
             /* Zap the offending AOT values (if we haven't already) */
             data[AOT_1][onekm_index] = AOT1_FILL;
	     data[AOT_3][onekm_index] = AOT3_FILL;
	     data[AOT_8][onekm_index] = AOT8_FILL;
       
             /* and blank out the aerosol quantity bits (climatology) */
             data[STATE][onekm_index] = data[STATE][onekm_index] & ~QAHIGHAEROSOL;
	  
	     /* 25-APR-05: Set the climatology bit */
             data[AOTCM][onekm_index] |= QACLIMATOLOGY;

             /* and set the AOT QA to '18' */
	     /* Please note, for future reference: the highest value AOT QA can take as of now (20-JUL-04)
	        is 18: and 18 is what variable N_AOTQA_VALUES (in modis_srefl.h) must be set to if AOT QA
	        values of 18 are to get into the AOT QA in the IDS file.  N_AOTQA_VALUES must be set to
	        the number of unique AOT QA values at any given time. */
             tmpAOTQA[onekm_index] = 18;

             aotmodel[onekm_index] = 0;  /* 31-OCT-05: perhaps do this too */

	       }
             }
	 }	  
     }     

    
return(0);
}

float newLUT_correction(float TOA, float tgo, float roatm, float ttatmg, float satm)
{
float tmp_output;
tmp_output = TOA/tgo;
tmp_output = tmp_output - roatm;
tmp_output = tmp_output/ttatmg;
tmp_output = tmp_output/(1.+satm*tmp_output);
return(tmp_output);
}

/**************************************************************************************************************************
 **************************************************************************************************************************/
void aerosol_retrieval(int scan_number, float in500put[7][NBSCANS_500M*NBSPOTS_500M], float in1kput[7][NBSCANS_1KM*NBSPOTS_1KM], 
                       dims_struct *local_output, dims_struct **local_input, float *sz, float *vz, float *lat, float *lon, float *fmus, 
		       float *fmuv, float *ffsfv, float *spres, float *sa, float *va, float *fsrftmp, float *ft2m, float *rhog, float *airmassXwater,
		       float *fwv, float *foz, uint8 *aotmodel)
/*
!C****************************************************************************

!Routine: aerosol_retrieval()

!Description: Routine which retrieves aerosols.

!Input Parameters:
  int AOTR_flag               to generate AOT (=1) or to use AOT in atm correction (=0)
  dims_struct *local_input    the input
  
!Input/Output Parameters:
  dims_struct *local_output     
  
!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    Works on one scan at a time.   Here's a rough sequence of calls:
         aotr_rejection()                   figures out whether to retrieve aerosols at this pixel or not
	 get_criteria()                     figures if pixel meets a criteria for AOTR
	 subpixel_cloud_check()
	 get_ocean_data()
	 get_Angstrom_and_tau_values()
	 
    All routines are in this file.
    
    Updates the following arrays in structure local_output:
    

      local_output[0].data[AOT_1]      array of retreived aerosol values for band 1 (1km)
      local_output[0].data[AOT_3]      array of retreived aerosol values for band 3 (1km)
      local_output[0].data[AOT_8]      array of retreived aerosol values for band 8 (1km)
      local_output[0].data[AOTQA]      array of aerosol retrieval QA values (1km):

      The NAME of the SDS that corresponds to local_output[0].data[AOTQA] is "1km Atmospheric Optical Depth Band CM"

             Not a bitmapped pixel, but with one value per pixel:
	     
	                  value                   meaning
			    
			    0                     initial value.
			    1                     Not all of the 500m pixels that correspond to this
			                          1km pixel have data that reaches any criteria for
						  containing aerosols.
			    2                     Pixel is over water (shallow ocean, inland water,
			                          shorelines/coastlines  -- but NOT deep ocean).
			    3                     One or more of the retrieved aerosol values has
			                          saturated (and then all are set to a fill value)
			    4                     Pixel is cloudy or mixed or has large band26 value.
			    5                     Pixel had been flagged as water, but also had 
			                          positive NDVI.
			    6                     Pixel is flagged as water and tests clear
			    7                     Pixel is flagged as water and tests as turbid
                           (8                     snow filtered -> fill: not done here but in aot_filter)
			    9                     bad geolocation data or high solar zenith angle.
			   10                     snow/fire/glint.
			   11                     500m data is flagged as OISBADPIXEL -- no
			                          aerosol will be retrieved.
                          (12                     subpixel cloud: not done here but in aot_filter)
                           13                     anomalous aerosol retrieval (tau1 > tau3) (error)
                           14                     possible salt pan (preliminary, needs work)
                           15                     desert
			   16                     AOT retrieval rejection (via mask)
			   17                     Anomalous atmospheric correction in 500m cloud test
			   18                     AOT set to zero in routine newLUT_check_correction()
	                   19                     Adjacent to cloud
		   
		   
      local_output[0].data[AOTCM]      array of aerosol retrieval cloudmask values (1km).
      
      The NAME of the SDS that corresponds to local_output[0].data[AOTCM] is "1km Atmospheric Optical Depth Band QA"
      
             
!END**************************************************************************/
{
extern float **hkmRho_ra_term, **hkmRho_r_term, **hkmStep1_term, **hkmStep2_term, **hkmStep3_term, **hkmSRA_term;
extern float **Rho_ra_term, **Rho_r_term, **Step1_term, **Step2_term, **Step3_term, **SRA_term;
int i,j,total_1km_pixels, index500m, index1km, band;
int16 *tmpAOT, *tmpAOT1, *tmpAOT3, *tmpAOT8, *band20albedo;
uint8 *tmpAOTQA;
uint16 *tmpAOTCM, *state;
int16 *chn8, ch8;
float *chn7, ch7;
uint16 qa, icm, landwater;
extern int do_climatology;
int local_clim_flag;
extern int bad_geoloc;
int32 where, detecter, baddetector[4];
char location[100]="atmcor.c, aerosol_retrieval\0";
int32 n_that_meet_criteria1, n_that_meet_criteria2, n_that_are_desert;
float32 rho1_1,rho2_1,rho3_1,rho5_1,rho7_1,rho8_1,rho1_pred,rho3_pred,rho8_pred,n;
float32 rho1_2,rho2_2,rho3_2,rho5_2,rho7_2,rho8_2,ratio;
float32 rho1,rho2,rho3,rho4,rho5,rho6,rho7,rho8;
float32 rho7_for8, rho7_for81, rho7_for82;
float32 viewzen, vzendep;
short ndvi, n67i, n57i, saturated, any_sat;
double den, num;
int row, col, irow, icol, n_band3_saturated, ret_500m_cloud;
uint32 *sqc500m;
int32 newflag;
float32 exp1, exp2;
float32 rhop_r,rho_r,rho_r3,transmission_r,td_r,ratio_Dd;
float32 target_rho,rho_ra,S_ra,S_ra3,S_ra8,transmission1,transmission2,retrieved_rho,tau,tau_first;
float32 trup_r,trdown_r;
float32 c550_to_band_x[] = {0.8287F, 0.5807F, 1.2003F, 0.9940F, 0.3669F, 0.2565F, 0.1666F};
int clear, turbid, cloudy, any_positive, glintflag;
float Angstrom, ndvis[4];
float32 TAU_band5, TAU_band2;


/* 05-JUL-05: new LUTs */
int ib;
float corrected;
uint16 **banddata, xxx;
uint16 **fvbanddata;
float32 ar_rotoa[NBANDS];
float32 *scale, *offset;
float32 *fscale, *foffset;
int zb_band;
float roslambref,residual,raot550nm;
float min_residual,raot550nm_take; 
int16 oldAOT;
#if defined IRIS4 || defined LINUX
#define invaero invaero_
#define invaeroocean invaeroocean_
#define atmcorlamb2 atmcorlamb2_
#define atmcorocea2 atmcorocea2_
#define raycorlamb2 raycorlamb2_
#endif
float xts, xtv, xfi, uwv, uoz, pres, invfmus;
int refbndland = 1;    /* 31-OCT-05: for new models */
int OLDrefbndland = 7;
int refbndocean = 1;
int retrbndland = 3;
int retrbndocean = 5;
float angexp;
extern float tgo_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float roatm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float ttatmg_array[16][NBSPOTS_1KM*NBSCANS_1KM];
extern float satm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float xrorayp_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
float tgo,roatm,ttatmg,satm,xrorayp;
float tgofill,roatmfill,ttatmgfill,satmfill,xroraypfill;
int8 fillflag[NBSPOTS_1KM*NBSCANS_1KM]; 
char err_msg[80];
int retval;
float erelc_for_this_pixel[16];  /* init with erelc; update if necessary band is saturated */
uint8 model;


void get_criteria(int scan_number, int pixel_number, float in500put[7][NBSCANS_500M*NBSPOTS_500M], uint32 *sqc500m, float vzendep, int32 baddetector[4], int *index500m, 
                  int *n_band3_saturated, int32 *n_that_are_desert, int32 *n_that_meet_criteria1, int32 *n_that_meet_criteria2, 
		  float32 *rho1_1, float32 *rho1_2, float32 *rho2_1, float32 *rho2_2, float32 *rho3_1, float32 *rho3_2, float32 *rho5_1, 
		  float32 *rho5_2, float32 *rho7_1, float32 *rho7_2, short *n57i, short *ndvi, short *n67i);
void onekm_get_criteria(int scan_number, int where, float input[7][NBSCANS_1KM*NBSPOTS_1KM], float vzendep, int32 baddetector[4],
                        int *n_band3_saturated, int32 *n_that_are_desert, int32 *n_that_meet_criteria1, int32 *n_that_meet_criteria2, 
		        float32 *rho1_1, float32 *rho1_2, float32 *rho2_1, float32 *rho2_2, float32 *rho3_1, float32 *rho3_2, float32 *rho5_1, 
		        float32 *rho5_2, float32 *rho7_1, float32 *rho7_2, short *n57i, short *ndvi, short *n67i);
int newLUTsubpixel_cloud_check(int scan, int16 *AOT1, int16 *AOT3, int16 *AOT8, uint8 *tmpAOTQA, uint16 *tmpAOTCM, float c550_to_band_x[7], uint16 *state, 
                         float32 spres, float32 cfts, float32 cftv, float32 cffsfv, float32 cfmuv, float32 invfmus, uint16 **in500put, 
			 float *offset, float *scale, int index1km, 
			 int index500m, float uwv, float uoz, float deltatemp, uint8 landflag, uint8 glintflag);
int subpixel_cloud_check(int16 *AOT1, int16 *AOT3, int16 *AOT8, uint8 *tmpAOTQA, uint16 *tmpAOTCM, float c550_to_band_x[7], uint16 *state, 
                         float32 spres, float32 cfts, float32 cftv, float32 cffsfv, float32 cfmuv, float32 cfmus, float in500put[7][NBSCANS_500M*NBSPOTS_500M], 
			 int index500m, float uwv, float uoz, float deltatemp, uint8 landflag, uint8 glintflag);
int get_Angstrom_and_tau_values(float TAU_band2, float TAU_band5, float *Angstrom, int16 *AOT1, int16 *AOT3, int16 *AOT8, uint8 *QA);
int get_ocean_data(int scan_number, int index1km, int index500m, float in500put[7][NBSCANS_500M*NBSPOTS_500M], 
                   float in1kput[7][NBSCANS_1KM*NBSPOTS_1KM], float *ch1, float *ch2, float *ch3, float *ch4, float *ch5, 
		   float *ch7, float ndvis[4]);
int onekm_get_ocean_data(int scan_number, int index1km, float in1kput[7][NBSCANS_1KM*NBSPOTS_1KM], float *ch1, 
                         float *ch2, float *ch3, float *ch4, float *ch5,  float *ch7, float ndvis[4]);
			 
local_clim_flag = do_climatology;  /* Init with user's wishes */

total_1km_pixels = NBSCANS_1KM*NBSPOTS_1KM;

if (bad_geoloc) local_clim_flag = 1;  /* if the geolocation is bad, do climatology */

tmpAOT1 = local_output->data[AOT_1];
tmpAOT3 = local_output->data[AOT_3];
tmpAOT8 = local_output->data[AOT_8];
tmpAOTQA = local_output->data[AOTQA];
tmpAOTCM = local_output->data[AOTCM];
state = local_output->data[STATE];
sqc500m = local_output->data[HKMQA];
chn8 = local_input[RAD1_FILE]->data[BAND8];
chn7 = in1kput[6];
band20albedo = local_output->data[BAND20ALB];

/* local_clim_flag = 1;  / * FOR NOW */ 
index500m=0;

if (sat_type == 0) { /* terra */
    /* 3 -> 2 on 16-APR-04 */  /* 26-JUN-02: 0 and 19 for aqua, 3 for terra: added 0 for terra on 25-NOV-02, b/c band 7's 0th detector sux. */
   baddetector[0] = 3   /*99*/;   /* 04-NOV-04: no, will no longer skip any detectors */ /* 01-FEB-05: will skip just this one */
   /* Note: at some point it will be best to get PGE11 to *read* the detectors it needs to skip from the PCF, not hard-code them... */
   baddetector[1] = /*0*/   99;   
   baddetector[2] = /*8*/   99;   
   baddetector[3] = /*15*/  99;   
   
   }
else if (sat_type == 1) { /* aqua */
   baddetector[0] = 99;   /* 0 -> 99 on 15-OCT-04 */
   baddetector[1] = 99;   /* 19 -> 99 on 15-OCT-04 */
   baddetector[2] = 99;   /* dummy values */
   baddetector[3] = 99;   /* dummy values */

   }
else { 
   modsmf(MODIS_W_FUNCTIONALITY_NOT_AVAIL, "PGE11 cannot perform mixed Terra/Aqua processing!", location);
   return;
   }

memset(tmpAOT1,'\0', NBSCANS_1KM * NBSPOTS_1KM * sizeof(int16));
memset(tmpAOT3,'\0', NBSCANS_1KM * NBSPOTS_1KM * sizeof(int16));
memset(tmpAOT8,'\0', NBSCANS_1KM * NBSPOTS_1KM * sizeof(int16));
memset(fillflag,'\0', NBSCANS_1KM * NBSPOTS_1KM * sizeof(int8));
 
offset = (float32 *)local_input[RAD1_FILE]->refoffset;
scale = (float32 *)local_input[RAD1_FILE]->refscale;
banddata = (uint16 **)local_input[RAD1_FILE]->data;
foffset = (float32 *)local_input[RAD500_FILE]->refoffset;
fscale = (float32 *)local_input[RAD500_FILE]->refscale;
fvbanddata = (uint16 **)local_input[RAD500_FILE]->data;

 
if (local_clim_flag) { 
    for(index1km=0;index1km<total_1km_pixels;index1km++){
         tmpAOT1[index1km] = AOT1_FILL; 
         tmpAOT3[index1km] = AOT3_FILL; 
         tmpAOT8[index1km] = AOT8_FILL; 
	 if (bad_geoloc) /* If you are using clim. because of bad angles... */
	     tmpAOTQA[index1km] = (uint8)9;

         fillflag[index1km] = 1; 
         tgo = ttatmg = 1.0;
         roatm = satm = xrorayp = 0.0;
         for(ib=0;ib<16;ib++) {
	   tgo_array[ib][index1km] = tgo;
 	   roatm_array[ib][index1km] = roatm;
 	   ttatmg_array[ib][index1km] = ttatmg;
 	   satm_array[ib][index1km] = satm;
	   xrorayp_array[ib][index1km] = xrorayp;
              }

         }
   }
else {
    for(index1km=0;index1km<total_1km_pixels;index1km++){

        /* 03-MAY-05: init with fill values */
         tmpAOT1[index1km] = AOT1_FILL; 
         tmpAOT3[index1km] = AOT3_FILL; 
         tmpAOT8[index1km] = AOT8_FILL; 
	 	 
        /* 1) reject bad angles and "forbidden" lats/lons */
	if (sz[index1km] > 75.0F) {
	   tmpAOTQA[index1km] = (uint8)9;
           index500m+=4;
	   continue;
	   }

        if (aotr_struct.n_aotr_offsets != 0) {
           if (aotr_rejection(lat[index1km], lon[index1km])) {
              tmpAOTQA[index1km] = (uint8)16;  /* 27-MAR-03: NEW QA VALUE! */
              index500m+=4;
	      continue;
              }
	   }
        viewzen = vz[index1km];
        if (ffsfv[index1km] > 90.0F) viewzen = -viewzen;   /* for desert-mask view zenith dependence */
        vzendep = (80.0F + (0.00340455*viewzen) + (1.38314E-06*viewzen*viewzen) + (-1.91499E-10*viewzen*viewzen*viewzen)) / 80.0F;
        any_sat = 0;

        /* 2) Check state QA; reject pixels that are cloudy, snow/ice, or non-land */
        qa = state[index1km];
        icm = tmpAOTCM[index1km];
        landwater = (qa&0x38)>>3;
	
        if ((  (qa&QAINTCM) != 0  )  ||  /* internal cloud bit, NOT MOD35 bits */
            (  landwater == 0 )  ||      /* reject shallow ocean */
            (  landwater == 2 )  ||      /* reject ocean coast/lake shore */
            (  landwater == 3 )  ||      /* reject shallow inland water */
           /*(  landwater == 4 )  ||      / * reject ephemeral water */
	    (  landwater >= 5 )  ||      /* reject deep inland water, ocean */ 
            (  (icm&0x0020) != 0x0 )||     /* reject fire */ 
            (  (icm&0x0040) != 0x0 )||     /* reject glint */ 
            (  (icm&0x0200) != 0x0 )||     /* New, 28-OCT-02: reject "adjacent" clouds */ 
            (  (icm&0x1000) != 0x0 )||     /* New, 13-JAN-03: reject possible pans */ 
            (  (qa&0x1000) != 0x0   )) {   /* reject snow/ice */
	   
            index500m+=4;
            if (  (qa&QAINTCM) != 0  ) {
	       tmpAOTQA[index1km] = (uint8)4;  /* special cloud flag */ 
	       }
            if ((  landwater == 0 )  || 
                (  landwater == 2 )  || 
                (  landwater == 3 )  || 
               /*(  landwater == 4 )  || */
	        (  landwater >= 5 )) tmpAOTQA[index1km] = (uint8)2;  /* special water flag */ 
            if (((icm&0x0020) != 0x0)   ||
	        ((icm&0x0040) != 0x0)   || 
	        ((qa&QAINTSNOW) != 0x0 ) )tmpAOTQA[index1km] = (uint8)10;  /* special fire/glint/snow flag; snow from OUR OWN internal snow mask (27-JUN-06) */ 
            if ((icm&0x1000) != 0x0) tmpAOTQA[index1km] = (uint8)14;    /* special pan flag */ 
            if ((icm&0x0200) != 0x0) tmpAOTQA[index1km] = (uint8)19;    /* special adjacent-cloud flag */ 
	    
            continue;
           }     

        /* 3) For each of the four corresponding 500m pixels, determine how many meet criteria; get data for criteria-meeting pixels. */ 
        n_that_meet_criteria1 = 0;
        n_that_meet_criteria2 = 0;
        n_that_are_desert = 0;
        n_band3_saturated = 0;
        rho1_1 = rho1_2 = 0.0F;
        rho2_1 = rho2_2 = 0.0F;
        rho3_1 = rho3_2 = 0.0F;
        rho5_1 = rho5_2 = 0.0F;
        rho7_1 = rho7_2 = 0.0F;
        rho8_1 = rho8_2 = 0.0F;
     
#ifdef HKMAOTR
        get_criteria(scan_number, index1km, in500put, sqc500m, vzendep, baddetector, &index500m, &n_band3_saturated, &n_that_are_desert, &n_that_meet_criteria1, 
                     &n_that_meet_criteria2, &rho1_1, &rho1_2, &rho2_1, &rho2_2, &rho3_1, &rho3_2, &rho5_1, &rho5_2, &rho7_1, &rho7_2,
		     &n57i, &ndvi, &n67i);
#else
        onekm_get_criteria(scan_number, index1km, in1kput, vzendep, baddetector, &n_band3_saturated, &n_that_are_desert, &n_that_meet_criteria1, 
                           &n_that_meet_criteria2, &rho1_1, &rho1_2, &rho2_1, &rho2_2, &rho3_1, &rho3_2, &rho5_1, &rho5_2, &rho7_1, &rho7_2,
		           &n57i, &ndvi, &n67i);
        index500m += 4;
#endif
		  
/*if ((scan_number==114)&&(index1km == 917))  printf("%d %d %f %f\n",n_that_meet_criteria1,n_that_meet_criteria2,rho3_1,rho3_2);*/
        /* 26-MAR-03 */
        if (n_that_are_desert > 0)  {
	   tmpAOT1[index1km] = AOT1_FILL;    /* these values will not be overwritten */
	   tmpAOT3[index1km] = AOT3_FILL;  
	   tmpAOT8[index1km] = AOT8_FILL;  
           tmpAOTQA[index1km] = (uint8)15;  /* flag as desert */
            }
        else {
	
           if (n_band3_saturated > 0) {   
	       /* AOT values will be overwritten, leave them blank */
               tmpAOTQA[index1km] = (uint8)11; 
              }
	   else {
              if ((n_that_meet_criteria1 == 0)&&(n_that_meet_criteria2 == 0))  {
	         /* AOT values will be overwritten, leave them blank */
                 tmpAOTQA[index1km] = (uint8)1; 
                }
	      else {

/******/
   
xts = sz[index1km];
xtv = vz[index1km];
xfi = ffsfv[index1km];
uwv = fwv[index1km]; 
uoz = foz[index1km];
pres = spres[index1km]*1013.0F;
invfmus = 1.0F/fmus[index1km];

for (band = BAND1_1KM; band < BAND18; band++) {
       zb_band = band-BAND1_1KM;
       xxx = banddata[band][index1km];
       ar_rotoa[zb_band] = (((float32)xxx - offset[band])*scale[band])*invfmus;

       /* 31-OCT-05: to prevent saturated data from affecting residuals */
       erelc_for_this_pixel[zb_band] = erelc[zb_band];
       if (xxx&L1BPROBINDICATOR)erelc_for_this_pixel[zb_band] = -1.0;
  }

/*if (( scan_number == MYSCAN)&&(index1km == MYINDEX)) {
   printf("ccc\n");
   }*/
/*if ((scan_number == MYSCAN)&&(index1km == MYINDEX))  { 
  printf("HERE  %f %f %f %f %f %f\n", xts, xtv, xfi, pres, uoz, uwv);
  } */

/* 25-OCT-05: for each model, do AOTR, check the residual, take the AOT at lowest residual */
/* Key to the models: "0 = no AOTR, 1 = SMKL, 2 = SMKH, 3 = DUST, 4 = URBANPOLU, 5 = URBANCLEAN" */

invaero(&xts,&xtv,&xfi,aot550nm,roluttSMKL,&pres,tpres,  
        transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtSMKL,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
min_residual = residual;
raot550nm_take = raot550nm;
model = (uint8)SMKL;
/*residual_array[0][index1km] = residual;*/

invaero(&xts,&xtv,&xfi,aot550nm,roluttSMKH,&pres,tpres,  
        transtSMKH,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtSMKH,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
if (min_residual > residual){
   min_residual = residual;
   raot550nm_take = raot550nm;
   model = (uint8)SMKH;
   }
/*residual_array[1][index1km] = residual;*/

#ifdef DUST_IS_OK
invaero(&xts,&xtv,&xfi,aot550nm,roluttDUST,&pres,tpres,  
        transtDUST,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtDUST,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
if ((min_residual > residual) && (raot550nm >0.6)){   /* modif eric 29-oct-05 to select dust only at higher optical depth */
   min_residual = residual;
   raot550nm_take = raot550nm;
   model = (uint8)DSST;
   }
/*residual_array[2][index1km] = residual;*/
#endif

invaero(&xts,&xtv,&xfi,aot550nm,roluttURBPOL,&pres,tpres,  
        transtURBPOL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtURBPOL,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
if (min_residual > residual){  
   min_residual = residual;
   raot550nm_take = raot550nm;
   model = (uint8)URBP;
   }
/*residual_array[3][index1km] = residual;*/

invaero(&xts,&xtv,&xfi,aot550nm,roluttURBCLN,&pres,tpres,  
        transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtURBCLN,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
if (min_residual > residual){  
   min_residual = residual;
   raot550nm_take = raot550nm;
   model = (uint8)URBC;
   }
/*residual_array[4][index1km] = residual;*/
 
/* New, 22-DEC-05: if we have DUST, check it out further */
if (model == DSST) {
   for (band = BAND1_1KM; band < BAND18; band++) {
       zb_band = band-BAND1_1KM;
       xxx = banddata[band][index1km];
       ar_rotoa[zb_band] = (((float32)xxx - offset[band])*scale[band])*invfmus;

       if (band == BAND7_1KM) erelc_for_this_pixel[zb_band] = 2.0;
       else erelc_for_this_pixel[zb_band] = erelc[zb_band];
       if (xxx&L1BPROBINDICATOR)erelc_for_this_pixel[zb_band] = -1.0;
      }

   invaero(&xts,&xtv,&xfi,aot550nm,roluttSMKL,&pres,tpres,  
        transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtSMKL,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
   min_residual = residual;
   raot550nm_take = raot550nm;
   model = (uint8)SMKL;

   invaero(&xts,&xtv,&xfi,aot550nm,roluttSMKH,&pres,tpres,  
        transtSMKH,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtSMKH,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
   if (min_residual > residual){
      min_residual = residual;
      raot550nm_take = raot550nm;
      model = (uint8)SMKH;
      }

   invaero(&xts,&xtv,&xfi,aot550nm,roluttDUST,&pres,tpres,  
        transtDUST,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtDUST,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
   if ((min_residual > residual) && (raot550nm >0.6)){   /* modif eric 29-oct-05 to select dust only at higher optical depth */
      min_residual = residual;
      raot550nm_take = raot550nm;
      model = (uint8)DSST;
      }

   invaero(&xts,&xtv,&xfi,aot550nm,roluttURBPOL,&pres,tpres,  
        transtURBPOL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtURBPOL,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
   if (min_residual > residual){  
      min_residual = residual;
      raot550nm_take = raot550nm;
      model = (uint8)URBP;
      }

   invaero(&xts,&xtv,&xfi,aot550nm,roluttURBCLN,&pres,tpres,  
        transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtURBCLN,tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelc_for_this_pixel,&refbndland,&retrbndland,&raot550nm,&roslambref,&residual);
   if (min_residual > residual){  
      min_residual = residual;
      raot550nm_take = raot550nm;
      model = (uint8)URBC;
      }


    } 
 
 
raot550nm = raot550nm_take;
aotmodel[index1km] = (uint8)model;

tmpAOT1[index1km] = (int16)((min_residual*100000.0F) + 0.5F);  /* new, 03-NOV-05 */ /* residual -> min_residual, 22-DEC-05 */

tmpAOT3[index1km] = (int16)((raot550nm*AOTR_SCALE) + 0.5F);
tmpAOTCM[index1km] = tmpAOTCM[index1km] & ~QACLIMATOLOGY;    /* 25-APR-05: unset the climatology bit */

for (band = BAND1_1KM; band < BAND18; band++) {   /* every time AOT changes, all these arrays have to be updated */
       zb_band = band-BAND1_1KM;
       ib = zb_band+1;
       retval=0;
       switch (model) {
         case(SMKL) :
          atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                  aot550nm,roluttSMKL, transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtSMKL,
                  tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                  &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                  ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	          &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
	  break; 
         case(SMKH) :
          atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                  aot550nm,roluttSMKH, transtSMKH,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtSMKH,
                  tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                  &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                  ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	          &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
	  break; 
         case(DSST) :
          atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                  aot550nm,roluttDUST, transtDUST,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtDUST,
                  tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                  &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                  ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	          &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
	  break; 
         case(URBP) :
           atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                   aot550nm,roluttURBPOL, transtURBPOL,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtURBPOL,
                   tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                   &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                   ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	           &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
           break; 
         case(URBC) :
           atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                   aot550nm,roluttURBCLN, transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtURBCLN,
                   tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                   &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                   ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	           &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
           break; 
	 default:
               printf("Error: anomalous value for 'model' (%d): cannot continue \n", model);
               exit(-2);
	       }
	       
       if(retval != 0) {
               sprintf(msg, "Error: message '%s' from routine atmcorlamb2: cannot continue \n", err_msg);
               modsmf(MODIS_F_FUNCTION_ERROR, msg, location);
               }
	/*if (band < BAND8) {*/
 	   tgo_array[band-BAND1_1KM][index1km] = tgo;
 	   roatm_array[band-BAND1_1KM][index1km] = roatm;
 	   ttatmg_array[band-BAND1_1KM][index1km] = ttatmg;
 	   satm_array[band-BAND1_1KM][index1km] = satm;
	   xrorayp_array[band-BAND1_1KM][index1km] = xrorayp;
	   fillflag[index1km] = 1;
	/*}	*/
   }
/*if ((scan_number == MYSCAN)&&(index1km == MYINDEX))  printf("HERE X %d %d %d %d %d\n", ret_500m_cloud, tmpAOT1[index1km], tmpAOTQA[index1km], state[index1km],  tmpAOTCM[index1km]);
*/
oldAOT = tmpAOT3[index1km];
if ( n_bands_res[1] != 0) {
    ret_500m_cloud = newLUTsubpixel_cloud_check(scan_number, &(tmpAOT1[index1km]), &(tmpAOT3[index1km]), &(tmpAOT8[index1km]), &(tmpAOTQA[index1km]),
		                                &(tmpAOTCM[index1km]), c550_to_band_x, &(state[index1km]), spres[index1km], xts, xtv, 
		                                xfi, fmuv[index1km], (1.0F/fmus[index1km]), fvbanddata, foffset, fscale, index1km, (index500m-4), uwv, uoz, 
 		                               (fsrftmp[index1km] - ft2m[index1km]), (uint8)0, (uint8)0);				      
                      }
      
if ((tmpAOT3[index1km] != oldAOT) && (tmpAOT3[index1km] == AOT3_FILL)) {
   tmpAOTCM[index1km] |= QACLIMATOLOGY;              /* set back the climatology bit */
   for (band = BAND1_1KM; band < BAND18; band++) {   /* every time AOT changes, all these arrays have to be updated -- ARRGGHHH. */
       raot550nm = (float)tmpAOT3[index1km]*0.001F;
       zb_band = band-BAND1_1KM;
       ib = zb_band+1;
       retval=0;
       switch (model) {
         case(SMKL) :
          atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                  aot550nm,roluttSMKL, transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtSMKL,
                  tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                  &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                  ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	          &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
	  break; 
         case(SMKH) :
          atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                  aot550nm,roluttSMKH, transtSMKH,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtSMKH,
                  tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                  &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                  ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	          &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
	  break; 
         case(DSST) :
          atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                  aot550nm,roluttDUST, transtDUST,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtDUST,
                  tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                  &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                  ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	          &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
	  break; 
         case(URBP) :
           atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                   aot550nm,roluttURBPOL, transtURBPOL,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtURBPOL,
                   tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                   &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                   ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	           &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
           break; 
         case(URBC) :
           atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                   aot550nm,roluttURBCLN, transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtURBCLN,
                   tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                   &uoz,&uwv,tauray, ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                   ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	           &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
           break; 
	 default:
               printf("Error: anomalous value for 'model' (%d): cannot continue \n", model);
               exit(-2);
	       }
       if(retval != 0) {
               sprintf(msg, "Error: message '%s' from routine atmcorlamb2: cannot continue \n", err_msg);
               modsmf(MODIS_F_FUNCTION_ERROR, msg, location);
               }
       /*if (band < BAND8) {*/
	   tgo_array[band-BAND1_1KM][index1km] = tgo;
 	   roatm_array[band-BAND1_1KM][index1km] = roatm;
 	   ttatmg_array[band-BAND1_1KM][index1km] = ttatmg;
 	   satm_array[band-BAND1_1KM][index1km] = satm;
	   xrorayp_array[band-BAND1_1KM][index1km] = xrorayp;	
	   fillflag[index1km] = 1;
	 /*  }*/
      }
   }

/****/                 }  /* else (at least one criterion was met) */
               
              }  /* else (not saturated) */
	
           }  /* else (not desert) */

        }  /* for(index1km=0;index1km<total_1km_pixels;index1km++) */

    /* Now, do pixels over water */
    index500m = 0;
    for(index1km=0;index1km<total_1km_pixels;index1km++){
       any_sat = 0;
       clear = 0;
       turbid = 1;         /* assume turbid */
       landwater = (state[index1km]&0x38)>>3;
       icm = tmpAOTCM[index1km];
       glintflag = ((rhog[index1km] > 0.0100F)&&(band20albedo[index1km] > 50));

       cloudy = (icm&0x0001);
       if ((cloudy)&&(tmpAOTQA[index1km] == (uint8)2)) tmpAOTQA[index1km] = (uint8)4;   /* reset cloudy QA */
     
       if (tmpAOTQA[index1km] == (uint8)2) {   /* you got cloud-free water */
#ifdef HKMAOTR
           any_positive = get_ocean_data(scan_number, index1km, index500m, in500put, in1kput, &rho1, &rho2, &rho3, &rho4, &rho5, &rho7, ndvis);
#else
           any_positive = onekm_get_ocean_data(scan_number, index1km, in1kput, &rho1, &rho2, &rho3, &rho4, &rho5, &rho7, ndvis);
#endif
	   
 	   if (any_positive) {	      
              tmpAOTQA[index1km] = (uint8)5;  /* flag as weird */	      
	      index500m += 4;                 /* reject pixel */
	      continue;
	      }
	      
	   if (landwater == 2) {  /* for now, we're rejecting ocean coastlines/shorelines over both land AND ocean */
	      index500m += 4;
	      continue;
	      }

           /* also, reject any pixels that are flagged as bad in corresponding 500m data */
	   n_band3_saturated=0;
	   for (i=0;i<4;i++)  if( (sqc500m[locator500[index500m+i]]&OISBADPIXEL) == 3 ) n_band3_saturated++;
 	   if (n_band3_saturated) {
              tmpAOTQA[index1km] = (uint8)11;  /* flag as saturated */
	      index500m += 4;                  /* reject pixel */
	      continue;
	      }
/*printf("XXXX %d %f %f %f %f %f %f\n",scan_number*total_1km_pixels+index1km, rho1, rho2, rho3, rho4, rho5, rho7);*/

	   /* 05-MAY-06: wrongly deleted, reinstated:
	      Check for clear/turbid */
	   /* Note: the '(ch1 < 0.8500F*ch3) && (surfacetemp[index1km] > 275.0F)' tests were added
	      on 22-JUN-01, used to determine if water is icy: if so, flag it as turbid to 
	      prevent AOTR over it. */
	   if ((rho1 < (float)((float64)0.900F*(float64)rho4)) && 
	       (rho1 < (float)((float64)0.8500F*(float64)rho3)) && (fsrftmp[index1km] > 275.0F)){
	       clear = 1;
	       tmpAOTQA[index1km] = (uint8)6;  /* flag for clear */
	       }
           else {
	       if ((rho7 > 0.0200F) && (  ((float)band20albedo[index1km]/REFSCALE)/rho7 > 0.8F)&&
	           (rhog[index1km] < 0.005F )) {
	           tmpAOTQA[index1km] = (uint8)6;  /* flag for clear */
	           clear = 1;
		   }
	       else
	           tmpAOTQA[index1km] = (uint8)7;  /* flag for turbid */
	       }
	    
	   if ((rhog[index1km] > 0.0100F)&&(band20albedo[index1km] > 500)){  /* for now (01-AUG-01) */
	       clear = 1;
	       tmpAOTQA[index1km] = (uint8)6;  /* flag for clear */
	        }

/***********/

xts = sz[index1km];
xtv = vz[index1km];
xfi = ffsfv[index1km];
uwv = fwv[index1km]; 
uoz = foz[index1km];
pres = spres[index1km]*1013.0F;
invfmus = 1.0F/fmus[index1km];

for (band = BAND1_1KM; band < BAND18; band++) {
       zb_band = band-BAND1_1KM;
       xxx = banddata[band][index1km];
       ar_rotoa[zb_band] = (((float32)xxx - offset[band])*scale[band])*invfmus;
  }

invaeroocean(&xts,&xtv,&xfi,aot550nm,roluttURBCLN,&pres,tpres,  
        transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
        sphalbtURBCLN,
        tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
        &uoz,&uwv,tauray,
        ogtransa0,ogtransa1,ogtransb0,ogtransb1,
        ogtransc0,ogtransc1,
        wvtransa,wvtransb,wvtransc,oztransa,     
        ar_rotoa,erelco,&refbndocean,&retrbndocean,&raot550nm,&roslambref,&residual,&angexp);

tmpAOT3[index1km] = (int16)((raot550nm*AOTR_SCALE) + 0.5F);
/* Residuals are not currently defined over oceans: don't do this
 * tmpAOT1[index1km] = (int16)((residual*100000.0F) + 0.5F);
 */
/* do this instead: */
tmpAOT1[index1km] = 0.0F;
 
tmpAOT8[index1km] = (int16)((angexp*AOTR_SCALE)+0.5F);


tmpAOTCM[index1km] = tmpAOTCM[index1km] & ~QACLIMATOLOGY;    /* 25-APR-05: unset the climatology bit */
aotmodel[index1km] = (uint8)URBC;

for (band = BAND1_1KM; band < BAND18; band++) {   /* every time AOT changes, all these arrays have to be updated */
       zb_band = band-BAND1_1KM;
       ib = zb_band+1;
       retval = 0;
       atmcorocea2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
               aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
               sphalbtURBCLN,
               tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
               &uoz,&uwv,tauray,
               ogtransa0,ogtransa1,ogtransb0,ogtransb1,
               ogtransc0,ogtransc1,
               wvtransa,wvtransb,wvtransc,oztransa,     
     	       &(ar_rotoa[zb_band]),&corrected,&angexp,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);  
	if(retval != 0) {
               sprintf(msg, "Error: message '%s' from routine atmcorocea2: cannot continue \n", err_msg);
               modsmf(MODIS_F_FUNCTION_ERROR, msg, location);
               }
	/*if (band < BAND8) {*/
 	  tgo_array[band-BAND1_1KM][index1km] = tgo;
 	  roatm_array[band-BAND1_1KM][index1km] = roatm;
 	  ttatmg_array[band-BAND1_1KM][index1km] = ttatmg;
 	  satm_array[band-BAND1_1KM][index1km] = satm;
	  xrorayp_array[band-BAND1_1KM][index1km] = xrorayp;	
	  fillflag[index1km] = 1;
	/*}*/
/*if ((scan_number == MYSCAN)&&(index1km == MYINDEX)&&(band<BAND5_1KM)) {
          printf("PARAMETERS %f %f %f %f %f %f %f\n", xts, xtv, xfi, raot550nm, pres, uoz, uwv);
          printf("BAND %d %f %f %f -- %f %f %f %f %f\n", ib, angexp, ar_rotoa[zb_band], corrected, tgo, roatm, ttatmg, satm, xrorayp);
            }*/
   }

oldAOT = tmpAOT3[index1km];
if ( n_bands_res[1] != 0) {
    ret_500m_cloud = newLUTsubpixel_cloud_check(scan_number, &(tmpAOT1[index1km]), &(tmpAOT3[index1km]), &(tmpAOT8[index1km]), &(tmpAOTQA[index1km]),
		                                &(tmpAOTCM[index1km]), c550_to_band_x, &(state[index1km]), spres[index1km], xts, xtv, 
		                                xfi, fmuv[index1km], (1.0F/fmus[index1km]), fvbanddata, foffset, fscale, index1km, (index500m), uwv, uoz, 
 		                                (fsrftmp[index1km] - ft2m[index1km]), (uint8)1, (uint8)glintflag);
			}
				      
if ((tmpAOT3[index1km] != oldAOT) && (tmpAOT3[index1km] == AOT3_FILL)) {
   tmpAOTCM[index1km] |= QACLIMATOLOGY;              /* set back the climatology bit */
   raot550nm = (float)tmpAOT3[index1km]*0.001F;
   for (band = BAND1_1KM; band < BAND18; band++) {   /* every time AOT changes, all these arrays have to be updated. */
       zb_band = band-BAND1_1KM;
       ib = zb_band+1;
       retval = 0;
       atmcorocea2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
               aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
               sphalbtURBCLN,
               tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
               &uoz,&uwv,tauray,
               ogtransa0,ogtransa1,ogtransb0,ogtransb1,
               ogtransc0,ogtransc1,
               wvtransa,wvtransb,wvtransc,oztransa,     
     	       &(ar_rotoa[zb_band]),&corrected,&angexp,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);  
	if(retval != 0) {
               sprintf(msg, "Error: message '%s' from routine atmcorocea2: cannot continue \n", err_msg);
               modsmf(MODIS_F_FUNCTION_ERROR, msg, location);
               }
	/*if (band < BAND8) {*/
 	  tgo_array[band-BAND1_1KM][index1km] = tgo;
 	  roatm_array[band-BAND1_1KM][index1km] = roatm;
 	  ttatmg_array[band-BAND1_1KM][index1km] = ttatmg;
 	  satm_array[band-BAND1_1KM][index1km] = satm;
	  xrorayp_array[band-BAND1_1KM][index1km] = xrorayp;	
	  fillflag[index1km] = 1;
	 /* }*/
/*if ((scan_number == MYSCAN)&&(index1km == MYINDEX)&&(band<BAND5_1KM)) 
          printf("XXX BAND %d %f: %f %f -- %f %f %f %f \n", ib, angexp, ar_rotoa[zb_band], corrected, tgo, roatm, ttatmg, satm);*/
      }
   }

/***********/


          } /* if (tmpAOTQA[index1km] == (uint8)2) */
           index500m += 4;
	   
        }  /* for(index1km=0;index1km<total_1km_pixels;index1km++) */

    }  /* else (no need for climatology) */

/* Now check the fillflag (1 if OK, 0 if not OK) and fill in accordingly */

for(index1km=0;index1km<total_1km_pixels;index1km++) { 
      
   if (fillflag[index1km] == 0) {
      xts = sz[index1km];
      xtv = vz[index1km];
      xfi = ffsfv[index1km];
      if (xts < -180.0) {    /* 10-APR-06: got rid of over 75 check */
         xts = 85.0F;  /* these are dumb fill values */
         xtv = 5.0F;
         xfi = 60.0F;
         }
      uwv = fwv[index1km]; 
      uoz = foz[index1km];
      pres = spres[index1km]*1013.0F;
      invfmus = 1.0F/fmus[index1km];
      raot550nm = 0.06000F;

      for (band = BAND1_1KM; band < BAND18; band++) {
           zb_band = band-BAND1_1KM;
           ib = zb_band+1;
           xxx = banddata[band][index1km];
           ar_rotoa[zb_band] = (((float32)xxx - offset[band])*scale[band])*invfmus;
           
	   if ( xts < 75.0 )   /* new, 10-APR-06 */
	   atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                       aot550nm,roluttSMKL,transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtSMKL,
                       tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                       &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                       ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	               &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
           else if ( xts < 85.0 )
	   raycorlamb2(&xts,&xtv,&xfi,&ib,&pres,&uoz,&uwv,tauray,
               ogtransa0,ogtransa1,ogtransb0,ogtransb1,
               ogtransc0,ogtransc1,
               wvtransa,wvtransb,wvtransc,oztransa,     
     	       &(ar_rotoa[zb_band]),&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp);  
          else {   /* 10-MAY-06 */
               tgo = 1.0;
               roatm = 0.0;
               ttatmg = 1.0;
               satm = 0.0;
               xrorayp = 0.0;
               }

	   tgo_array[zb_band][index1km] = tgo;
 	   roatm_array[zb_band][index1km] = roatm;
 	   ttatmg_array[zb_band][index1km] = ttatmg;
 	   satm_array[zb_band][index1km] = satm;
	   xrorayp_array[zb_band][index1km] = xrorayp;
	    }
        }

   }


}

/*************************************************************************************************************************
 **************************************************************************************************************************/

int get_parameter_fill_values(int band, float *sz, float *vz, float *phi, float *wv, float *oz, float *pres, float *toa, 
                              float *tgofill, float *roatmfill, float *ttatmgfill, float *satmfill, float *xroraypfill)
{
float corrected;
float raot550nm = 0.060F;
int retval;
char err_msg[256];
int ib;

ib = band;
if ( *sz < 75.0 )   
	   atmcorlamb2(sz,vz,phi,&raot550nm,&ib,pres,tpres,
                       aot550nm,roluttSMKL,transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin, sphalbtSMKL,
                       tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                       oz,wv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                       ogtransc0,ogtransc1, wvtransa,wvtransb,wvtransc,oztransa,     
     	               toa,&corrected,tgofill,roatmfill,
                       ttatmgfill,satmfill,xroraypfill,err_msg,&retval); 
else if ( *sz < 85.0 )   
	   raycorlamb2(sz,vz,phi,&ib,pres,oz,wv,tauray,
               ogtransa0,ogtransa1,ogtransb0,ogtransb1,
               ogtransc0,ogtransc1,
               wvtransa,wvtransb,wvtransc,oztransa,     
     	       toa,&corrected,tgofill,
               roatmfill,ttatmgfill,satmfill,xroraypfill);  

else { 
     *tgofill = 1.0;
     *roatmfill = 0.0;
     *ttatmgfill = 1.0;
     *satmfill = 0.0;
     *xroraypfill = 0.0;
   }
return(0);
}			      


/*************************************************************************************************************************
 **************************************************************************************************************************/
int get_Angstrom_and_tau_values(float TAU_band2, float TAU_band5, float *Angstrom, int16 *AOT1, int16 *AOT3, int16 *AOT8, uint8 *QA)
/*
!C****************************************************************************

!Routine: get_Angstrom_and_tau_values()

!Description: 

!Input Parameters:
  
!Input/Output Parameters:
  
!Output Parameters:
  none

!Returns:
  1   turbid
  0   non-turbid
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    
!END**************************************************************************/
{
int turbid;
/*float32 c550_to_band_x = 1.2003F;  /  * for band 3 */
double tmpdub;
            /* get Angstrom exponent */
            if ((TAU_band2 <= 0.05)||(TAU_band5 <= 0.05)) {  /* will this ever happen? */
	        *Angstrom=0.0F; 
		}
	    else {
#ifdef LINUX
	        *Angstrom = -log( (double)(TAU_band2)/(double)(TAU_band5) );
	        *Angstrom /= log( 0.87/1.24 );
#else
	        *Angstrom = -logf( TAU_band2/TAU_band5 );
	        *Angstrom /= logf( 0.87F/1.24F );
#endif
	    }
	    
	       if (*Angstrom > -0.5){                           /* 29-MAY-01 */
	          if (*Angstrom < 0.0) *Angstrom = 0.0;
		  if (*Angstrom > 1.0) *Angstrom = 1.0;
#ifdef LINUX
		  tmpdub = pow(0.87/0.47, (double)(*Angstrom));
	          *AOT3 =  (int16)((double)TAU_band2*tmpdub*(double)AOTR_SCALE);
		  tmpdub = pow(0.87/0.67, (double)(*Angstrom));
	          *AOT1 =  (int16)((double)TAU_band2*tmpdub*(double)AOTR_SCALE);
#else
	          *AOT3 =  (int16)(TAU_band2*powf((0.87F/0.47F), *Angstrom)*AOTR_SCALE);
	          *AOT1 =  (int16)(TAU_band2*powf((0.87F/0.67F), *Angstrom)*AOTR_SCALE);
#endif
	          *AOT8 =  (int16)(0.01*c550_to_band3*AOTR_SCALE);  /* assume saturation */
                  *QA = (uint8)6;  /* flag for clear */
	          turbid = 0;
	       }else{
	          turbid = 1;
                  *QA = (uint8)7;  /* flag for turbid */
	       }	    
return(turbid);
}
/*************************************************************************************************************************
 **************************************************************************************************************************/
int get_ocean_data(int scan_number, int index1km, int index500m, float in500put[7][NBSCANS_500M*NBSPOTS_500M], 
                   float in1kput[7][NBSCANS_1KM*NBSPOTS_1KM], float *ch1, float *ch2, float *ch3, float *ch4, float *ch5, 
		   float *ch7, float ndvis[4])
/*
!C****************************************************************************

!Routine: get_ocean_data()

!Description: 

!Input Parameters:
  
!Input/Output Parameters:
  
!Output Parameters:

!Returns:
  the number of corresponding 500m pixels that have a positive NDVI (0 - 3)
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    
!END**************************************************************************/
{

float *chn1,*chn2,*chn3,*chn4,*chn5,*chn6,*chn7, ndvi, num, den;
int i, any_positive;
/* locator500[] is global */

chn1 = in1kput[0];
chn2 = in1kput[1];
chn3 = in1kput[2];
chn4 = in1kput[3];
chn5 = in500put[4];
chn7 = in500put[6];

*ch1 = chn1[index1km];
*ch2 = chn2[index1km];
*ch3 = chn3[index1km];
*ch4 = chn4[index1km];

chn1 = in500put[0];
chn2 = in500put[1];
	
if ( (locator500[index500m]/(NBSPOTS_1KM*2))  == 3) {
   *ch5 = chn5[locator500[index500m+2]];
	   } 
else if ( (locator500[index500m+2]/(NBSPOTS_1KM*2))  == 3) {
   *ch5 = chn5[locator500[index500m]];
	   } 
else 
   *ch5 = (chn5[locator500[index500m]] + chn5[locator500[index500m+2]])/2.0F;

*ch7 = (chn7[locator500[index500m]] + chn7[locator500[index500m+2]])/2.0F;

		
/* check NDVI to make sure */
any_positive=0;
for (i=0;i<4;i++) {
          num = chn2[locator500[index500m+i]];
          den = num;
          num -= chn1[locator500[index500m+i]];
          den += chn1[locator500[index500m+i]];
          if (den != 0) 
              ndvi=((1000.0F*num)/den);
          else 
              ndvi=-99.0;
	  if (ndvi > 0.0) any_positive++;
          ndvis[i] = ndvi;
	}
return(any_positive);
}

/*************************************************************************************************************************
 **************************************************************************************************************************/
int onekm_get_ocean_data(int scan_number, int index1km,  float in1kput[7][NBSCANS_1KM*NBSPOTS_1KM], float *ch1, float *ch2, 
                         float *ch3, float *ch4, float *ch5, float *ch7, float ndvis[4])
/*
!C****************************************************************************

!Routine: onekm_get_ocean_data()

!Description: 

!Input Parameters:
  
!Input/Output Parameters:
  
!Output Parameters:

!Returns:
  the number of corresponding 500m pixels that have a positive NDVI (0 - 3)
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    
!END**************************************************************************/
{

float *chn1,*chn2,*chn3,*chn4,*chn5,*chn6,*chn7, ndvi, num, den;
int i, any_positive;
/* locator500[] is global */

chn1 = in1kput[0];
chn2 = in1kput[1];
chn3 = in1kput[2];
chn4 = in1kput[3];
/*chn5 = in500put[4];
chn7 = in500put[6];*/

*ch1 = chn1[index1km];
*ch2 = chn2[index1km];
*ch3 = chn3[index1km];
*ch4 = chn4[index1km];

/*chn1 = in500put[0];
chn2 = in500put[1];
	
if ( (locator500[index500m]/(NBSPOTS_1KM*2))  == 3) {
   *ch5 = chn5[locator500[index500m+2]];
	   } 
else if ( (locator500[index500m+2]/(NBSPOTS_1KM*2))  == 3) {
   *ch5 = chn5[locator500[index500m]];
	   } 
else 
   *ch5 = (chn5[locator500[index500m]] + chn5[locator500[index500m+2]])/2.0F;

*ch7 = (chn7[locator500[index500m]] + chn7[locator500[index500m+2]])/2.0F;
*/

chn5 = in1kput[4];
chn7 = in1kput[6];
*ch5 = chn5[index1km];
*ch7 = chn7[index1km];
		
/* check NDVI to make sure */
any_positive=0;
/*for (i=0;i<4;i++) {
          num = chn2[locator500[index500m+i]];
          den = num;
          num -= chn1[locator500[index500m+i]];
          den += chn1[locator500[index500m+i]]; */

          num = *ch2;
          den = num;
          num -= *ch1;
          den += *ch1;

          if (den != 0) 
              ndvi=((1000.0F*num)/den);
          else 
              ndvi=-99.0;
	  if (ndvi > 0.0) any_positive++;
          ndvis[0] = ndvi;
	  
/*	}*/
return(any_positive);
}

/*************************************************************************************************************************
 **************************************************************************************************************************/
int subpixel_cloud_check(int16 *AOT1, int16 *AOT3, int16 *AOT8, uint8 *tmpAOTQA, uint16 *tmpAOTCM, float32 c550_to_band_x[7], uint16 *state,
                         float32 spres, float32 cfts, float32 cftv, float32 cffsfv, float32 cfmuv, float32 cfmus, 
			 float in500put[7][NBSCANS_500M*NBSPOTS_500M], int index500m, float uwv, float uoz, float deltatemp, uint8 landflag, uint8 glintflag)
/*
!C****************************************************************************

!Routine: subpixel_cloud_check()

!Description:  Routine which checks for subpixel (500m) clouds and flags them as such.

!Input Parameters:
  
!Input/Output Parameters:
  
!Output Parameters:

!Returns:
        The number of pixels at 500m (corresponding to 1km pixel in question) that are cloud
	positive: range is 0 - 4. 
	OR
	-1 (error -- aerosols at this point have been rejected).
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    
!END**************************************************************************/
{
float n;
int16 tmpaot1, tmpaot3, tmpaot8;
uint16 tmpCM, tmpST;
uint8 tmpQA;
float tau1, tau3, tau;
int ret = 0;
int this_is_a_500m_cloud(float32 spres, float32 cfts, float32 cftv, float32 cffsfv, float32 cfmuv, float32 cfmus, 
                         float tau1, float tau3, float in500put[7][NBSCANS_500M*NBSPOTS_500M], int index500m, float deltatemp, 
			 uint8 landflag, uint8 glintflag);

tmpaot1 = *AOT1;
tmpaot3 = *AOT3;
tmpaot8 = *AOT8;
tmpCM   = *tmpAOTCM;
tmpQA   = *tmpAOTQA;
tmpST   = *state;

if (landflag == 0) {
  n = logf((float)tmpaot8/((float)tmpaot3)) * 7.6F;

  if ((n < 0.5) || (n > 3.0)) n = 1.0F;

  tmpaot1 = (int16)((float)tmpaot3*expf(n*-0.354)); 
}

tau1 = ((float)(tmpaot1))/(c550_to_band_x[BAND1]*1000.0F);
tau3 = ((float)(tmpaot3))/(c550_to_band_x[BAND3]*1000.0F);

tau = tmpaot3*0.00100F;
ret = this_is_a_500m_cloud(spres, cfts, cftv, cffsfv, cfmuv, cfmus, tau1, tau3, in500put, 
			   index500m, deltatemp, landflag, glintflag);
			   
if (ret > 0) {
    /* flag the relevant stuff as cloudy */
    if (((tmpCM&128) == 0)  /* not flagged as dust */
	&& ((tmpCM%2) == 0)) { /* not already flagged as cloudy */
	    tmpCM |= 1;   /* flag it */
            tmpCM = tmpCM & ~(0x0200);                   /* 06-MAY-05: CLEAR THIS ADJACENT-TO-CLOUD BIT */
            tmpCM = tmpCM & ~(0x0002);                   /* 06-MAY-05: UNSET THE "CLEAR" BIT */
            tmpQA = (uint8)4; 
	    /*sqc1km_state[index1km]|=OISCLOUD1KM;*/
            tmpST = tmpST & ~QAHIGHAEROSOL;    /* 06-MAY-05: CLEAR THESE AEROSOL QUANTITY BITS */
	    tmpCM |= QACLIMATOLOGY;            /* 13-MAY-05: reset this bit */

	    tmpaot1 = (int16)AOT1_FILL;
	    tmpaot3 = (int16)AOT3_FILL;  
	    tmpaot8 = (int16)AOT8_FILL;
	      }
    }
else if (ret == -1) {  /* do NOT flag as cloud */
    tmpaot1 = (int16)AOT1_FILL;   /* These should be interpolated away...; Changed from 0 to FILL value on 31-MAY-05. */
    tmpaot3 = (int16)AOT3_FILL;  
    tmpaot8 = (int16)AOT8_FILL;
    tmpQA = (uint8)17;    /* new, 20-JAN-04, for testing purposes */
    }
*AOT1 = tmpaot1;
*AOT3 = tmpaot3;
*AOT8 = tmpaot8;
*tmpAOTCM = tmpCM;
*tmpAOTQA = tmpQA;
*state    = tmpST;

return(ret);
}

/*************************************************************************************************************************
 **************************************************************************************************************************/
int newLUTsubpixel_cloud_check(int scan, int16 *AOT1, int16 *AOT3, int16 *AOT8, uint8 *tmpAOTQA, uint16 *tmpAOTCM, float c550_to_band_x[7], uint16 *state, 
                         float32 spres, float32 cfts, float32 cftv, float32 cffsfv, float32 cfmuv, float32 invfmus, uint16 **in500put, 
			 float *offset, float *scale, int index1km, int index500m, float uwv, float uoz, float deltatemp, uint8 landflag, uint8 glintflag)
{
float n;
int16 tmpaot1, tmpaot3, tmpaot8;
uint16 tmpCM, tmpST;
uint8 tmpQA;
float tau1, tau3, tau;
int ret = 0;
int newLUT_500m_cloud(int scan, float32 spres, float32 cfts, float32 cftv, float32 cffsfv, float uwv, float uoz, float32 cfmuv, float32 invfmus, 
                         float tau, uint16 **in500put, float *offset, float *scale, int index1km, int index500m, float deltatemp, 
			 uint8 landflag, uint8 glintflag);
tmpaot1 = *AOT1;
tmpaot3 = *AOT3;
tmpaot8 = *AOT8;
tmpCM   = *tmpAOTCM;
tmpQA   = *tmpAOTQA;
tmpST   = *state;

tau = (float)tmpaot3*0.00100F;
ret = newLUT_500m_cloud(scan, spres, cfts, cftv, cffsfv, uwv, uoz, cfmuv, invfmus, tau, in500put, offset, scale, index1km,
			   index500m, deltatemp, landflag, glintflag);


/*if ((scan == MYSCAN)&&(index1km == MYINDEX)) 
   printf("SBPC %f %f %f %f %f %f %f %f %d\n", cfts, cftv, cffsfv, spres, uoz, uwv, invfmus, tau, ret);*/
			   
if (ret > 0) {
    /* flag the relevant stuff as cloudy */
    if (((tmpCM&128) == 0)  /* not flagged as dust */
	&& ((tmpCM%2) == 0)) { /* not already flagged as cloudy */
	    tmpCM |= 1;   /* flag it */
            tmpCM = tmpCM & ~(0x0200);                   /* 06-MAY-05: CLEAR THIS ADJACENT-TO-CLOUD BIT */
            tmpCM = tmpCM & ~(0x0002);                   /* 06-MAY-05: UNSET THE "CLEAR" BIT */
            tmpQA = (uint8)4; 
	    /*sqc1km_state[index1km]|=OISCLOUD1KM;*/
            tmpST = tmpST & ~QAHIGHAEROSOL;    /* 06-MAY-05: CLEAR THESE AEROSOL QUANTITY BITS */
	    tmpCM |= QACLIMATOLOGY;            /* 13-MAY-05: reset this bit */

	    tmpaot1 = (int16)AOT1_FILL;
	    tmpaot3 = (int16)AOT3_FILL;  
	    tmpaot8 = (int16)AOT8_FILL;
	      }
    }
else if (ret == -1) {  /* do NOT flag as cloud */
    tmpaot1 = (int16)AOT1_FILL;   /* These should be interpolated away...; Changed from 0 to FILL value on 31-MAY-05. */
    tmpaot3 = (int16)AOT3_FILL;  
    tmpaot8 = (int16)AOT8_FILL;
    tmpQA = (uint8)17;    /* new, 20-JAN-04, for testing purposes */
    }
*AOT1 = tmpaot1;
*AOT3 = tmpaot3;
*AOT8 = tmpaot8;
*tmpAOTCM = tmpCM;
*tmpAOTQA = tmpQA;
*state    = tmpST;

return(ret);
}

/*************************************************************************************************************************
 **************************************************************************************************************************/
int newLUT_500m_cloud(int scan, float32 spres, float32 cfts, float32 cftv, float32 cffsfv, float uwv, float uoz, float32 cfmuv, float32 invfmus, 
                         float tau, uint16 **in500put, float *offset, float *scale, int index1km, int index500m, float deltatemp, 
			 uint8 landflag, uint8 glintflag)
/*
!C*****************************************************************************
!Description:  newLUT_500m_cloud()
	Determines whether retreived aerosols are actually clouds by applying AOT to an
	atmospheric correction of bands 1 and 3, and thresholding their ratio.  For the new
	LUTs specifically

!Input Parameters:
	spres             surface pressure at this 1km pixel, in atm.
	cfts              solar zenith
	cftv              sensor zenith
	cffsfv            relative azimuth
	uwv               water vapor
	uoz               ozone
	cfmuv
	cfmus
	
	[these are now global...
	sref              simulated reflectance, read from LUN 20952x, x=0-6 (Con_wwww.V2.01, wwww=wavelength)
	ta_tab            aerosol transmission data, read from LUN 2095xx, xx=27-33 (AeroTrans.wwww.V2.1)
	Sra_tab           spherical albedo data, read from LUN 209534 (SraTable.V2.01)]
	
	
	tau               retreived AOT 
        in500put          partially corrected reflectances
	index500m
	deltatemp         (surface temperature - air temperature) at this 1km pixel
	landflag          0 = land, 1 = sea
	
!Output Parameters:
	none

!Input/Output Parameters:
        none

!Returns:
        The number of pixels at 500m (corresponding to 1km pixel in question) that are cloud
	positive: range is 0 - 4. 
	OR
	-1 (error -- reject aerosols at this point, do NOT flag as cloud).
 
!Revision History:

Revision 1.0, J. Ray, July 24, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
!END***************************************************************************
*/
{
int ib, cloud;
int32 i, where, newflag;
float32 exp1, exp2, taup_r, trdown_r, rhop_r, avg_tau, pres;
float32 rho_ra_1, transmission1_1, transmission2_1, S_ra_1, rho_r_1, transmission_r_1;
float32 rho_ra_3, transmission1_3, transmission2_3, S_ra_3, rho_r_3, transmission_r_3;
float32 rho_ra_4, transmission1_4, transmission2_4, S_ra_4, rho_r_4, transmission_r_4;
float32 corrected_band1, uncorrected_band1, VRA;
float32 corrected_band3, uncorrected_band3;
float32 corrected_band4, uncorrected_band4;
float32 corrected_band5, corrected_band7;
float32 uncorrected, corrected;
float32 b5, b7, n57i;
int early_return=-1;
/* locator500[] is global */
float newLUT_correction(float TOA, float tgo, float roatm, float ttatmg, float satm);
#if defined IRIS4 || defined LINUX
#define atmcorlamb2 atmcorlamb2_
#endif
extern float tgo_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float roatm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float ttatmg_array[16][NBSPOTS_1KM*NBSCANS_1KM];
extern float satm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
float tgo,roatm,ttatmg,satm,xrorayp;
/*correct band 1,3,4,5,7 using atmcorlamb EV */
char err_msg[80];
int retval,problem;
uint16 xxx;

cloud = 0;
pres = spres*1013.00F;
for (i=index500m;i<index500m+4;i++) {  /* BIG BUG FIX 02-DEC-02 */
        VRA = 0.0F;       	
	where = locator500[i];	
	problem = 0;

        for(ib = 1; ib < 8; ib++) {
	   if ((ib == 2)||(ib == 6)) continue;
	   
	   xxx = (uint16)in500put[(ib-1)+BAND1_500M][where];
	   
	   /* 14-JUL-05: We should have been doing this all along.  
	      We aren't checking QA, so just check this: and DON'T process 
	      ANY bad data */
	   if (xxx&L1BPROBINDICATOR) {
	      problem = 1;
	      continue;	   
	      }
	   
          uncorrected = (((float32)xxx - offset[(ib-1)+BAND1_500M])*scale[(ib-1)+BAND1_500M])*invfmus;		  
          tgo = tgo_array[(ib-1)][index1km];
          roatm = roatm_array[(ib-1)][index1km];
          satm = satm_array[(ib-1)][index1km];
          ttatmg = ttatmg_array[(ib-1)][index1km];	  
          corrected = newLUT_correction(uncorrected, tgo, roatm, ttatmg, satm);

/*if ((scan == MYSCAN)&&(index1km == MYINDEX)) 
          printf("BAND %d %f %f -- %f %f %f %f \n", ib, uncorrected, corrected, tgo, roatm, ttatmg, satm);*/

/*             atmcorlamb2(&cfts,&cftv,&cffsfv,&tau,&ib,&pres,tpres,
               aot550nm,roluttSMKL,
               transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,
               sphalbtSMKL,
               tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
               &uoz,&uwv,tauray,
               ogtransa0,ogtransa1,ogtransb0,ogtransb1,
               ogtransc0,ogtransc1,
               wvtransa,wvtransb,wvtransc,oztransa,     
     	       &uncorrected,&corrected,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);  */
/*if ((scan == MYSCAN)&&(index1km == MYINDEX)&&(ib == 3)) 
          printf("RETRN: %f %f %f %f\n", tgo, roatm, ttatmg, satm);*/
/* Note: as of 11-JUL-05, the two are *still* not quite exact...  Possible variable rounding effect... */
	      
	  if (ib == 1) {
	       uncorrected_band1 = uncorrected;
	       corrected_band1 = corrected;
	       }
	  if (ib == 3) {
	       uncorrected_band3 = uncorrected;
	       corrected_band3 = corrected;
	       }
	  if (ib == 4) {
	       uncorrected_band4 = uncorrected;
	       corrected_band4 = corrected;
	       }
	  if (ib == 5) {
	       b5 = uncorrected;
	       corrected_band5 = corrected;
	       }
	  if (ib == 7) {
	       b7 = uncorrected;
	       corrected_band7 = corrected;
	       }
	       
/*if (ib==3) printf("SBPC %f %f %f %f %f %f ...", tgo, roatm, ttatmg, satm, uncorrected, corrected);*/
        }
	
	if (problem == 1)continue;
	
	b5 = corrected_band5;
	b7 = corrected_band7;
	
	n57i = ((b5-b7)*1000.0F)/(b5+b7);
/*if ((scan == MYSCAN)&&(index1km == MYINDEX)) 
printf( "SBPC %f %f %f %f %f  %d %d\n", corrected_band4,corrected_band3,corrected_band1,b7,n57i, landflag, glintflag);*/

/* Keep the rest the same EV (carefull compute n57 */

        if (landflag == 0) {
            if ((corrected_band4 < 0.0F)||(corrected_band3 < 0.0F)||(corrected_band1 < 0.003F)){
	        early_return=1;  /* negative value short-circuit */
		break;
		}
	    }
        else {
            if ((corrected_band4 < 0.0F)||(corrected_band3 < 0.0F)){
	        early_return=1;   /* negative value short-circuit */
		break;
		}
	    }

        /* new test, 14-JAN-02 */
	if ( (b7 > 0.3000F) && (n57i < 100.00F) && (tau > 0.500F) && ((corrected_band1/corrected_band3) > 2.00F) ){
	     early_return=1;   /* short-circuit */
             break;
	     }

        if (corrected_band1 > 0.003F) {
           VRA = corrected_band3-(corrected_band1/2.0F);  /* new, 13-DEC-02 */ 
	   
          if (glintflag) {
	        early_return=0;
		break;
	       }
	       
	   if ((landflag == 0) && (VRA >= 0.05F) && (deltatemp < 10.0F)) cloud++;  
	   else if ((landflag == 1) && (VRA >= 0.07F) && (deltatemp < 10.0F) && (corrected_band1 > 0.03F)) cloud++;  
	}   	
}

if (early_return > -1)return(-1);   /* 13-DEC-02: for early returns, 1) get rid of aerosols at this point, and 2) do NOT flag as cloud */
else return(cloud);

}

/*************************************************************************************************************************
 **************************************************************************************************************************/
int this_is_a_500m_cloud(float32 spres, float32 cfts, float32 cftv, float32 cffsfv, float32 cfmuv, float32 cfmus, 
                         float tau1, float tau3, float in500put[7][NBSCANS_500M*NBSPOTS_500M], int index500m, float deltatemp, 
			 uint8 landflag, uint8 glintflag)
/*
!C*****************************************************************************
!Description:  this_is_a_500m_cloud()
	Determines whether retreived aerosols are actually clouds by applying AOT to an
	atmospheric correction of bands 1 and 3, and thresholding their ratio.

!Input Parameters:
	spres             surface pressure at this 1km pixel, in atm.
	cfts              solar zenith
	cftv              sensor zenith
	cffsfv            relative azimuth
	cfmuv
	cfmus
	
	[these are now global...
	sref              simulated reflectance, read from LUN 20952x, x=0-6 (Con_wwww.V2.01, wwww=wavelength)
	ta_tab            aerosol transmission data, read from LUN 2095xx, xx=27-33 (AeroTrans.wwww.V2.1)
	Sra_tab           spherical albedo data, read from LUN 209534 (SraTable.V2.01)]
	
	
	tau1              retreived AOT for band 1
	tau3              retreived AOT for band 3
        in500put          partially corrected reflectances
	index500m
	deltatemp         (surface temperature - air temperature) at this 1km pixel
	landflag          0 = land, 1 = sea
	
!Output Parameters:
	none

!Input/Output Parameters:
        none

!Returns:
        The number of pixels at 500m (corresponding to 1km pixel in question) that are cloud
	positive: range is 0 - 4. 
	OR
	-1 (error -- reject aerosols at this point, do NOT flag as cloud).
 
!Revision History:

Revision 1.0, J. Ray, July 24, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
!END***************************************************************************
*/
{
int cloud;
int32 i, where, newflag;
float32 exp1, exp2, taup_r, trdown_r, rhop_r, avg_tau;
float32 rho_ra_1, transmission1_1, transmission2_1, S_ra_1, rho_r_1, transmission_r_1;
float32 rho_ra_3, transmission1_3, transmission2_3, S_ra_3, rho_r_3, transmission_r_3;
float32 rho_ra_4, transmission1_4, transmission2_4, S_ra_4, rho_r_4, transmission_r_4;
float32 corrected_band1, uncorrected_band1, VRA;
float32 corrected_band3, uncorrected_band3;
float32 corrected_band4, uncorrected_band4;
float32 b6, b7, n67i;
int early_return=-1;
/* locator500[] is global */



/* For band 1: */
newflag = 1;
taup_r = atmos.tau_r[BAND1]*spres;
chand(&cffsfv,&cfmuv,&cfmus,&atmos.tau_r[BAND1],&rho_r_1,&newflag,&exp1,&exp2);
newflag = 0;
chand(&cffsfv,&cfmuv,&cfmus,&taup_r,&rhop_r,&newflag,&exp1,&exp2);
transmission_r_1=((TWO_THIRDS+cfmuv)+(TWO_THIRDS-cfmuv)*exp1)/(FOUR_THIRDS+taup_r);
trdown_r=((TWO_THIRDS+cfmus)+(TWO_THIRDS-cfmus)*exp2)/(FOUR_THIRDS+taup_r);
transmission_r_1 *= trdown_r;

interrefl(sref[BAND1],&rho_r_1,cfts,cftv,cffsfv,0.0001F);
interrefl(sref[BAND1],&rho_ra_1,cfts,cftv,cffsfv,tau1);
interatrans(ta_tab[BAND1],&transmission1_1,cftv,tau1);
interatrans(ta_tab[BAND1],&transmission2_1,cfts,tau1);
interSra(Sra_tab[BAND1],tau1,&S_ra_1);

/* Same for band 3: */
newflag = 1;
taup_r = atmos.tau_r[BAND3]*spres;
chand(&cffsfv,&cfmuv,&cfmus,&atmos.tau_r[BAND3],&rho_r_3,&newflag,&exp1,&exp2);
newflag = 0;
chand(&cffsfv,&cfmuv,&cfmus,&taup_r,&rhop_r,&newflag,&exp1,&exp2);
transmission_r_3=((TWO_THIRDS+cfmuv)+(TWO_THIRDS-cfmuv)*exp1)/(FOUR_THIRDS+taup_r);
trdown_r=((TWO_THIRDS+cfmus)+(TWO_THIRDS-cfmus)*exp2)/(FOUR_THIRDS+taup_r);
transmission_r_3 *= trdown_r;
interrefl(sref[BAND3],&rho_ra_3,cfts,cftv,cffsfv,tau3);
/* 27-JUL-01: deliberate overwrite of rho_r_3 */
interrefl(sref[BAND3],&rho_r_3,cfts,cftv,cffsfv,0.0001F);
interatrans(ta_tab[BAND3],&transmission1_3,cftv,tau3);
interatrans(ta_tab[BAND3],&transmission2_3,cfts,tau3);
interSra(Sra_tab[BAND3],tau3,&S_ra_3);

/* Same for band 4 (02-DEC-02): */
avg_tau = (tau1+tau3)/2.0F;    /* for now */
newflag = 1;
taup_r = atmos.tau_r[BAND4]*spres;
chand(&cffsfv,&cfmuv,&cfmus,&atmos.tau_r[BAND4],&rho_r_4,&newflag,&exp1,&exp2);
newflag = 0;
chand(&cffsfv,&cfmuv,&cfmus,&taup_r,&rhop_r,&newflag,&exp1,&exp2);
transmission_r_4=((TWO_THIRDS+cfmuv)+(TWO_THIRDS-cfmuv)*exp1)/(FOUR_THIRDS+taup_r);
trdown_r=((TWO_THIRDS+cfmus)+(TWO_THIRDS-cfmus)*exp2)/(FOUR_THIRDS+taup_r);
transmission_r_4 *= trdown_r;
interrefl(sref[BAND4],&rho_ra_4,cfts,cftv,cffsfv,avg_tau);
interrefl(sref[BAND4],&rho_r_4,cfts,cftv,cffsfv,0.0001F);
interatrans(ta_tab[BAND4],&transmission1_4,cftv,avg_tau);
interatrans(ta_tab[BAND4],&transmission2_4,cfts,avg_tau);
interSra(Sra_tab[BAND4],avg_tau,&S_ra_4);

cloud = 0;
for (i=index500m;i<index500m+4;i++) {  /* BIG BUG FIX 02-DEC-02 */
        VRA = 0.0F;       	
	where = locator500[i];
        uncorrected_band1 = (float32)in500put[0][where];
        uncorrected_band3 = (float32)in500put[2][where];
        uncorrected_band4 = (float32)in500put[3][where];
/*        b6 = (float32)in500put[5][where];*/
/* 25-MAY-05: SHOULD WE BE USING BAND 5 HERE? */
        b6 = (float32)in500put[4][where];
        b7 = (float32)in500put[6][where];
	n67i = ((b6-b7)*1000.0F)/(b6+b7);

	corrected_band1 = uncorrected_band1*transmission_r_1 + rho_r_1 - rho_ra_1;
	corrected_band1 /= transmission_r_1*transmission1_1*transmission2_1;
	corrected_band1 = corrected_band1/(1.0F + S_ra_1*corrected_band1);

	corrected_band3 = uncorrected_band3*transmission_r_3 + rho_r_3 - rho_ra_3;
	corrected_band3 /= transmission_r_3*transmission1_3*transmission2_3;
	corrected_band3 = corrected_band3/(1.0F + S_ra_3*corrected_band3);

	corrected_band4 = uncorrected_band4*transmission_r_4 + rho_r_4 - rho_ra_4;
	corrected_band4 /= transmission_r_4*transmission1_4*transmission2_4;
	corrected_band4 = corrected_band4/(1.0F + S_ra_4*corrected_band4);

        if (landflag == 0) {
            if ((corrected_band4 < 0.0F)||(corrected_band3 < 0.0F)||(corrected_band1 < 0.003F)){
	        early_return=1;  /* negative value short-circuit */
		break;
		}
	    }
        else {
            if ((corrected_band4 < 0.0F)||(corrected_band3 < 0.0F)){
	        early_return=1;   /* negative value short-circuit */
		break;
		}
	    }

        /* new test, 14-JAN-02 */
	if ( (b7 > 0.3000F) && (n67i < 100.00F) && (tau3 > 0.500F) && ((corrected_band1/corrected_band3) > 2.00F) ){
	     early_return=1;   /* short-circuit */
             break;
	     }

        if (corrected_band1 > 0.003F) {
           VRA = corrected_band3-(corrected_band1/2.0F);  /* new, 13-DEC-02 */ 
	   
          if (glintflag) {
	        early_return=0;
		break;
	       }
	       
	   if ((landflag == 0) && (VRA >= 0.05F) && (deltatemp < 10.0F)) cloud++;  
	   else if ((landflag == 1) && (VRA >= 0.07F) && (deltatemp < 10.0F) && (corrected_band1 > 0.03F)) cloud++;  
	}   	
}
if (early_return > -1)return(-1);   /* 13-DEC-02: for early returns, 1) get rid of aerosols at this point, and 2) do NOT flag as cloud */
else return(cloud);

}

/*************************************************************************************************************************
 **************************************************************************************************************************/
void get_criteria(int scan_number, int pixel_number, float input[7][NBSCANS_500M*NBSPOTS_500M], uint32 *sqc500m, float vzendep, int32 baddetector[4], int *index, 
                  int *n_band3_saturated, int32 *n_that_are_desert, int32 *n_that_meet_criteria1, int32 *n_that_meet_criteria2, 
		  float32 *rho1_1, float32 *rho1_2, float32 *rho2_1, float32 *rho2_2, float32 *rho3_1, float32 *rho3_2, float32 *rho5_1, 
		  float32 *rho5_2, float32 *rho7_1, float32 *rho7_2, short *n57i, short *ndvi, short *n67i)
/*
!C*****************************************************************************
!Description:  get_criteria()

!Input Parameters:

!Output Parameters:

!Input/Output Parameters:
   none

!Returns:
   nothing

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
!END****************************************************************************/
{
/* locator500[] is global */
int i, where, index500m, detecter;
float ch1,ch2,ch3,ch4,ch5,ch6,ch7, tmpfloat;
float *chn1,*chn2,*chn3,*chn4,*chn5,*chn6,*chn7;
double num, den, ln57i, lndvi, ln67i;
int16 ich1,ich2,ich3,ich4,ich5,ich6,ich7;  /* 16-JAN-04: just to get it to behave like the old version */

chn1 = input[0];
chn2 = input[1];
chn3 = input[2];
chn4 = input[3];
chn5 = input[4];
chn6 = input[5];
chn7 = input[6];

index500m = *index;

     for(i=0;i<4;i++){
         
        /* get data */
	where = locator500[index500m]; 
	detecter = where/(NBSPOTS_1KM*2);
	
        ch1 = chn1[where]; 
        ch2 = chn2[where];
        ch3 = chn3[where]; 
        ch4 = chn4[where];
        ch5 = chn5[where];
        ch6 = chn6[where];
        ch7 = chn7[where];

	/* 19-APR-04: Will fill in band5 detector 3 with avg of detectors 2 and 4 for terra only */
	/* 04-NOV-04: will skip this
	if ((sat_type == 0)&&(detecter == 3)) 
	    ch5 = (chn5[where - NBSPOTS_500M] + chn5[where + NBSPOTS_500M])/2;
	*/
	
	ich1 = (int16)(((float64)ch1*(float64)REFSCALE)+0.5F);    /* 16-JAN-04: to re-create v4.0.13's scaling, to make outputs more comparable */
	ich2 = (int16)(((float64)ch2*(float64)REFSCALE)+0.5F);
	ich3 = (int16)(((float64)ch3*(float64)REFSCALE)+0.5F);
	ich4 = (int16)(((float64)ch4*(float64)REFSCALE)+0.5F);
	ich5 = (int16)(((float64)ch5*(float64)REFSCALE)+0.5F);
	ich6 = (int16)(((float64)ch6*(float64)REFSCALE)+0.5F);
	ich7 = (int16)(((float64)ch7*(float64)REFSCALE)+0.5F);   /* end, 16-JAN-04 stuff  */
	if( (sqc500m[where]&OISBADPIXEL) == 3 ){
	     n_band3_saturated++;
	}
	  
	/* 05-OCT-01: Will skip AOTR for bad detectors */
	if ((detecter==baddetector[0])||(detecter==baddetector[1])||(detecter==baddetector[2])||(detecter==baddetector[3])) {  
	   index500m++;
	   continue;
	   }
	   
        /* 26-MAR-03: get n pixels that are desertic */
        num = (double)ich5;    /* 16-JAN-04: use integer values and not floats (e. g., ich5 not ch5) */
        num -= (double)ich7;
        den = (double)ich5;
        den += (double)ich7;
        if (den != 0) 
              *n57i=(short)((1000.0F*num)/den);
        else 
              *n57i=109;

	/* 12-MAY-03: add view zenith dependence to n57i */
 	*n57i = (short) ( (float)(*n57i)/vzendep );
	
	/*if ((*n57i < 50)&&(ch7 > 0.3000F)) (*n_that_are_desert)++;*/
	if ((*n57i < 50)&&(ch7 > 0.4000F)) (*n_that_are_desert)++; /*modif eric to get the bondville site back 29-oct-05 increase threshold ch7 from 0.3000 to 0.4000 */

        num = (double)ich2;
        num -= (double)ich1;
        den = (double)ich2;
        den += (double)ich1;
        if (den != 0) 
              *ndvi=(short)((1000.0F*num)/den);
        else 
              *ndvi=-99;

/*        if (sat_type == 0)
            num = (double)ich6;  / * 26-JUN-02: terra * /
	else
            num = (double)ich5;  / * 26-JUN-02: aqua * /  / * CHECK THIS!! * /
        den = num;
*/	
        num = (double)ich5;  /* 26-APR-05: either satellite */
        den = num;

        num -= (double)ich7;
        den += (double)ich7;
        if (den != 0) 
              *n67i=(short)((1000.0F*num)/den);
        else 
              *n67i=-99;

        /* apply tests */ 
        if ((*ndvi > 75) &&   /* reduced from 150 to 75, 09-OCT-01 */
            (ch2 > 0.1000F) /*  &&  28-MAR-06: Need to remove this test 
            (((float64)ich5 - ((float64)0.9000F*(float64)ich2)) > 0.0F) */  ) { 
	  if (*n67i > 250){   
            (*rho1_1) += (float32)ch1;
            (*rho2_1) += (float32)ch2;
            (*rho3_1) += (float32)ch3;
            (*rho5_1) += (float32)ch5;
            (*rho7_1) += (float32)ch7;
            (*n_that_meet_criteria1)++;
	  }
	  else {
	  if (*n67i > 0){  /* 29-NOV-02: 2002-017:0700 yellowspot; increased threshold from 50 to 100. To 75 on 10-JAN-03.; put to 0 on 29-Oct-05 Eric */
            (*rho1_2) += (float32)ch1;
            (*rho2_2) += (float32)ch2;
            (*rho3_2) += (float32)ch3;
            (*rho5_2) += (float32)ch5;
            (*rho7_2) += (float32)ch7;
            (*n_that_meet_criteria2)++;
	       }
	  }
        
         }
/*if ((scan_number==114)&&(pixel_number == 917)) 
    printf("%d %d\n%f %f %f %f %f\n%d %d %d %d %d; %d %d %d\n",*n_that_meet_criteria1, *n_that_meet_criteria2,
       ch1, ch2, ch5, ch6, ch7, ich1, ich2, ich5, ich6, ich7,*n57i, *ndvi, *n67i);*/
        index500m++;
     }  /* for(i=0... */

/* return averages */
if ( *n_that_meet_criteria1 > 0) {
   tmpfloat = (float)*n_that_meet_criteria1;
   (*rho1_1) /= tmpfloat;
   (*rho2_1) /= tmpfloat;
   (*rho3_1) /= tmpfloat;
   (*rho5_1) /= tmpfloat;
   (*rho7_1) /= tmpfloat;
   }
if ( *n_that_meet_criteria2 > 0) {
   tmpfloat = (float)*n_that_meet_criteria2;
   (*rho1_2) /= tmpfloat;
   (*rho2_2) /= tmpfloat;
   (*rho3_2) /= tmpfloat;
   (*rho5_2) /= tmpfloat;
   (*rho7_2) /= tmpfloat;
   }
*index = index500m;

}

/**************************************************************************************************************************
 **************************************************************************************************************************/
void onekm_get_criteria(int scan_number, int where, float input[7][NBSCANS_1KM*NBSPOTS_1KM], float vzendep, int32 baddetector[4],
                        int *n_band3_saturated, int32 *n_that_are_desert, int32 *n_that_meet_criteria1, int32 *n_that_meet_criteria2, 
		        float32 *rho1_1, float32 *rho1_2, float32 *rho2_1, float32 *rho2_2, float32 *rho3_1, float32 *rho3_2, float32 *rho5_1, 
		        float32 *rho5_2, float32 *rho7_1, float32 *rho7_2, short *n57i, short *ndvi, short *n67i)
{
int i, detecter;
float ch1,ch2,ch3,ch4,ch5,ch6,ch7, tmpfloat;
float *chn1,*chn2,*chn3,*chn4,*chn5,*chn6,*chn7;
double num, den, ln57i, lndvi, ln67i;
int16 ich1,ich2,ich3,ich4,ich5,ich6,ich7;

chn1 = input[0];
chn2 = input[1];
chn3 = input[2];
chn4 = input[3];
chn5 = input[4];
chn6 = input[5];
chn7 = input[6];

detecter = (where/NBSPOTS_1KM);
/***********************************/

        ch1 = chn1[where]; 
        ch2 = chn2[where];
        ch3 = chn3[where]; 
        ch4 = chn4[where];
        ch5 = chn5[where];
        ch6 = chn6[where];
        ch7 = chn7[where];

	/* 19-APR-04: Will fill in band5 detector 3 with avg of detectors 2 and 4 for terra only */
	/* 04-NOV-04: will skip this
	if ((sat_type == 0)&&(detecter == 3)) 
	    ch5 = (chn5[where - NBSPOTS_500M] + chn5[where + NBSPOTS_500M])/2;
	*/
	
	ich1 = (int16)(((float64)ch1*(float64)REFSCALE)+0.5F);    /* 16-JAN-04: to re-create v4.0.13's scaling, to make outputs more comparable */
	ich2 = (int16)(((float64)ch2*(float64)REFSCALE)+0.5F);
	ich3 = (int16)(((float64)ch3*(float64)REFSCALE)+0.5F);
	ich4 = (int16)(((float64)ch4*(float64)REFSCALE)+0.5F);
	ich5 = (int16)(((float64)ch5*(float64)REFSCALE)+0.5F);
	ich6 = (int16)(((float64)ch6*(float64)REFSCALE)+0.5F);
	ich7 = (int16)(((float64)ch7*(float64)REFSCALE)+0.5F);   /* end, 16-JAN-04 stuff  */
	  
	/* 05-OCT-01: Will skip AOTR for bad detectors *  /
	if ((detecter==baddetector[0])||(detecter==baddetector[1])||(detecter==baddetector[2])||(detecter==baddetector[3])) {  
	   return;
	   }
	 *   No, do NOT do this for 1km data */
	 
        /* 26-MAR-03: get n pixels that are desertic */
        num = (double)ich5;    /* 16-JAN-04: use integer values and not floats (e. g., ich5 not ch5) */
        num -= (double)ich7;
        den = (double)ich5;
        den += (double)ich7;
        if (den != 0) 
              *n57i=(short)((1000.0F*num)/den);
        else 
              *n57i=109;

	/* 12-MAY-03: add view zenith dependence to n57i */
 	*n57i = (short) ( (float)(*n57i)/vzendep );
	
	/*if ((*n57i < 50)&&(ch7 > 0.3000F)) (*n_that_are_desert)++;*/
	if ((*n57i < 50)&&(ch7 > 0.4000F)) (*n_that_are_desert)++; /*modif eric to get the bondville site back 29-oct-05 increase threshold ch7 from 0.3000 to 0.4000 */

        num = (double)ich2;
        num -= (double)ich1;
        den = (double)ich2;
        den += (double)ich1;
        if (den != 0) 
              *ndvi=(short)((1000.0F*num)/den);
        else 
              *ndvi=-99;

/*        if (sat_type == 0)
            num = (double)ich6;  / * 26-JUN-02: terra * /
	else
            num = (double)ich5;  / * 26-JUN-02: aqua * /  / * CHECK THIS!! * /
        den = num;
*/	
        num = (double)ich5;  /* 26-APR-05: either satellite */
        den = num;

        num -= (double)ich7;
        den += (double)ich7;
        if (den != 0) 
              *n67i=(short)((1000.0F*num)/den);
        else 
              *n67i=-99;

        /* apply tests */ 
        if ((*ndvi > 75) &&   /* reduced from 150 to 75, 09-OCT-01 */
            (ch2 > 0.1000F) /*   &&   28-MAR-06: Need to remove this test
            (((float64)ich5 - ((float64)0.9000F*(float64)ich2)) > 0.0F) */  ) {	    
	  if (*n67i > 250){   
            (*rho1_1) += (float32)ch1;
            (*rho2_1) += (float32)ch2;
            (*rho3_1) += (float32)ch3;
            (*rho5_1) += (float32)ch5;
            (*rho7_1) += (float32)ch7;
            (*n_that_meet_criteria1)++;
	  }
	  else {
	  if (*n67i > 0){  /* 29-NOV-02: 2002-017:0700 yellowspot; increased threshold from 50 to 100. To 75 on 10-JAN-03.; put to 0 on 29-Oct-05 Eric */
            (*rho1_2) += (float32)ch1;
            (*rho2_2) += (float32)ch2;
            (*rho3_2) += (float32)ch3;
            (*rho5_2) += (float32)ch5;
            (*rho7_2) += (float32)ch7;
            (*n_that_meet_criteria2)++;
	       }
	  }
        
         }
/*if ((scan_number==30)&&(where == (8*1354)+663)) 
    printf("%d %d\n%f %f %f %f %f\n%d %d %d %d %d; %d %d %d\n",*n_that_meet_criteria1, *n_that_meet_criteria2, ch1, ch2, ch5, ch6, ch7, ich1, ich2, ich5, ich6, ich7,*n57i, *ndvi, *n67i);
*/
/* return averages * /  Not necessary
if ( *n_that_meet_criteria1 > 0) {
   tmpfloat = (float)*n_that_meet_criteria1;
   (*rho1_1) /= tmpfloat;
   (*rho2_1) /= tmpfloat;
   (*rho3_1) /= tmpfloat;
   (*rho5_1) /= tmpfloat;
   (*rho7_1) /= tmpfloat;
   }
if ( *n_that_meet_criteria2 > 0) {
   tmpfloat = (float)*n_that_meet_criteria2;
   (*rho1_2) /= tmpfloat;
   (*rho2_2) /= tmpfloat;
   (*rho3_2) /= tmpfloat;
   (*rho5_2) /= tmpfloat;
   (*rho7_2) /= tmpfloat;
   }

/   ************************************/

}			     
/**************************************************************************************************************************
 **************************************************************************************************************************/
float get_reflectance(int AOTR_flag, int16 *mode1, float *mode2, int row, int col)
/*
!C*****************************************************************************
!Description:  get_reflectance()

               Gets the averaged 500m reflectance that corresponds to the 1km row, col.

!Input Parameters:

!Output Parameters:

!Input/Output Parameters:
   none

!Returns:
   the averaged 500m reflectance at this 1km row, col.

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

   This needs to be made into the triangular function, not simply 2x2.

 
!END****************************************************************************/
{
float ret;
int localrow, r;
long index;

r = row*2;
ret = 0.0F;
for (localrow = r; localrow < (r+2); localrow++) {
   index = (localrow*NBSPOTS_500M) + (col*2);

   if (AOTR_flag == 1) {   /* we are using floating-point inputs */
       ret += mode2[index];
       ret += mode2[index+1];
   }
   else {                  /* we are using int16 inputs */
       ret += (float)mode1[index]/REFSCALE;
       ret += (float)mode1[index+1]/REFSCALE;
   }

    }
    
ret /= 4.0F;
return(ret);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
void get_internal_cloud_mask(int scan_number, int AOTR_flag, dims_struct *local_input, dims_struct *local_output, 
                             float tmp5band[7][NBSCANS_500M*NBSPOTS_500M], float tmp1band[7][NBSCANS_1KM*NBSPOTS_1KM], float *ft2m,
			     float *fmuv, float *spres, float *fsrftmp, int16 *inband26, int use_intcm_as_MOD35)
/*
!C*****************************************************************************
!Description:  get_internal_cloud_mask()

!Input Parameters:

!Output Parameters:

!Input/Output Parameters:
   none

!Returns:
   nothing

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
!END****************************************************************************/
{
int i, j, cloud, row, col;
double b1, b2, b3, b5, b6, b7;
float b26, b31, b32, b20a, T, surftemp;
double num, den;
short n67i, n56i, n52i;
int16 *band1, *band2, *band3, *band5, *band6, *band7, *band20a, *band26;
float *fband1, *fband2, *fband3, *fband5, *fband6, *fband7, *fband26;
uint16 *band31, *band32;
uint16 *state, *retr_cm;
float RA, VRA;                      /* reflective anomaly, visible reflective anomaly */
float height_threshold = 1500.0F;
int LWC, IHC, CLEAR, SNOW, FIRE, GLINT, DUST, CIRRUS, PAN;
float get_reflectance(int AOTR_flag, int16 *mode1, float *mode2, int row, int col);

band20a = local_output->data[BAND20ALB];
state = local_output->data[STATE];
retr_cm = local_output->data[AOTCM];

if /*(AOTR_flag == 0)*/(AOTR_flag != 1) {
   /*band1 = local_output->data[BAND1_500M];
   band2 = local_output->data[BAND2_500M];*/
   
   band1 = local_output->data[BAND1_1KM];
   band2 = local_output->data[BAND2_1KM];
   band3 = local_output->data[BAND3_1KM];
   band5 = local_output->data[BAND5_1KM];
   band6 = local_output->data[BAND6_1KM];
   band7 = local_output->data[BAND7_1KM];
   band26 = local_output->data[BAND26];
   band31 = local_output->data[BAND31];
   band32 = local_output->data[BAND32];
/*if (scan_number == 0)printf("%p %p %p %p %p %p %d %p %p\n", band1, band2, band3, band5, band6, band7, band7[0], band20a, band26);*/
}
else {
   /*fband1 = tmp5band[0];
   fband2 = tmp5band[1];*/
   
   fband1 = tmp1band[0];
   fband2 = tmp1band[1];
   fband3 = tmp1band[2];
   fband5 = tmp1band[4];
   fband6 = tmp1band[5];
   fband7 = tmp1band[6];
   band26 = inband26;    /* ICM needs corrected band26, no matter what */
   band31 = local_input->data[BAND31];
   band32 = local_input->data[BAND32];
/*if (scan_number == 0)printf("%p %p %p %p %p %p %f %p %p\n", fband1, fband2, fband3, fband5, fband6, fband7, fband7[0], band20a, band26);*/
}
/*if (scan_number == 0)printf("%p %p\n",  band31, band32);*/
/*if (scan_number == 0)printf("%p %p\n",  state, retr_cm);*/

height_threshold = expf(-height_threshold/8000.0F);   /* not necessary when we get actual height
                                                         in here (and not surface pressure) */

for (i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) {
    row = i/NBSPOTS_1KM;
    col = i%NBSPOTS_1KM;

    cloud = 0;
    b20a = (float)band20a[i]/REFSCALE;

    /*  These routines assume b1 and b2 need to be aggregated from 
        500m data, which is wrong.  Just use native 1km data.
    b1 = get_reflectance(AOTR_flag, band1, fband1, row, col);
    b2 = get_reflectance(AOTR_flag, band2, fband2, row, col);
    */
    
    if (AOTR_flag == 1) {
        b1 =  fband1[i];
        b2 =  fband2[i];
        b3 =  fband3[i]; 
        b5 =  fband5[i]; 
        b6 =  fband6[i]; 
        b7 =  fband7[i]; 
        }
    else {
        b1 =  (float)band1[i];
        b2 =  (float)band2[i];
        b3 =  (float)band3[i]; 
        b5 =  (float)band5[i]; 
        b6 =  (float)band6[i]; 
        b7 =  (float)band7[i]; 
        }
    
    b26 = (float)band26[i];
    b31 = (float)band31[i]/100.0F;
    b32 = (float)band32[i]/100.0F;
    
    T = ft2m[i];
    
    surftemp = fsrftmp[i];

/*
    if (sat_type == 0)  / * 26-JUN-02: terra * /
        RA = b20a - (0.82F*b7 - 0.32F*b6);
    else                / * 26-JUN-02: assume aqua, don't use band 6 * /
        RA = b20a - (0.22F*b7);
*/ 

    /* 01-FEB-05: new */
    RA = b20a - (0.149975F*b7 + (2.58535e-01*b7*b7)) ; 
 
    VRA = b3 - (b1/2.0F);
    LWC = IHC = CLEAR = SNOW = FIRE = GLINT = CIRRUS = PAN = -1;  /* init value */

/*if ((scan_number==193)&&(i==11818))printf( "VRA %f  RA %f  b1 %f b3 %f b20a %f 0.8... %f b6 %f b7 %f  b26 %f \n%f %f %f\n", 
      VRA, RA,b1, b3, b20a,(0.0687147F*b7 + (7.03762e-01*b7*b7)),b6,b7, b26, surftemp, T,surftemp - T); */
    DUST = 0;
    if(ACTUALLANDCHECK(state[i])){  /* land */
        if (( ( (VRA > 0.02F) && (RA > 0.035)) || (VRA > 0.2F)) && ((surftemp - T) < -5.0F)) {
	    /* 22-OCT-01: seems to be cloud, but check for dust first */
	    if ( ((surftemp - T) > -15.0F) && (b26 < 150.0F) &&
	       ( (b20a/b7) > 0.9) ) {
	       DUST = 1;
	       LWC = 0;
		}
            else
	       LWC = 1;
	    }
	else LWC = 0;
    }
    else{  /* ocean */
        if (( ( (VRA > 0.02F) && (RA > 0.035)) || (VRA > 0.2F)) && ((surftemp - T) < -3.0F)) {
	    /* 22-OCT-01: seems to be cloud, but check for dust first */
	    if ( ((surftemp - T) > -15.0F) && (b26 < 150.0F) &&
	       ( (b20a/b7) > 0.9F) ) {
	       DUST = 1;
	       LWC = 0;
		}
            else
	       LWC = 1;
	    }
	else LWC = 0;
    }


    if(ACTUALLANDCHECK(state[i])){    /* land */
      if (spres[i] > height_threshold) {     /* below 1500 m */

          /* 11-MAR-02: commented out VRA test, as cirrus over bright desert scenes were not getting
	      caught because VRA wasn't over 0.02 (more like e. g. 0.018951 in one case) */
	  /* 25-OCT-02: changed cirrus threshold from 150 to 75 */
          if (  /*(VRA > 0.02F) &&*/ (b26 > 75.0F) && ((surftemp - T) < -2.0F)) IHC = 1;  /* -5.0 -> -2.0 on 22-SEP-03 */
	  else IHC = 0;
      }
      else{  /* above 1500 m */   /* 300 -> 150 29-OCT-02 */
          if (  /*(VRA > 0.02F) &&*/ (b26 > 150.0F) && ((surftemp - T) < -5.0F)) IHC = 1;
	  else IHC = 0;
      }
    }
    else{  /* ocean */
      if ((b26 > 50.0F) && ((surftemp - T) < -5.0F)) IHC = 1;
      else IHC = 0;
    }
    

    if ((VRA < 0.02F) && (b26 < 150.0F) && ((surftemp - T) > 0.0F) && (RA < 0.05)) CLEAR = 1;
    else CLEAR = 0;

    if ((LWC == 0) && (IHC == 0) &&    /* not cloudy */
        (VRA > 0.02) && (b31 < 280) && (b2 > 0.2F) && (b5/b2 < 0.8F)) SNOW = 1;
    else SNOW = 0;
    
    if ((LWC != 1) && (IHC != 1))  {
       if ((RA > 0.10F) && ((surftemp - T) > 2.0F)) FIRE = 1;
       else FIRE = 0;
    
       if ((RA > 0.10F) && ((surftemp - T) <= 2.0F)) GLINT = 1;
       else GLINT = 0;
    }
    else {
       FIRE = 0;
       GLINT = 0;
    }
    
    /* new, 25-NOV-02: cirrus tests */
    if ((LWC == 0) && (IHC == 1))  {
        CIRRUS = 0;
        if ((b26 > 75)&&(b26 <= 125)) CIRRUS = 1; /*sqc1km_state[i]|=QASCIRRUS;*/
        else if ((b26 > 125)&&(b26 <= 200)) CIRRUS = 2; /*sqc1km_state[i]|=QAMCIRRUS;*/
        else if (b26 > 200) CIRRUS = 3; /*sqc1km_state[i]|=QALCIRRUS;*/
    }
    
    if ((FIRE == 1) || (GLINT == 1)) CLEAR = 0;
    
    if ((LWC == -1) || (IHC == -1) || (CLEAR == -1) || (FIRE == -1) || (SNOW == -1) || (GLINT == -1))
      { /* do nothing for now */
      }
    if ((LWC == 1) || (IHC == 1)) cloud = 1;
    
    /* new, 10-JAN-03: PAN (ephemeral water?) tests */
    if (sat_type == 0)  {   /* TERRA ONLY for now */
      num = den = (double)b6;
      num -= (double)b7;
      den += (double)b7;
      if (den != 0.0) 
          n67i=(short)((1000.0*num)/den);
      else 
          n67i=-99;
	  
      num = den = (double)b5;
      num -= (double)b2;
      den += (double)b2;
      if (den != 0.0) 
          n52i=(short)((1000.0*num)/den);
      else 
          n52i=-99;
	  
      num = den = (double)b5;
      num -= (double)b6;
      den += (double)b6;
      if (den != 0.0) 
          n56i=(short)((1000.0*num)/den);
      else 
          n56i=-99;
	  
      if ((n67i > 150)&&(n52i < 50)&&(n56i < 100)) PAN = 1;
      else if ((n67i > 150)&&(n52i < -200)) PAN = 1;
      else PAN = 0;
    
      if(!ACTUALLANDCHECK(state[i])) PAN = 0;
      else if((cloud)||(SNOW)) PAN = 0;
        }
    else PAN = 0;
 
/*if ((scan_number==40)&&(i==(6*1354)+519))
   printf( "%f %f %f %f %f %f\n%d %d %d\n %d %d %d %d %d %d %d %d %d %d\n", b1,b2,b3,b5,b6,b7,  n67i, n56i, n52i,cloud, CLEAR, IHC,LWC,SNOW,FIRE,GLINT,DUST,CIRRUS,PAN);  
  */ 
    if (AOTR_flag == 1) {
       retr_cm[i] |= cloud;
       retr_cm[i] |= CLEAR<<1;
       retr_cm[i] |= IHC<<2;
       retr_cm[i] |= LWC<<3;
       retr_cm[i] |= SNOW<<4;
       retr_cm[i] |= FIRE<<5;
       retr_cm[i] |= GLINT<<6;
       retr_cm[i] |= DUST<<7;
       if (CIRRUS > -1) retr_cm[i] |= CIRRUS<<10;
       retr_cm[i] |= PAN<<12;
    }


    if(cloud){
         if (use_intcm_as_MOD35 != 0) state[i]|=OISCLOUD1KM; /* "MOD35" cloud mask */
         state[i]|=QAINTCM;   /* internal cloud mask */
         /*if(bands[BANDS250]){
	  for(j=0;j<16;j++)sqc250m[locator250[index250m+j]]|=OISCLOUD250M;
                            }*/
	               
             }

    if (CIRRUS > -1) state[i] |= CIRRUS<<8;
    if(SNOW == 1) state[i] |= QAINTSNOW;  /* internal snow mask */
    }

/* 30-OCT-02: Now, for each value of sqc1km_state flagged as cloudy, flag all 3 by 3 adjacent 
   RETR_CM values for "adjacent cloud" IF they aren't already clouds themselves. *   /
  for(row=1;row<NBSCANS_1KM-1;row++){
     for(col=1;col<NBSPOTS_1KM-1;col++){
        i = row*NBSPOTS_1KM + col;
	if ( (state[i]&QAINTCM) != 0 ) {
	    if (!(retr_cm[i-1]%2)) retr_cm[i-1] |= 512;
	    if (!(retr_cm[i+1]%2)) retr_cm[i+1] |= 512;
	    j = i - NBSPOTS_1KM;
	    if (!(retr_cm[j-1]%2)) retr_cm[j-1] |= 512;
	    if (!(retr_cm[j]%2)) retr_cm[j]     |= 512;
	    if (!(retr_cm[j+1]%2)) retr_cm[j+1] |= 512;
	    j = i + NBSPOTS_1KM;
	    if (!(retr_cm[j-1]%2)) retr_cm[j-1] |= 512;
	    if (!(retr_cm[j]%2)) retr_cm[j]     |= 512;
	    if (!(retr_cm[j+1]%2)) retr_cm[j+1] |= 512;
	    }
     }
  }
/   * NO.  As of v5.3.6 (05-JUN-06) do this immediately prior to interpolation
    * on an entire dataset, not on  a scan-by-scan basis..
    *  14-JUN-06: added routine get_parameter_fill_values(), to replace parameter 
    *  values with valid fill values over cloud-adjacent pixels, because those pixels
    *  were no longer being identified as such HERE, and we were getting retrieval
    *  at cloud-adjacent pixels in routine aerosol_retreival().  
    */

}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int check_geolocation(int scan_number, float *lat, float *lon, float *sz, float *vz, float *sa, float *va, int32 *highsolarzenith)
/*
!C*****************************************************************************
!Description:  check_geolocation(): provides sanity checks on geolocation.

!Input Parameters:

!Output Parameters:

!Input/Output Parameters:

!Returns:
   0     OK
   1     problem with Latitude
   2                  longitude
   3                  solar azimuth
   4                  view azimuth
   5                  solar zenith
   6                  view zenith

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
!END****************************************************************************/
{
int i, flag;
float flat, flon, fsz, fsa, fvz, fva;
char text[4];
char msg[PGS_SMF_MAX_MSG_SIZE]; 
char location[100] = "atmcor.c, check_geolocation\0";

for (i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) {
    flag = 0;
    flat = lat[i];
    flon = lon[i];
    fsz = sz[i];
    fsa = sa[i];
    fvz = vz[i];
    fva = va[i];
    if ((flat < -90.0F)||(flat > 90.0F)) {flag = 1; strcpy(text, "LAT\0");}
    if ((flon < -180.0F)||(flon > 180.0F)) {flag = 2; strcpy(text, "LON\0");}
    if ((fsa < -360.0F)||(fsa > 360.0F)) {flag = 3; strcpy(text, "SA\0");}
    if ((fva < -360.0F)||(fva > 360.0F)) {flag = 4; strcpy(text, "VA\0");}
    if (fsz < 0.0F) {flag = 5; strcpy(text, "SZ\0");}
    if (fvz < 0.0F) {flag = 6; strcpy(text, "VZ\0");}
    
    if(fsz >= HIGHSOLARZENITH)(*highsolarzenith)++;
    
    if (flag != 0) {
        sprintf(msg, "%s: scan is not atmospherically corrected", text);
	modsmf(MODIS_E_BAD_GEOLOCATION, msg, location);
	return(flag); 
       }
   }
/* if you're still here ... */
return(0); 
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
void get_band20_albedo(uint16 *band20, uint16 *band21, uint16 *band31, uint16 *band32, int16 *band20albedo,
                       float *fmus, float *fmuv, float *fwv, uint16 *stateqa, int total_1km_pixels, int scan)
/*
!C*****************************************************************************
!Description:  get_band20_albedo()

!Input Parameters:

!Output Parameters:

!Input/Output Parameters:

!Returns:
   nothing

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
!END****************************************************************************/
{
float64 c1, c2;
float64 k1=1.1910659e-5;         /* units: mW/(m^2 sr cm^-4) */
float64 k2=1.438833;             /* units: cm K              */
float64 band20_albedo;
float64 b20, b21, b31, b32;
int i, saturated, detector, j;
float64 calc_albedo(float64 T3, float64 T4, float64 T5, float64 fmus, float64 fmuv, float64 uH2O, 
                    float64 c1, float64 c2, int ls);
float64 local_lambdas[BANDPROCESS-BAND20+1][10];

/* precompute Planck function constants as well, 
   since T3 wavenumber is constant
   BUT WHAT IF WE HAVE TO USE BAND21????? * /
*  c1 = k1*(T3_WAVENUMBER*T3_WAVENUMBER*T3_WAVENUMBER);
*  c2 = k2*T3_WAVENUMBER;
* No. 12-MAY-04, made this change: calc_albedo() will use newPlanckFunction() with
* arguments of temperature and wavelength: pass it wavelength in place of c1, and
* let c2 be unused.
***********************************************************************************/
if (sat_type == 0) {
    for(i=0;i<BANDPROCESS-BAND20+1;i++) 
        for(j=0;j<10;j++) local_lambdas[i][j] = terra_lambdas[i][j];
    }
else if (sat_type == 1) {
    for(i=0;i<BANDPROCESS-BAND20+1;i++) 
        for(j=0;j<10;j++) local_lambdas[i][j] = aqua_lambdas[i][j];
    }

if ((band20 != NULL)&&(band21 != NULL)&&(band31 != NULL)&&(band32 != NULL)&&(band20albedo != NULL)) {   /* should be nonNULL during BOTH passes */

     for (i=0;i<total_1km_pixels;i++) {
         detector = (i/NBSPOTS_1KM);
         b20 = (float64)band20[i]/100.0F;
         b21 = (float64)band21[i]/100.0F;
         b31 = (float64)band31[i]/100.0F;
         b32 = (float64)band32[i]/100.0F;
         saturated = 1;

	 if ((b20 < 333.0F)&&(!NearlyZero(b20))) {
             saturated = 0;
	     band20_albedo = calc_albedo( b20, b31, b32, (float64)fmus[i], (float64)fmuv[i], 
	                                 (float64)fwv[i], local_lambdas[0][detector], c2, ACTUALLANDCHECK(stateqa[i]));
             if (band20_albedo < 3.2767F) 
                 band20albedo[i] =  (int16)((float64)band20_albedo*(float64)REFSCALE);
             else 
                 band20albedo[i] =  (int16)DATAFILLVALUE;
            }
	 if (saturated == 1) {
             saturated = 0;
	     band20_albedo = calc_albedo( b21, b31, b32, (float64)fmus[i], (float64)fmuv[i], 
	                                 (float64)fwv[i], local_lambdas[1][detector], c2, ACTUALLANDCHECK(stateqa[i]));
             if (band20_albedo < 3.2767F) 
                 band20albedo[i] =  (int16)((float64)band20_albedo*(float64)REFSCALE);
             else 
                 band20albedo[i] =  (int16)DATAFILLVALUE;
            }

       } /* for (i=0;i<total_1km_pixels;i++) */
   }
  
}		       
/**************************************************************************************************************************
 **************************************************************************************************************************/
float64 calc_albedo(float64 T3, float64 T4, float64 T5, float64 fmus, float64 fmuv, float64 uH2O, 
                    float64 lambda, float64 c2, int ls)
/*
!C*****************************************************************************
!Description:  calc_albedo()
	Calculates band20 albedo

!Input Parameters:

!Output Parameters:

!Input/Output Parameters:
   none

!Returns:
   band 20 albedo

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END

****************************************************************************/
{
float64 k1=1.1910659e-5;         /* units: mW/(m^2 sr cm^-4) */
float64 k2=1.438833;             /* units: cm K              */
float64 T3E, R3E, R3, CH3A=0.0F;
float64 LT4, Ldiff;
float64 m0,m1,m2;
float64 trans_m, trans_term1, trans_term2, trans_term3, trans_m_water, trans, local_water; 
extern float dsol;

/* 04-OCT-01: skip if solar zenith is too high: 0.2588 is cosine of 75 degrees. */
if (fmus < 0.2588F) return(CH3A);

/* 06-SEP-01; new values from Eric */
m0 = m2 = 0.000F;
m1 = 3.07345F;

/* 01-JUN-04; even newer values from Eric */
m0 = 0.000F;
m2 = 0.00315392F;
m1 = 2.30976F;

Ldiff = (T4-T5)*100.0;
LT4   = T4*100.0;

/*T3E = T4 + m0 + (m1*(T4-T5)) + (m2*(T4-T5)*(T4-T5));   /  * from PFII also */
T3E = LT4 + m0 + (m1*(Ldiff)) + (m2*(Ldiff)*(Ldiff));   /* 17-FEB-05 */
T3E /= 100.0;

/*R3E = PlanckFunction(c1, c2, T3E);
 *R3  = PlanckFunction(c1, c2, T3);
 * No, as of 12-MAY-04, will do this:
 *************************************/
R3E = newPlanckFunction(T3E, lambda);
R3  = newPlanckFunction(T3, lambda);
 
trans_m = (1.0F/fmus) + (1.0F/fmuv);

local_water=uH2O;
if (local_water < 0.0F) local_water = 0.0F;

trans_m_water = trans_m*local_water;
trans_term1 = exp(-trans_m * 0.04065F);
trans_term2 = exp(-0.0572967F * pow(trans_m_water, 0.745438F));
trans_term3 = exp(-0.00174718F * pow(trans_m_water, 1.26441F));
trans = trans_term1*trans_term2*trans_term3;

CH3A = ((M_PI*(R3 - R3E))/(trans*K*dsol*fmus));

/*printf("%7.4f %7.4f %7.4f %6.4f %6.4f %f %6.4F ==> %6.4f\n", T3, T4, T5, fmus, dsol, trans, uH2O, CH3A);*/
return(CH3A);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
void band18_19_water_vapor(int scan_number, float *band18, float *band19, float *fmus, float *fmuv, float *fwv, int total_1km_pixels)
/*
!C*****************************************************************************
!Description:  band18_19_water_vapor()
	Gets water vapor from bands 18 and 19 and angles.

!Input Parameters:
   band18                 
   band19
   fmus
   fmuv
   total_1km_pixels

!Output Parameters:
   fwv               unscaled, raw water vapor data.
   
!Input/Output Parameters:
   none

!Returns:
   nothing

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END

****************************************************************************/
{
float local_water_a;
float local_water_b;
float R18, R19, log_ratio;
int index1km;
/* This rewrite doesn't handle saturated values like regular PGE11.  
 * In PGE11, sat. values in L1B are cast into signed integers and wind up
 * negative.  Here they aren't being cast like that, so you have to test for
 * saturation a little more explicitly.
 */
float SATVAL = ((float)SATURATED_VALUE/(float)REFSCALE);
 
if ((band18 != NULL)&&(band19 != NULL)) {   /* should be nonNULL during BOTH passes */
     local_water_a = -5.124F;
     local_water_b = 9.292F;
     for (index1km=0;index1km<total_1km_pixels;index1km++) {
 
                R19 = band19[index1km];
                R18 = band18[index1km];
                if ((R19 > 0.05F)&&(R18 != SATVAL)&&(R19 != SATVAL)){
                    log_ratio = logf(R18/R19);
                    fwv[index1km] = (local_water_a*log_ratio + local_water_b*log_ratio*log_ratio)/
		                     ((1.0F/fmus[index1km]) + (1.0F/fmuv[index1km])) ;
               }
       }
    } /* else, use what's there already (NCEP) */
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
void atmcor_extra(int scan_number, int band, dims_struct *input, dims_struct *output, float *sz, float *vz, float *lat, float *lon, 
                  float *fmus, float *fmuv, float *ffsfv, float *spres, float *sa, float *va, float *fuw, float *fvw, float *rhog,
		  int16 *band26)
/*
!C*****************************************************************************
!Description:  atmcor_extra()
	Corrects thermal bands and bands 8 and 26.

!Input Parameters:

!Output Parameters:
   
!Input/Output Parameters:
   none

!Returns:
   nothing

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END

****************************************************************************/
{
uint16 *tmp_input, *band5;
int16 *tmp_output;
float *tmpf_output;
float64 scale, offset, invfmus;
uint16 scratchspace[NBSCANS_1KM*NBSPOTS_1KM];
float b5, b26, sat_values[BANDPROCESS];
int i, j, index1km, row, ret;
long longret;
float32 taup_r, fts, ftv, ffs_fv, f_muv, f_mus, PHIV, scan_line_orientation, ZAOI;
float32 step1, step2, step3;
int32 newflag;
float32 exp1, exp2;
int16 tmpint;
uint16 tmpuint;
float32 tmpflt;
int N_SUN, N_SIDE, SAT, pol_corr = 1;
float windspeed, az_wind, az_sun_az_wind, rho_g;
void sunglint(float *windspeed, float *az_sun_az_wind, float *cfts, float *cftv, float *cffsfv, float *rho_g);

/* Courtesy Chris Moeller, U. Mad. */
float32 band26_coeff[NBSCANS_1KM] = {0.021F, 0.015F, 0.013F, 0.012F, 0.012F, 
                                     0.013F, 0.014F, 0.016F, 0.020F, 0.031F};   
float32 Es = 354.92F;
extern float dsol;
extern int bad_geoloc;
float64 local_lambdas[BANDPROCESS-BAND20+1][10];

/*               for {BAND8,    BAND_18,  BAND_19}; */
int dex;
float32 tau_r[3]   = {0.31418F, 0.01140F, 0.01120F};
float32 Rayleigh[3]= {0.00000F, 0.0F,     0.0F    };
void get_pol_corr_angles(float *PHIV, float *ZAOI, int i, float *lat, float *lon, float *sa, float *va, 
                         float *scan_line_orientation, int *N_SUN, int *N_SIDE);

ret=0;
longret=0L;

/* for conversion of thermal bands */
for (i=0;i<BANDPROCESS;i++) {
    sat_values[i] = 0.0F;
    }
sat_values[BAND20] = 333.0F;
sat_values[BAND21] = 429.0F;   
sat_values[BAND22] = 329.0F;   
sat_values[BAND23] = 318.0F;   
sat_values[BAND29] = 330.0F;
sat_values[BAND31] = 378.0F;
sat_values[BAND32] = 419.0F;
if (sat_type == 0) {
    for(i=0;i<BANDPROCESS-BAND20+1;i++) 
        for(j=0;j<10;j++) local_lambdas[i][j] = terra_lambdas[i][j];
    }
else if (sat_type == 1) {
    for(i=0;i<BANDPROCESS-BAND20+1;i++) 
        for(j=0;j<10;j++) local_lambdas[i][j] = aqua_lambdas[i][j];
    }


tmp_input = input->data[band];
tmp_output = output->data[band];
scale = (float64)input->radscale[band];
offset = (float64)input->radoffset[band];

switch (band) {  /* should be BAND8 ... BANDPROCESS-1 */
/*   case BAND8:*/
   case BAND18:
   case BAND19:

        SAT = SATURATED_VALUE;
	if (band==BAND8) SAT -= 3;
	
	if (band == BAND8) dex = 0;
	else if (band == BAND18) dex = 1;
	else if (band == BAND19) dex = 2;
	
	
        if ((band==BAND18)||(band==BAND19))tmpf_output = output->data[band];   /* these will be floats */

 /*if (scan_number == 0)printf("%d %p %p\n", band, tmpf_output, tmp_output); */
        for (i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) {
	  taup_r = tau_r[dex]*spres[i];
          fts = sz[i];
	  ftv = vz[i];
	  ffs_fv = ffsfv[i];
	  
	  if ((band==BAND8)&&(pol_corr)&&(bad_geoloc==0)) get_pol_corr_angles(&PHIV, &ZAOI, i, lat, lon, sa, va, &scan_line_orientation, &N_SUN, &N_SIDE);
	  
	  f_muv = fmuv[i];
	  f_mus = fmus[i];
	  if (fts >= HIGHSOLARZENITH) {
              if (band==BAND8) {if (tmp_input != NULL)  tmp_input[i] = (int16)REFSCALE; }  /* OVERWRITE THE INPUTS */
              else             {if (tmpf_output != NULL)  tmpf_output[i] = 0.0F;}
	      continue;
	      }
	  newflag = 1;

	  chand(&ffs_fv,&f_muv,&f_mus,&taup_r,&step1,&newflag,&exp1,&exp2);
	  
	  step2 =  ((TWO_THIRDS+f_muv)+(TWO_THIRDS-f_muv)*exp1)/(FOUR_THIRDS+taup_r);
	  step2 *= ((TWO_THIRDS+f_mus)+(TWO_THIRDS-f_mus)*exp2)/(FOUR_THIRDS+taup_r);
	  
	  step3 = Rayleigh[dex];
	  
	  if (NearlyZero(step2)) tmpuint = (uint16)SATURATED_VALUE;
	  else                   tmpuint = tmp_input[i];
	  tmpflt = (float)0.0F; 
	  
	  if (tmpuint < SAT) {
	    tmpflt = ((float32)tmpuint - input->refoffset[band])*input->refscale[band];
	    
	    if(bad_geoloc==0){
              tmpflt /= f_mus;
	      if (tmpflt>=3.2767F) tmpflt = ((float64)DATAFILLVALUE/(float64)REFSCALE);
	      else {

	        if ((band==BAND8)&&(pol_corr)) {
	          ret = polarization_coefficient(sz[i], vz[i], PHIV, ((i/NBSPOTS_1KM)%NBSCANS_1KM), ZAOI, scan_line_orientation,
		                                 N_SIDE, N_SUN, &step1);
	          longret += (long)ret;
		  if (ret) step1 = 0.00000F;  /* in case of problems */
				}
	        tmpflt -= step1;  
	        tmpflt /= step2;
	        tmpflt /= (1.0F + (step3*tmpflt));   /* Step3 is ZERO for bands 8, 18 and 19 */
 
                 }
	       }
	      } 
	  else 
	      tmpflt = ((float64)SATURATED_VALUE/(float64)REFSCALE);
	      
	  if (band==BAND8) { /* OVERWRITE THE INPUTS */
	       if (tmpflt>=3.2767F)  tmp_input[i] = (int16)SATURATED_VALUE;
	       else                  tmp_input[i] = (int16)((tmpflt*REFSCALE)+0.5F); 
		           } 
          else {
	       if (tmpf_output != NULL)  tmpf_output[i] = tmpflt; 
	       }

         }
        break;
	
   case BAND26:
        band5 = input->data[BAND5_1KM];
        for (index1km=0;index1km<NBSCANS_1KM*NBSPOTS_1KM;index1km++) {
	
	    if ((tmp_input[index1km] == L1BMISSING) ||
	        (tmp_input[index1km] & L1BPROBINDICATOR)) {     /* 21-JUN-05 */
               if (tmp_output != NULL)  tmp_output[index1km] = (int16)0; 
               else                     band26[index1km] = (int16)0;    /* first pass! */
	       continue;
	       }	       

            fts = sz[index1km];
	    if (fts >= HIGHSOLARZENITH) {
               if (tmp_output != NULL)  tmp_output[index1km] = tmp_input[index1km];  /* pass thru raw Band 26 unchanged */
               else                     band26[index1km] = tmp_input[index1km];    
	       continue;
	       }
	       
            row=index1km/NBSPOTS_1KM;
	        
	    if (band26corr == 0) {    /* to-be-corrected */ 
               b26 = (((float)tmp_input[index1km] - input->radoffset[BAND26])*input->radscale[BAND26]);
               b5  = (((float)band5[index1km] - input->radoffset[BAND5_1KM])*input->radscale[BAND5_1KM]);
               b26 = b26 - (b5 * band26_coeff[row]);
		
 	       /* and convert to reflectance with invfmus (dsol != 1.0) */
	       b26 = (PI*b26)/(fmus[index1km]*dsol*Es);
               }
	    else {
               b26 = (((float)tmp_input[index1km] - input->refoffset[BAND26])*input->refscale[BAND26]);
   	       b26 = b26/fmus[index1km];
	       }
	    	    
            if (tmp_output != NULL)  tmp_output[index1km] = (int16)(b26*REFSCALE); 
            else                     band26[index1km] = (int16)(b26*REFSCALE);    /* first pass! */

 	    }
        break;
	
   case BAND20:
   case BAND21:
   case BAND22:
   case BAND23:
   case BAND29:
   case BAND31:
   case BAND32:  
	for (index1km=0;index1km<NBSCANS_1KM*NBSPOTS_1KM;index1km++) {
            scratchspace[index1km] = tmp_input[index1km]; 
 	    }

        /* convert to brightness temperatures... BUT keep original-read inputs intact... */
	for(j=0;j<NBSCANS_1KM;j++) {
	   cnvt_data_to_temp(scratchspace+(j*NBSPOTS_1KM), offset, scale, NBSPOTS_1KM, sat_values[band], local_lambdas[band-BAND20][j]);
	   }

        /* actually, don't keep original-read inputs intact... overwrite it. */
	for (index1km=0;index1km<NBSCANS_1KM*NBSPOTS_1KM;index1km++) {
           tmp_input[index1km] = scratchspace[index1km]; 
 	   }
		
	if (tmp_output != NULL) {   /* it will be NULL during aerosol retrieval, nonNULL during aerosol correction */
	    for (index1km=0;index1km<NBSCANS_1KM*NBSPOTS_1KM;index1km++) {
               tmp_output[index1km] = (int16)scratchspace[index1km]; 
 	       }
	   }
	break;          
   default:  
        break;
  }
  
/* now get sunglint data */

if (band == BAND32) {	/* 01-FEB-05: ONLY NEED TO DO THIS ONCE! */
for (i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) {	
   rho_g = 0.0F;
   fts = sz[i];
   ftv = vz[i];
   ffs_fv = ffsfv[i];
   az_sun_az_wind = sa[i]; /* solar azimuth (deg) */
   if ( (az_sun_az_wind < -360.0F) || (az_sun_az_wind > 360.0F) ) {  
	   /* then there's something wrong somewhere; use windspeed of 7.0 and az_sun_az_wind of 0.0 */
	   windspeed = 7.0F;
	   az_sun_az_wind = 0.0F;
 	}
   else {  /* note: if there was an error in interpolating the uwnd or vwnd, they will have a fill value (7.0) */
	   windspeed = sqrtf(fuw[i]*fuw[i] + fvw[i]*fvw[i]);
	   az_wind = RAD2DEG*atan2f(fuw[i], fvw[i]);
	   az_sun_az_wind -= az_wind;
	}
   sunglint(&windspeed,&az_sun_az_wind,&fts,&ftv,&ffs_fv,&rho_g);
   rhog[i] = rho_g;
   }
}
  
if (longret > 0L) {
      modsmf((PGSt_SMF_code)MODIS_E_FUNCTION_ERROR, 
        "problem with polarization correction, band 8", "atmcor.c, atmcor_extra\0");
	}
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
void get_pol_corr_angles(float *PHIV, float *ZAOI, int i, float *lat, float *lon, float *sa, float *va, 
                         float *scan_line_orientation, int *N_SUN, int *N_SIDE)
/*
!C*****************************************************************************
!Description:  get_pol_corr_angles()
	Gets angles and such for polarization correction.

!Input Parameters:

!Output Parameters:
   
!Input/Output Parameters:
   none

!Returns:
   nothing

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END

****************************************************************************/
{
int row, col;
float dlat, dlon, az_pol, phisat;

*PHIV = (sa[i] - va[i]) - 180.0F;
if (*PHIV < -180.0F) *PHIV = *PHIV + 360.0F;
else if (*PHIV > 180.0F) *PHIV = *PHIV - 360.0F;
	    
row=i/NBSPOTS_1KM;
col=i%NBSPOTS_1KM;

dlon = DEG2RAD*lon[col] - DEG2RAD*lon[(NBSCANS_1KM-1)*NBSPOTS_1KM + col];
if (fabsf(dlon) > 1.75F*PI) {
	/* adjust for dateline */
	if (dlon >= 0.)
	    	    dlon = dlon - 2.0F*PI;
	else
		    dlon = dlon + 2.0F*PI;
     }

dlat = DEG2RAD*lat[col] - DEG2RAD*lat[(NBSCANS_1KM-1)*NBSPOTS_1KM + col];

az_pol = atan2f(dlon, dlat);	/* Scan orientation angle */ 
    
/* and phisat */
phisat = DEG2RAD*(float)va[((NBSCANS_1KM-1)-row)*NBSPOTS_1KM + col];

phisat += PI;
if (phisat < -PI)     phisat += 2.0F*PI;      /* Put in [-PI,PI] */
else if (phisat > PI) phisat -= 2.0F*PI;      /* Put in [-PI,PI] */

*scan_line_orientation = (phisat/DEG2RAD) - (az_pol/DEG2RAD) - 90.0F;
	    
/* 22-JAN-03: figure out the "side of the sun" */
if (lat[i] > 30.) *N_SUN = 0;          /*  pixel is north of sun  */
else if (lat[i] < -30.) *N_SUN = 1;    /*  pixel is south of sun  */
else {
	if (sa[i] <= 90.) *N_SUN = 1;
	else              *N_SUN = 0;
     }

*ZAOI = (float32)(10.5 + ((float)(col)/(float)(NBSPOTS_1KM))*(55.0));
*N_SIDE = (row/NBSCANS_1KM)%2;

}

/**************************************************************************************************************************
 **************************************************************************************************************************/
int correct_with_new_LUTs(int scan_number, int AOTR_flag, int rez, void *vsqc, int total_1km_pixels, dims_struct *local_input, dims_struct *local_output, 
                          float tmp500band[7][NBSCANS_500M*NBSPOTS_500M], float tmp1kband[7][NBSCANS_1KM*NBSPOTS_1KM],float *sz, float *vz, float *fmus, float *ffsfv, 
                          int16 *aotone, int16 *aotthree, int16 *aoteight, float *fwv, float *fO3, float *fsp, uint16 *stateqa, uint8 *aotmodel)
{
int band, zb_band, ib, index, n;
float32 *scale, *offset;
uint16 **banddata, xxx;
int16 **corrband;
int16 band8value;
float32 xts,xtv,xfi,raot550nm,uwv,uoz,pres,invfmus,inv_ftarget;
float32 tau1, tau3;
float tn;
float32 ar_rotoa[NBANDS];
float32 rotoa;
float32 ar_roslamb[NBANDS];
extern float32 tauray[NBANDS];
extern float32 oztransa[NBANDS];
extern float32 wvtransa[NBANDS],wvtransb[NBANDS],wvtransc[NBANDS];
extern float32 ogtransa0[NBANDS],ogtransa1[NBANDS];
extern float32 ogtransb0[NBANDS],ogtransb1[NBANDS];
extern float32 ogtransc0[NBANDS],ogtransc1[NBANDS];
extern float32 nbfi[NTS][NXX],tsmax[NTS][NXX],tsmin[NTS][NXX];
extern float32 ttv[NTS][NXX],nbfic[NTS][NXX];
extern float32 tts[NTS];
extern int indts[NTS];
extern float32 rolutt[NBANDS][NPR][NAOT][8000];
extern float32 transt[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbt[NBANDS][NPR][NAOT];  
extern float32 roluttSMKL[NBANDS][NPR][NAOT][8000];
extern float32 transtSMKL[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtSMKL[NBANDS][NPR][NAOT];  
extern float32 roluttSMKH[NBANDS][NPR][NAOT][8000];
extern float32 transtSMKH[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtSMKH[NBANDS][NPR][NAOT];   
extern float32 roluttDUST[NBANDS][NPR][NAOT][8000];
extern float32 transtDUST[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtDUST[NBANDS][NPR][NAOT];  
extern float32 roluttURBPOL[NBANDS][NPR][NAOT][8000];
extern float32 transtURBPOL[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtURBPOL[NBANDS][NPR][NAOT];  
extern float32 roluttURBCLN[NBANDS][NPR][NAOT][8000];
extern float32 transtURBCLN[NBANDS][NPR][NAOT][NTS];
extern float32 sphalbtURBCLN[NBANDS][NPR][NAOT];  
extern int32 dead_bands[BANDPROCESS][4 * NBSCANS_1KM];
extern int32 noisy_bands[BANDPROCESS][4 * NBSCANS_1KM];  /* 01-JAN-07 */
extern int sat_type;


char sbandname[NBANDS][6] = {"modb1 ","modb2 ","modb3 ","modb4 ","modb5 "
      ,"modb6 ","modb7 ","modb8 ","modb9 ","modb10","modb11","modb12"
      ,"modb13","modb14","modb15","modb16"};
char location[100]="atmcor.c, correct_with_new_LUTs";

extern int bad_geoloc;   /* new, 01-NOV-05 */
int onekm_row, onekm_col, onekm_index, spots, row;
int startband, endband;
uint8 aotmodel_value;
uint32 *sqc;
uint16 *qsqc;
void clamp_ref_1_OR_500(float *ref, uint32 *qc500mval, uint32 blank, uint32 qc500m_mask, uint32 modlandQA);
void clamp_ref_250(float *ref, uint16 *qc500mval, uint16 blank, uint16 qc500m_mask, uint16 modlandQA);
float newLUT_correction(float TOA, float tgo, float roatm, float ttatmg, float satm);
float tgo,roatm,ttatmg,satm,xrorayp;   /* arrays which hold this data for an entire 1km scan and all seven bands are global */
float angexp;
float32 fTOA,checkcor;
int proc_mask[7],proc;
extern float tgo_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float roatm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
extern float ttatmg_array[16][NBSPOTS_1KM*NBSCANS_1KM];
extern float satm_array[16][NBSPOTS_1KM*NBSCANS_1KM]; 
char err_msg[80];
int retval;
int at_least_one_DD_in_band6;

#if defined IRIS4 || defined LINUX
#define atmcorlamb2 atmcorlamb2_
#define atmcorocea2 atmcorocea2_
#define raycorlamb2 raycorlamb2_
#endif

if ((rez == 4) && (AOTR_flag == 1)) return;  /* no need to correct 250m data if AOT is being retrieved */

if (rez == 4) qsqc = (uint16 *)vsqc;
else           sqc = (uint32 *)vsqc;

if (rez == 4) {
    spots = NBSPOTS_250M;
    startband = BAND1_250M;
    endband = BAND1_500M;
    }
else if (rez == 2) {
    spots = NBSPOTS_500M;
    startband = BAND1_500M;
    endband = BAND1_1KM;
    }
else  {
    spots = NBSPOTS_1KM;
    startband = BAND1_1KM;
    endband = BAND18;
    }

/* 31-OCT-05 */
if (AOTR_flag == 1) {
   for (index = 0; index < total_1km_pixels; index++) aotmodel[index] = (uint8)NOMODEL;
   }

/* 21-DEC-06 */
at_least_one_DD_in_band6 = 0;
for (index = 0; index < 20; index++) if (dead_bands[BAND6_500M][index] == 1) at_least_one_DD_in_band6++;
   

offset = (float32 *)local_input->refoffset;
scale = (float32 *)local_input->refscale;
banddata = (uint16 **)local_input->data;
corrband = (int16 **)local_output->data;
n = NBANDS;

inv_ftarget = 1.0F/(cosf(TERMINATORSZ*DEG2RAD));

for (index = 0; index < total_1km_pixels*(rez*rez); index++) {

   onekm_row = (index/spots)/rez;
   onekm_col = (index%spots)/rez;
   onekm_index = onekm_row*NBSPOTS_1KM + onekm_col;
   
   invfmus = 1.0F/fmus[onekm_index];
   if ((invfmus >= inv_ftarget)||(invfmus < 0.0)) invfmus = 1.0;
   xts = sz[onekm_index];

   if (rez == 1) {        /* if rez is 1, we need to calculate all this stuff.  If it isn't, take the
                              requesite data from the global arrays tgo_array, roatm_array, et cetera... */
   
     xtv = vz[onekm_index];
     xfi = ffsfv[onekm_index];
     tau1 = (float32)(aotone[onekm_index])*0.001;
     tau3 = (float32)(aotthree[onekm_index])*0.001;
     angexp = (float)(aoteight[onekm_index])*0.001;
     /*raot550nm = (tau1+tau3)/2.0F;*/
     raot550nm = tau3;
     

     if  (AOTR_flag == 1)  {
        raot550nm = 0.000060;
	angexp = 0.000060;
	}     
     else if  (raot550nm < 1e-3)  {
        raot550nm = 0.060;     /* just some fill value */
	angexp = 0.000060;
	}
     	
     uwv = fwv[onekm_index];
     uoz = fO3[onekm_index];
     pres = fsp[onekm_index]*1013.0F;
     
     /* 31-OCT-05 */
     aotmodel_value = aotmodel[onekm_index];
     
    }
    
   for (band = startband; band < endband; band++) {
       zb_band = band-startband;
       
       xxx = banddata[band][index];
       rotoa = (((float32)xxx - offset[band])*scale[band])*invfmus;
              
        
       if (band < BAND8) {    /* QA is only for bands 1 - 7! */    
                proc_mask[zb_band] = 0;
                if(xxx & L1BPROBINDICATOR){
	               if ((AOTR_flag != 1)||(rez>1)){
			  if (rez==4) 
		              qsqc[index]|=OISBADPIXEL;
			  else 
		              sqc[index]|=OISBADPIXEL;
			      
	                  if(xxx == L1BMISSING){
			    if (rez==4) {
	                       qsqc[index]&=~(BANDQA250(0xf, band));
	                       qsqc[index]|=BANDQA250(MISSINGINPUTL1B, band);
			       }
			    else if (rez==2) {
	                       sqc[index]&=~(BANDQA500(0xf, band));
	                       sqc[index]|=BANDQA500(MISSINGINPUTL1B, band);
			       }
			    else {
	                       sqc[index]&=~(BANDQA1(0xf, band));
	                       sqc[index]|=BANDQA1(MISSINGINPUTL1B, band);
			       }
	                    }
	                  else {
			     if (rez==4)      qsqc[index]|=BANDQA250(BADL1B, band);
			     else if (rez==2) sqc[index]|=BANDQA500(BADL1B, band);
			     else             sqc[index]|=BANDQA1(BADL1B, band);
			     }
			  }
                 
                    proc_mask[zb_band] = 1;
                      }
		else {     /* new, 25-FEB-05 */                            
		       
	    	   /* skip processing if this pixel is on the terminator (sz above 86) */
	           if(sz[onekm_index] >= TERMINATORSZ){
	               if ((AOTR_flag != 1)||(rez>1)){
		          if (rez==4) {
	                     qsqc[index]|=OISBADPIXEL;
	                     qsqc[index]&=~(BANDQA250(0xf, band));
	                     qsqc[index]|=BANDQA250(TERMANGLE, band);
			     }
		          else if (rez==2) {
	                     sqc[index]|=OISBADPIXEL;
	                     sqc[index]&=~(BANDQA500(0xf, band));
	                     sqc[index]|=BANDQA500(TERMANGLE, band);
			     }
		          else {
	                     sqc[index]|=OISBADPIXEL;
	                     sqc[index]&=~(BANDQA1(0xf, band));
	                     sqc[index]|=BANDQA1(TERMANGLE, band);
			     }
			  }
                       proc_mask[zb_band] = 0;
	               } 
	    	   /* ...or has a high solar zenith angle (above 85) */
	           else if(sz[onekm_index] >= HIGHSOLARZENITH){
	               if ((AOTR_flag != 1)||(rez>1)){
		          if (rez==4) {
	                     qsqc[index]|=OISBADPIXEL;
	                     qsqc[index]&=~(BANDQA250(0xf, band));
	                     qsqc[index]|=BANDQA250(BADSOLARZENITH, band);
			     }
		          else if (rez==2) {
	                     sqc[index]|=OISBADPIXEL;
	                     sqc[index]&=~(BANDQA500(0xf, band));
	                     sqc[index]|=BANDQA500(BADSOLARZENITH, band);
			     }
		          else {
	                     sqc[index]|=OISBADPIXEL;
	                     sqc[index]&=~(BANDQA1(0xf, band));
	                     sqc[index]|=BANDQA1(BADSOLARZENITH, band);
			     }
			  }
                       proc_mask[zb_band] = 0;
	               } 
		       
                   else {
		   
                       proc_mask[zb_band] = 0;
			}
		   } /* new, 25-FEB-05 */

         }
	 
  
          ib = zb_band + 1;

          if (rez == 1) {
	  
	     if (AOTR_flag != 1) {    /* use the values we have in there already, even for 1km data (31-MAR-06) */
	        tgo = tgo_array[zb_band][onekm_index];
                roatm = roatm_array[zb_band][onekm_index];
                satm = satm_array[zb_band][onekm_index];
                ttatmg = ttatmg_array[zb_band][onekm_index];
                ar_roslamb[zb_band] = newLUT_correction(rotoa, tgo, roatm, ttatmg, satm);
	        }
             else   {       /* generate the tgo, roatm, ttatmg, etc values */
	     
	     if (bad_geoloc != 0) {  /* 01-NOV-05: atmcorlamb2, etc, can't handle funky angles */
	     
	       ar_roslamb[zb_band] = rotoa;
	       
               /*if (band < BAND8) {*/
 	         tgo_array[zb_band][index] = 1.0;
 	         roatm_array[zb_band][index] = 0.0;
 	         ttatmg_array[zb_band][index] = 1.0;
 	         satm_array[zb_band][index] = 0.0;
	         xrorayp_array[zb_band][index] = 0.0;
	        /* }*/
	        }
	     else if (xts < 80.0 && !(xxx&L1BPROBINDICATOR)) {
	  
	     retval = 0;

             if (aotmodel_value == URBC) {   /* URBANCLEAN */
               if (ACTUALLANDCHECK(stateqa[index])) {
               atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBCLN,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);  
                    }
               else {  
               atmcorocea2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBCLN,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&angexp,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
                 }
	        }
             else if (aotmodel_value == URBP) {   /* URBANPOLU */
               if (ACTUALLANDCHECK(stateqa[index])) {
               atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttURBPOL,transtURBPOL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBPOL,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);  
                    }
               else {  
               atmcorocea2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBCLN,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&angexp,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
                 }
	        }
             else if (aotmodel_value == DSST) {   /* DUST */
               if (ACTUALLANDCHECK(stateqa[index])) {
               atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttDUST,transtDUST,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtDUST,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);  
                    }
               else {  
               atmcorocea2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBCLN,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&angexp,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
                 }
	        }
             else if (aotmodel_value == SMKH) {
               if (ACTUALLANDCHECK(stateqa[index])) {
               atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttSMKH,transtSMKH,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtSMKH,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);  
                    }
               else {  
               atmcorocea2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBCLN,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&angexp,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
                 }
	        }
 	     else {  /* SMKL *OR* NOMODEL, NO aerosol retrieval whatsoever */
               if (ACTUALLANDCHECK(stateqa[index])) {
               atmcorlamb2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttSMKL,transtSMKL,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtSMKL,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval);  
                    }
               else {  
               atmcorocea2(&xts,&xtv,&xfi,&raot550nm,&ib,&pres,tpres,
                 aot550nm,roluttURBCLN,transtURBCLN,&xtsstep,&xtsmin,&xtvstep,&xtvmin,sphalbtURBCLN,
                 tsmax,tsmin,nbfic,nbfi,tts,indts,ttv,
                 &uoz,&uwv,tauray,ogtransa0,ogtransa1,ogtransb0,ogtransb1,
                 ogtransc0,ogtransc1,wvtransa,wvtransb,wvtransc,oztransa,     
     	         &rotoa,&(ar_roslamb[zb_band]),&angexp,&tgo,&roatm,&ttatmg,&satm,&xrorayp,err_msg,&retval); 
                 }
               }


	      if(retval != 0) {
                   sprintf(msg, "Error: message '%s' from routine atmcorlamb2: cannot continue \n", err_msg);
                   modsmf(MODIS_F_FUNCTION_ERROR, msg, location);
 		 }
	    
/*if ((scan_number == MYSCAN)&&(index == MYINDEX)&&(zb_band < 4)) 
   printf("XX %f .. %f %f %f %f %f %f %f\n", angexp, raot550nm, rotoa, ar_roslamb[zb_band], tgo,roatm,ttatmg,satm);*/

               /*if (band < BAND8) {*/
 	         tgo_array[zb_band][index] = tgo;
 	         roatm_array[zb_band][index] = roatm;
 	         ttatmg_array[zb_band][index] = ttatmg;
 	         satm_array[zb_band][index] = satm;
	         xrorayp_array[zb_band][index] = xrorayp;
	       /*  }*/
		   
                       }
	     else if (xts < 85.0 && !(xxx&L1BPROBINDICATOR)) {
	  
             raycorlamb2(&xts,&xtv,&xfi,&ib,&pres,
               &uoz,&uwv,tauray,
               ogtransa0,ogtransa1,ogtransb0,ogtransb1,
               ogtransc0,ogtransc1,
               wvtransa,wvtransb,wvtransc,oztransa,     
     	       &rotoa,&(ar_roslamb[zb_band]),&tgo,&roatm,&ttatmg,&satm,&xrorayp);  
	    
/*if ((scan_number == MYSCAN)&&(index == MYINDEX)&&(zb_band == 2)) 
   printf("XX %f %f %f %f %f %f .. %f %f %f \n%f %f %f %f\n", xts,xtv,xfi,pres,uoz,uwv, raot550nm, rotoa, ar_roslamb[zb_band], tgo,roatm,ttatmg,satm);*/

              /* if (band < BAND8) {*/
 	         tgo_array[zb_band][index] = tgo;
 	         roatm_array[zb_band][index] = roatm;
 	         ttatmg_array[zb_band][index] = ttatmg;
 	         satm_array[zb_band][index] = satm;
	         xrorayp_array[zb_band][index] = xrorayp;
	       /*  }*/
                       }
	     else {
	     
	       ar_roslamb[zb_band] = rotoa;
	       
              /* if (band < BAND8) {*/
 	         tgo_array[zb_band][index] = 1.0;
 	         roatm_array[zb_band][index] = 0.0;
 	         ttatmg_array[zb_band][index] = 1.0;
 	         satm_array[zb_band][index] = 0.0;
	         xrorayp_array[zb_band][index] = 0.0;
	      /*   }*/
	        }

              }  /* generate the tgo, roatm, ttatmg, etc values */
	      }  /* rez == 1 */
          else {
       
/*if ((scan_number == MYSCAN)&&(onekm_index == MYINDEX)&&(zb_band == 2)&&(rez==2)) {
   printf("qqq\n");
  }*/
                tgo = tgo_array[zb_band][onekm_index];
                roatm = roatm_array[zb_band][onekm_index];
                satm = satm_array[zb_band][onekm_index];
                ttatmg = ttatmg_array[zb_band][onekm_index];
                ar_roslamb[zb_band] = newLUT_correction(rotoa, tgo, roatm, ttatmg, satm);
			     
/*if ((scan_number == MYSCAN)&&(onekm_index == MYINDEX)&&(zb_band == 2)&&(rez==2)) {
   printf("XXX  %f %f \n%f %f %f %f\n", rotoa, newLUT_correction(rotoa, tgo, roatm, ttatmg, satm), tgo,roatm,ttatmg,satm);

}*/
             }
      
       
       if (band < BAND8) {    /* QA is only for bands 1 - 7! */    

          if (proc_mask[zb_band] == 1) {
              /* Then replace "corrected" data with fill value */
	      ar_roslamb[zb_band] = (float)DATAFILLVALUE/(float)REFSCALE;
	      		
              }
          else{

            if ((AOTR_flag != 1)||(rez>2)){
	      if (rez == 4) {
	        if (xts < 85.0) qsqc[index] |= ATMCORR250;  /* 27-JUL-06 */
	        clamp_ref_250(&(ar_roslamb[zb_band]), &(qsqc[index]), BANDQA250(0xf, band), BANDQA250(BANDPOOROUTOFBOUNDS, band),(uint16)0x1);	   
                  }
	       else if (rez == 2) {
	        if (xts < 85.0) sqc[index] |= ATMCORR500;
	        clamp_ref_1_OR_500(&(ar_roslamb[zb_band]), &(sqc[index]), BANDQA500(0xf, band), BANDQA500(BANDPOOROUTOFBOUNDS, band),(uint32)0x1);	   
                  }
               else {
	        if (xts < 85.0)  sqc[index] |= ATMCORR1;
	        clamp_ref_1_OR_500(&(ar_roslamb[zb_band]), &(sqc[index]), BANDQA1(0xf, band), BANDQA1(BANDPOOROUTOFBOUNDS, band),(uint32)0x1);		   
                    }
                 }
	       
	       }
            }
/*#ifdef LETSDOTHIS*/
       else {   /* 28-OCT-05; even tho QA is for bands 1-7, we still need to handle saturated data */
          if (xxx & L1BPROBINDICATOR) ar_roslamb[zb_band] = (float)DATAFILLVALUE/(float)REFSCALE;
            }
/*#endif*/
	    
       if (AOTR_flag != 1) {
          if (ar_roslamb[zb_band] < 0.0F) 
             corrband[band][index] = (int16)(((float64)ar_roslamb[zb_band]*(float64)REFSCALE)-0.5F);
	  else
             corrband[band][index] = (int16)(((float64)ar_roslamb[zb_band]*(float64)REFSCALE)+0.5F);
	  }
       
       if ((tmp1kband != NULL)&&(rez == 1)&&(zb_band < 7)) tmp1kband[zb_band][index] = (float)ar_roslamb[zb_band];
       else if ((tmp500band != NULL)&&(rez == 2)) tmp500band[zb_band][index] = (float)ar_roslamb[zb_band];

       /* Band 8 has to be written back to the inputs... *  /
          As of 02-NOV-05, it doesn't... 
       if (band == BAND8) banddata[band][index] = (int16)(((float64)ar_roslamb[zb_band]*(float64)REFSCALE)+0.5F);
       */

        row = index/spots;
	
	/* 04-JAN-07: removed code for setting B5/D3 to badl1b if terra and at least one dead det in band 6 */
		  
	/* 02-JAN-07 -- Will do in this order so Dead detectors take precedence over Noisy detectors
	   in case some detectors are flagged as both */
	   
        /* 02-JAN-07 -- added noisy band flagging. */          
        if ((AOTR_flag != 1)||(rez>1)){
           if ((rez == 2) && (noisy_bands[band][row])) {
	      sqc[index] &= ~(BANDQA500(0xf, band));
	      sqc[index] |= BANDQA500(NOISYDET, band);
               }
            }

        /* 15-DEC-06: FLAG DD HERE!!! */          
        if ((AOTR_flag != 1)||(rez>1)){
           if ((rez == 2) && (dead_bands[band][row])) {
	      sqc[index] &= ~(BANDQA500(0xf, band));
	      sqc[index] |= BANDQA500(DEAD, band);
               }
            }

      

   }
   }
}
		     
/**************************************************************************************************************************
 **************************************************************************************************************************/
int scale_angle_data(dims_struct *input, float *sz, float *vz, float *sa, float *va, float *fmus, 
                     float *fmuv, float *ffsfv, float *airmass)
/*
!C*****************************************************************************
!Description:  scale_angle_data()
	Returns scaled, floating-point angle data to the calling routine.  

!Input Parameters:
     input              structure holding inputs from the geolocation file.

!Output Parameters:
     sz
     vz
     sa
     va
     fmus
     fmuv
     ffsfv
     airmass
     
!Input/Output Parameters:
   none

!Returns:
   0   (only 0)

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END
 
****************************************************************************/
{
int index1km;
int16 *geo1angle, *geo2angle, *geo3angle, *geo4angle;
float n, aot550, inv_fmus, inv_fmuv;
/* for all geolocation data, one must simply remember the data is read in this order:
 *   Latitude, Longitude, Height, SensorZenith, SensorAzimuth, SolarZenith, SolarAzimuth, Land/SeaMask
 *   (e. g. see open_inputs() in modis_srefl_io.c.)
 */

geo1angle = input->data[5];
geo2angle = input->data[3];
geo3angle = input->data[6];
geo4angle = input->data[4];    

for (index1km=0;index1km<NBSCANS_1KM*NBSPOTS_1KM;index1km++) {
  
    sz[index1km] = (float)geo1angle[index1km]*input->refscale[5];
    vz[index1km] = (float)geo2angle[index1km]*input->refscale[3];
    sa[index1km] = (float)geo3angle[index1km]*input->refscale[6];
    va[index1km] = (float)geo4angle[index1km]*input->refscale[4];

    fmus[index1km] = cosf(sz[index1km]*DEG2RAD);
    inv_fmus = 1.0F/fmus[index1km];
    ffsfv[index1km] = sa[index1km] - va[index1km];
    ffsfv[index1km] = PrincipalAngle(ffsfv[index1km]);
    fmuv[index1km] = cosf(vz[index1km]*DEG2RAD);
    inv_fmuv = 1.0F/fmuv[index1km];
    airmass[index1km] = inv_fmus + inv_fmuv;
    

    }
        
return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int map_variable_data(int AOTR_flag, float *fsp, float *fwv, float *fO3, float *airmass, float *sz, float *vz, float *fmus, float *fmuv, float *ffsfv, 
                      float **tau, float **Rho_ra_term, float **Rho_r_term, float **Step1_term, float **Step2_term, float **Step3_term, 
		      float **SRA_term)
/*
!C*****************************************************************************
!Description:  map_variable_data()
	Fills up the atmospheric correction data arrays Rho_ra_term, Rho_r_term, Step1_term, Step2_term, Step3_term, and SRA_term
	for each band at 1 km.

!Input Parameters:

!Output Parameters:
     
!Input/Output Parameters:
   none

!Returns:
   0   (only 0)

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

    In case of bad geolocation -- or if we are not doing atmospheric correction--
    this routine sets Step1_term and Step3_term to 1 and everything else to 0.
    
!END
 
****************************************************************************/
{
extern t_atmospars atmos;
int i, j, index1km, newflag;
float uCH4, uNO2, uCO2, uO2, taup_r, S_r, S_r0, ftemp, ftemphalf, tghalfH2O, exp1, exp2, tmpf;
float STEP1, STEP2, STEP3, RHO_RA, RHO_R, RHOP_R, T_R, T_A, S_RA, TGH2O;
float n, aot550, inv_fmus, inv_fmuv;
extern float32 Sra_tab[7][10];
extern float32 *sref[7];
extern float32 *ta_tab[7];
extern int bad_geoloc;
float local_airmass, local_tau_band1, local_tau_band3, local_sz, local_vz, local_ffsfv, local_fmuv, local_fmus, local_fwv;
float32 xaH2O,xbH2O,xcH2O;
float32 xaO3;
float32 xaCO2,xbCO2;
float32 xcCO2,xdCO2;
float32 xaO2,xbO2;
float32 xcO2,xdO2;
float32 xaNO2,xbNO2;
float32 xcNO2,xdNO2;
float32 xaCH4,xbCH4;
float32 xcCH4,xdCH4;
float32 tau_r;
float32 *surfrefl, *ta_table;
float32 Sra_table[10];

if ((commands.ref_lam == 0)||(bad_geoloc)) {       /* forget about it! */
   for(i=BAND1;i<=BAND7;i++) {
     for (index1km=0;index1km<NBSCANS_1KM*NBSPOTS_1KM;index1km++) {
	Rho_ra_term[i][index1km] = 0.00000F;
	Rho_r_term[i][index1km]  = 0.00000F;
	Step1_term[i][index1km]  = 1.00000F; 
	Step2_term[i][index1km]  = 0.00000F;
	Step3_term[i][index1km]  = 1.00000F;
	SRA_term[i][index1km]    = 0.00000F;
        }
     }
return(0);
}

for(i=BAND1;i<=BAND7;i++) {
        
	tau_r = atmos.tau_r[i];
        xaO2 = atmos.xaO2[i];
        xbO2 = atmos.xbO2[i];
        xcO2 = atmos.xcO2[i];
        xdO2 = atmos.xdO2[i];
        xaO3 = atmos.xaO3[i];
        xaCO2 = atmos.xaCO2[i];
        xbCO2 = atmos.xbCO2[i];
        xcCO2 = atmos.xcCO2[i];
        xdCO2 = atmos.xdCO2[i];
        xaNO2 = atmos.xaNO2[i];
        xbNO2 = atmos.xbNO2[i];
        xcNO2 = atmos.xcNO2[i];
        xdNO2 = atmos.xdNO2[i];
        xaCH4 = atmos.xaCH4[i];
        xbCH4 = atmos.xbCH4[i];
        xcCH4 = atmos.xcCH4[i];
        xdCH4 = atmos.xdCH4[i];
        xaH2O = atmos.xaH2O[i];
        xbH2O = atmos.xbH2O[i];
        xcH2O = atmos.xcH2O[i];
	surfrefl = sref[i];
	ta_table = ta_tab[i];
	for(j=0;j<10;j++)Sra_table[j] = Sra_tab[i][j];
	
for (index1km=0;index1km<NBSCANS_1KM*NBSPOTS_1KM;index1km++) {

        inv_fmus = 1.0F/fmus[index1km];
        inv_fmuv = 1.0F/fmuv[index1km];
        local_airmass = airmass[index1km];
	local_tau_band1 = tau[BAND1][index1km];
	local_tau_band3 = tau[BAND3][index1km];
	local_sz = sz[index1km];
	local_vz = vz[index1km];
	local_ffsfv = ffsfv[index1km];
	local_fmuv = fmuv[index1km];
	local_fmus = fmus[index1km];
	local_fwv = fwv[index1km];
	
        uCH4 = uNO2 = uCO2 = uO2 = fsp[index1km];
        taup_r = tau_r*fsp[index1km];

	STEP1=(1.0F + xaO2*powf(local_airmass,xbO2)*(1.0F/(1.0F + xcO2*uO2 + xdO2*uO2*uO2)-1.0F));
	  
	STEP1*=(expf(-xaO3*(local_airmass*fO3[index1km])));
	  
	STEP1*=(1.0F + xaCO2*powf(local_airmass,xbCO2)*(1.0F/(1.0F + xcCO2*uCO2 + xdCO2*uCO2*uCO2)-1.0F));

	STEP1*=(1.0F + xaNO2*powf(local_airmass,xbNO2)*(1.0F/(1.0F + xcNO2*uNO2 + xdNO2*uNO2*uNO2)-1.0F));
	  
	STEP1*=(1.0F + xaCH4*powf(local_airmass,xbCH4)*(1.0F/(1.0F + xcCH4*uCH4 + xdCH4*uCH4*uCH4)-1.0F));
 
        n = logf(local_tau_band1/local_tau_band3) * 3.061719F;
        aot550 = local_tau_band1 * expf(n * -0.160881F);

	if (AOTR_flag == 1) {
	    interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv,0.0001F);
                }
	else {   
	    if (i==BAND1) {
	      interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv, (local_tau_band1/c550_to_band1));
 	       }
	    else if (i==BAND3) {
	      interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv, (local_tau_band3/c550_to_band3));
 	       }
	    else if ((i==BAND6)||(i==BAND7)) {
	      interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv,0.0001F);
 	       }
	    else   
	      interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv,aot550);
            }

	 newflag = 1;
	 chand(&local_ffsfv,&local_fmuv,&local_fmus,&tau_r,&RHO_R, &newflag, &exp1, &exp2);

         /* 07-AUG-01 */
         interrefl(surfrefl,&RHO_R,local_sz,local_vz,local_ffsfv,0.0001F);


	 newflag = 0;
	 chand(&local_ffsfv,&local_fmuv,&local_fmus,&taup_r,&RHOP_R, &newflag, &exp1, &exp2);
	  
	 /* downward */
	 T_R=(((TWO_THIRDS+local_fmuv)+(TWO_THIRDS-local_fmuv)*exp1)/(FOUR_THIRDS+taup_r));

	 /* upward */
	 T_R*=(((TWO_THIRDS+local_fmus)+(TWO_THIRDS-local_fmus)*exp2)/(FOUR_THIRDS+taup_r));
	 
	 

	  if (AOTR_flag == 1) {
	     interatrans(ta_table,&T_A,local_sz,0.0001F);
	     interatrans(ta_table,&tmpf,local_vz,0.0001F);
                }
	  else {   
	     if (i==BAND1) {
	       interatrans(ta_table,&T_A,local_sz,(local_tau_band1/c550_to_band1));
	       interatrans(ta_table,&tmpf,local_vz,(local_tau_band1/c550_to_band1));
               }
	     else if (i==BAND3) {
	       interatrans(ta_table,&T_A,local_sz,(local_tau_band3/c550_to_band3));
	       interatrans(ta_table,&tmpf,local_vz,(local_tau_band3/c550_to_band3));
               }
	     else if ((i==BAND6)||(i==BAND7)) {
	       interatrans(ta_table,&T_A,local_sz,0.0001F);
	       interatrans(ta_table,&tmpf,local_vz,0.0001F);
	       }
	     else {
	       interatrans(ta_table,&T_A,local_sz,aot550);
	       interatrans(ta_table,&tmpf,local_vz,aot550);
	       }
	    }
	  T_A *= tmpf;
	    

	  if (AOTR_flag == 1) {
	       interSra(Sra_table,0.0001F,&S_RA);
                }
	  else {   
	     if (i==BAND1) 
	         interSra(Sra_table,(local_tau_band1/c550_to_band1),&S_RA);
	     else if (i==BAND3) 
	         interSra(Sra_table,(local_tau_band3/c550_to_band3),&S_RA);
	     else if ((i==BAND6)||(i==BAND7)) 
	         interSra(Sra_table,0.0001F,&S_RA);
	     else
	         interSra(Sra_table,aot550,&S_RA); 
              }
	      
	  csalbr(&taup_r,&S_r);
	  
	  csalbr(&tau_r,&S_r0);
	  if (!NearlyZero(S_r0))
	    S_RA = S_RA + S_r - S_r0;
	  else
	    S_RA = 0.0F;

     /*if ((i==BAND3)&&(index1km==(4*1354)+1154)) {
         printf("  ****** ->  RHO_R = %f, RHO_RA = %f, RHOP_R = %f, TRANSMISSION_R = %f TRANSMISSION1*TRANSMISSION2 = %f S_RA = %f TAU = %f\n",
	              RHO_R,RHO_RA,RHOP_R,T_R,T_A,S_RA,local_tau_band3); 
      }*/  



	if ( !NearlyZero(xaH2O) &&  ( (local_airmass*local_fwv) > 0.000F) ) /* new, 23-APR-01: to keep NANs out of data */ {
	  
	  ftemp = logf(local_airmass*local_fwv);
	  ftemphalf = logf(local_airmass*0.5*local_fwv);
	  
	  TGH2O=expf(-expf(xaH2O + xbH2O*ftemp + xcH2O*ftemp*ftemp));
	  
	  tghalfH2O=expf(-expf(xaH2O + xbH2O*ftemphalf + xcH2O*ftemphalf*ftemphalf));
	}
	else {
	  TGH2O = 1.0F;
	  tghalfH2O = 1.0F;
	}
	
	STEP2=((RHO_RA-RHO_R)*tghalfH2O + RHOP_R);
	STEP3=(T_R*T_A*TGH2O);
        
	Rho_ra_term[i][index1km] = RHO_RA;
	Rho_r_term[i][index1km]  = RHO_R;
	Step1_term[i][index1km]  = STEP1; 
	Step2_term[i][index1km]  = STEP2;
	Step3_term[i][index1km]  = STEP3;
	SRA_term[i][index1km]    = S_RA;

    }
    }
return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int map_local_variables(float fsp, float fwv, float fO3, float airmass, float sz, float vz, float fmus, float fmuv, float ffsfv, 
                        float tau1, float tau3, float *Rho_ra_term, float *Rho_r_term, float *Step1_term, float *Step2_term, 
			float *Step3_term, float *SRA_term)
/*
!C*****************************************************************************
!Description:  map_local_variables()
	Fills up the atmospheric correction data arrays Rho_ra_term, Rho_r_term, Step1_term, Step2_term, Step3_term, and SRA_term
	for each band at 1 km, BUT FOR ONLY ONE PIXEL.  Assumes AOT is being used.

!Input Parameters:

!Output Parameters:
     
!Input/Output Parameters:
   none

!Returns:
   0   (only 0)

!Revision History:

Revision 1.0, J. Ray, 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

    In case of bad geolocation -- or if we are not doing atmospheric correction--
    this routine sets Step1_term and Step3_term to 1 and everything else to 0.
    
!END
 
****************************************************************************/
{
extern t_atmospars atmos;
int i, j, newflag;
float uCH4, uNO2, uCO2, uO2, taup_r, S_r, S_r0, ftemp, ftemphalf, tghalfH2O, exp1, exp2, tmpf;
float STEP1, STEP2, STEP3, RHO_RA, RHO_R, RHOP_R, T_R, T_A, S_RA, TGH2O;
float n, aot550, inv_fmus, inv_fmuv;
extern float32 Sra_tab[7][10];
extern float32 *sref[7];
extern float32 *ta_tab[7];
extern int bad_geoloc;
float local_airmass, local_tau_band1, local_tau_band3, local_sz, local_vz, local_ffsfv, local_fmuv, local_fmus, local_fwv;
float32 xaH2O,xbH2O,xcH2O;
float32 xaO3;
float32 xaCO2,xbCO2;
float32 xcCO2,xdCO2;
float32 xaO2,xbO2;
float32 xcO2,xdO2;
float32 xaNO2,xbNO2;
float32 xcNO2,xdNO2;
float32 xaCH4,xbCH4;
float32 xcCH4,xdCH4;
float32 tau_r;
float32 *surfrefl, *ta_table;
float32 Sra_table[10];

for(i=BAND1;i<=BAND7;i++) {
        
	tau_r = atmos.tau_r[i];
        xaO2 = atmos.xaO2[i];
        xbO2 = atmos.xbO2[i];
        xcO2 = atmos.xcO2[i];
        xdO2 = atmos.xdO2[i];
        xaO3 = atmos.xaO3[i];
        xaCO2 = atmos.xaCO2[i];
        xbCO2 = atmos.xbCO2[i];
        xcCO2 = atmos.xcCO2[i];
        xdCO2 = atmos.xdCO2[i];
        xaNO2 = atmos.xaNO2[i];
        xbNO2 = atmos.xbNO2[i];
        xcNO2 = atmos.xcNO2[i];
        xdNO2 = atmos.xdNO2[i];
        xaCH4 = atmos.xaCH4[i];
        xbCH4 = atmos.xbCH4[i];
        xcCH4 = atmos.xcCH4[i];
        xdCH4 = atmos.xdCH4[i];
        xaH2O = atmos.xaH2O[i];
        xbH2O = atmos.xbH2O[i];
        xcH2O = atmos.xcH2O[i];
	surfrefl = sref[i];
	ta_table = ta_tab[i];
	for(j=0;j<10;j++)Sra_table[j] = Sra_tab[i][j];
	

        inv_fmus = 1.0F/fmus;
        inv_fmuv = 1.0F/fmuv;
        local_airmass = airmass;
	local_tau_band1 = tau1;
	local_tau_band3 = tau3;
	local_sz = sz;
	local_vz = vz;
	local_ffsfv = ffsfv;
	local_fmuv = fmuv;
	local_fmus = fmus;
	local_fwv = fwv;
	
        uCH4 = uNO2 = uCO2 = uO2 = fsp;
        taup_r = tau_r*fsp;

	STEP1=(1.0F + xaO2*powf(local_airmass,xbO2)*(1.0F/(1.0F + xcO2*uO2 + xdO2*uO2*uO2)-1.0F));
	  
	STEP1*=(expf(-xaO3*(local_airmass*fO3)));
	  
	STEP1*=(1.0F + xaCO2*powf(local_airmass,xbCO2)*(1.0F/(1.0F + xcCO2*uCO2 + xdCO2*uCO2*uCO2)-1.0F));

	STEP1*=(1.0F + xaNO2*powf(local_airmass,xbNO2)*(1.0F/(1.0F + xcNO2*uNO2 + xdNO2*uNO2*uNO2)-1.0F));
	  
	STEP1*=(1.0F + xaCH4*powf(local_airmass,xbCH4)*(1.0F/(1.0F + xcCH4*uCH4 + xdCH4*uCH4*uCH4)-1.0F));
 
        aot550 = 0.000F;
        if (local_tau_band3 > 0.0F) {
           n = logf(local_tau_band1/local_tau_band3) * 3.061719F;
           aot550 = local_tau_band1 * expf(n * -0.160881F);
          }
	  
	    if (i==BAND1) {
	      interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv, (local_tau_band1/c550_to_band1));
 	       }
	    else if (i==BAND3) {
	      interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv, (local_tau_band3/c550_to_band3));
 	       }
	    else if ((i==BAND6)||(i==BAND7)) {
	      interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv,0.0001F);
 	       }
	    else   
	      interrefl(surfrefl,&RHO_RA,local_sz,local_vz,local_ffsfv,aot550);
            

	 newflag = 1;
	 chand(&local_ffsfv,&local_fmuv,&local_fmus,&tau_r,&RHO_R, &newflag, &exp1, &exp2);

         /* 07-AUG-01 */
         interrefl(surfrefl,&RHO_R,local_sz,local_vz,local_ffsfv,0.0001F);


	 newflag = 0;
	 chand(&local_ffsfv,&local_fmuv,&local_fmus,&taup_r,&RHOP_R, &newflag, &exp1, &exp2);
	  
	 /* downward */
	 T_R=(((TWO_THIRDS+local_fmuv)+(TWO_THIRDS-local_fmuv)*exp1)/(FOUR_THIRDS+taup_r));

	 /* upward */
	 T_R*=(((TWO_THIRDS+local_fmus)+(TWO_THIRDS-local_fmus)*exp2)/(FOUR_THIRDS+taup_r));
	 
	 

	     if (i==BAND1) {
	       interatrans(ta_table,&T_A,local_sz,(local_tau_band1/c550_to_band1));
	       interatrans(ta_table,&tmpf,local_vz,(local_tau_band1/c550_to_band1));
               }
	     else if (i==BAND3) {
	       interatrans(ta_table,&T_A,local_sz,(local_tau_band3/c550_to_band3));
	       interatrans(ta_table,&tmpf,local_vz,(local_tau_band3/c550_to_band3));
               }
	     else if ((i==BAND6)||(i==BAND7)) {
	       interatrans(ta_table,&T_A,local_sz,0.0001F);
	       interatrans(ta_table,&tmpf,local_vz,0.0001F);
	       }
	     else {
	       interatrans(ta_table,&T_A,local_sz,aot550);
	       interatrans(ta_table,&tmpf,local_vz,aot550);
	       }
	  T_A *= tmpf;
	    
	     if (i==BAND1) 
	         interSra(Sra_table,(local_tau_band1/c550_to_band1),&S_RA);
	     else if (i==BAND3) 
	         interSra(Sra_table,(local_tau_band3/c550_to_band3),&S_RA);
	     else if ((i==BAND6)||(i==BAND7)) 
	         interSra(Sra_table,0.0001F,&S_RA);
	     else
	         interSra(Sra_table,aot550,&S_RA); 
              
	      
	  csalbr(&taup_r,&S_r);
	  
	  csalbr(&tau_r,&S_r0);
	  if (!NearlyZero(S_r0))
	    S_RA = S_RA + S_r - S_r0;
	  else
	    S_RA = 0.0F;

	if ( !NearlyZero(xaH2O) &&  ( (local_airmass*local_fwv) > 0.000F) ) /* new, 23-APR-01: to keep NANs out of data */ {
	  
	  ftemp = logf(local_airmass*local_fwv);
	  ftemphalf = logf(local_airmass*0.5*local_fwv);
	  
	  TGH2O=expf(-expf(xaH2O + xbH2O*ftemp + xcH2O*ftemp*ftemp));
	  
	  tghalfH2O=expf(-expf(xaH2O + xbH2O*ftemphalf + xcH2O*ftemphalf*ftemphalf));
	}
	else {
	  TGH2O = 1.0F;
	  tghalfH2O = 1.0F;
	}
	
	STEP2=((RHO_RA-RHO_R)*tghalfH2O + RHOP_R);
	STEP3=(T_R*T_A*TGH2O);
        
	Rho_ra_term[i] = RHO_RA;
	Rho_r_term[i]  = RHO_R;
	Step1_term[i]  = STEP1; 
	Step2_term[i]  = STEP2;
	Step3_term[i]  = STEP3;
	SRA_term[i]    = S_RA;

    
    }
return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int make_coarse_resolution_output(dims_struct **local_output, float *lat, float *lon, float *sz, float *vz, float *ffsfv, int nb1kmcols, int nblines, 
                              int nbcols, float *fcoarse, float *fO3, float *fwv, float *fsp, float *fslp, float *ft2m, float *NCEPwv, float *fuw, float *fvw)
/*
!C****************************************************************************

!Routine: make_coarse_resolution_output()

!Description: Makes coarse resolution outputs for ancillary data during daytime.

!Input Parameters:
  float *lat
  float *lon
  int nb1kmcols
  int nblines
  int nbcols
  float *fO3         }
  float *fwv         } the parameters being coarsened
  float *fsp         }
  float *fslp        }  New, 12-JUN-06: mean sea level pressure.
  float *ft2m        }
  float *NCEPwv      } 
  float *fuw         }
  float *fvw         } 
    
!Input/Output Parameters:
  float *fcoarse                 scratch space for coarse resolution floats 
  dims_struct **local_output     coarse-resolution buffers are loaded
  
!Output Parameters:
  none

!Returns:
  0
  
!Revision History:
  Revision 1.0  01-APR-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
            called by routine atmcorrect() (atmcor.c)

!END**************************************************************************/
{
uint8 *coarse;
uint16 *uintcoarse;
int indexcr;

  /* make into coarse rez... */
  fcoarsen(fO3, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, fcoarse);
  /* and scale it */
  coarse=local_output[1]->data[OZONE];
  for (indexcr=0;indexcr<nblines*nbcols;indexcr++) {
    coarse[indexcr] = (uint8)(fcoarse[indexcr]*400.0);
      }
      
  /* and so on */
  fcoarsen(fsp, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, fcoarse);
  coarse=local_output[1]->data[SURFP];
  for (indexcr=0;indexcr<nblines*nbcols;indexcr++) {
    coarse[indexcr] = (uint8)(fcoarse[indexcr]*200.0);
      }
  /* new, 12-JUN-06 */ 
  fcoarsen(fslp, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, fcoarse);
  coarse=local_output[1]->data[SLEVP];
  for (indexcr=0;indexcr<nblines*nbcols;indexcr++) {
    coarse[indexcr] = (uint8)(fcoarse[indexcr]*200.0);
      }
      
  fcoarsen(ft2m, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, fcoarse);
  uintcoarse=local_output[1]->data[AIR_TEMP];
  for (indexcr=0;indexcr<nblines*nbcols;indexcr++) {
    uintcoarse[indexcr] = (uint16)(fcoarse[indexcr]*100.0);
      }
  fcoarsen(fwv, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, fcoarse);
  uintcoarse=local_output[1]->data[WATERVAPOR];
  for (indexcr=0;indexcr<nblines*nbcols;indexcr++) {
    uintcoarse[indexcr] = (uint16)(fcoarse[indexcr]*100.0);
      }
  fcoarsen(NCEPwv, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, fcoarse);
  coarse=local_output[1]->data[NCEPWATERVAPOR];
  for (indexcr=0;indexcr<nblines*nbcols;indexcr++) {
    coarse[indexcr] = (uint8)(fcoarse[indexcr]*50.0);
      } 
  /* Coarse-resolution lat/lon, etc., into output */
  fcoarsen(lat, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[LAT]);
  fcoarsen(lon, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[LON]);
  fcoarsen(sz, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[SOLZ]);
  fcoarsen(vz, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[SATZ]);
  fcoarsen(ffsfv, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[RPHI]);
  fcoarsen(fuw, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[U_WND]);
  fcoarsen(fvw, NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[V_WND]);
  
  /* Coarse-resolution AOT into output */
  coarsen(local_output[0]->data[AOT_1], NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[AOT_1]);
  coarsen(local_output[0]->data[AOT_3], NBSCANS_1KM, nb1kmcols, SREFL_COARSESIZE, nblines, nbcols, local_output[1]->data[AOT_3]);

return(0);
}
/**************************************************************************************************************************
 **************************************************************************************************************************/
int get_day_night(char *daynightflag)
/*
!C****************************************************************************

!Routine: get_day_night()

!Description: Figures out what daynightflag says.

!Input Parameters:
  char *daynightflag               
  
!Input/Output Parameters:

!Output Parameters:
  none

!Returns:
  1 for day or both 
  0 for night or undefined
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
 
!END**************************************************************************/
{
/* 1 for day or both, 0 for night or undefined */
char local[20];
int i;

for(i=0;i<strlen(daynightflag);i++) local[i] = toupper(daynightflag[i]); 
local[i] = '\0';
if ((!strcmp(local, "NIGHT")) || (!strcmp(local, "UNDEFINED")))  return 0;
else return 1;
}

void night_coarse_output(dims_struct *rad1km_input, dims_struct *geo_input, dims_struct *output, int *local_process_bands)
/*
!C****************************************************************************

!Routine: night_coarse_output()

!Description: Does limited coarse resolution processing at night (thermal bands).

!Input Parameters:
  dims_struct *rad1km_input      1km L1B input
  dims_struct *geo_input         geolocation input
  int *local_process_bands       to process band or not (actually, not quite necessary)
  
!Input/Output Parameters:
  dims_struct *output            the output structure (SDSs in it are written to)

!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
            called by routine atmospheric_correction() (atmcor.c)

!END

**************************************************************************/
{
int i,j,ii,n_scans,nbcols,nblines;
int32 start[3], dims[3];
int32 estart[2], edims[2], sds;
int32 ostart[2], odims[2];
char lgid[30];
float sat_values[BANDPROCESS];
char location[100]="atmcor.c, night_coarse_output";
/*extern output_type_t output_type[ALLBANDS]; GLOBAL */
float64 local_lambdas[BANDPROCESS-BAND20+1][10];
float64 scale, offset;

n_scans = rad1km_input->nblines/NBSCANS_1KM;

if(NBSCANS_1KM % SREFL_COARSESIZE == 0) nblines = NBSCANS_1KM/SREFL_COARSESIZE;
else nblines=((int32)(NBSCANS_1KM/SREFL_COARSESIZE))+1;
nbcols = ((int32)(NBSPOTS_1KM/SREFL_COARSESIZE)) +1;

for (i=0;i<BANDPROCESS;i++) {
    sat_values[i] = 0.0F;
    }
sat_values[BAND20] = 999.0F;   /* not available */
sat_values[BAND29] = 330.0F;
sat_values[BAND31] = 378.0F;
sat_values[BAND32] = 999.0F;   /* not available */
if (sat_type == 0) {
    for(i=0;i<BANDPROCESS-BAND20+1;i++) 
        for(j=0;j<10;j++) local_lambdas[i][j] = terra_lambdas[i][j];
    }
else if (sat_type == 1) {
    for(i=0;i<BANDPROCESS-BAND20+1;i++) 
        for(j=0;j<10;j++) local_lambdas[i][j] = aqua_lambdas[i][j];
    }

/* for each band... */
for (i=BAND20;i<BANDPROCESS;i++) {
   
   if ((output_type[i].DN != NIGHT_ONLY)&&(output_type[i].DN != DNBOTH)) continue;
   if ((output_type[i].FC != COARSE_ONLY)&&(output_type[i].FC != FCBOTH)) continue;

   start[0] = rad1km_input->sds_offset[i];
   dims[0] = 1;
   start[2] = 0;
   dims[1] = NBSCANS_1KM;
   dims[2] = rad1km_input->nbcols;
   scale = (float64)rad1km_input->radscale[i];
   offset = (float64)rad1km_input->radoffset[i];

   rad1km_input->data[i] = (uint16 *)AllocMem(NBSCANS_1KM*rad1km_input->nbcols*sizeof(rad1km_input->type[i]), location);
   output->data[i] = (uint16 *)AllocMem(nblines*nbcols*sizeof(rad1km_input->type[i]), location);

   ostart[1] = 0;
   odims[0] = nblines;
   odims[1] = nbcols;
             
   /* for each scan... */
   for (j=0;j<n_scans;j++) {
   
        start[1] = j*NBSCANS_1KM;
       
        /* read the data... */
        SDreaddata(rad1km_input->sdsid[i], start, NULL, dims, (VOID *)rad1km_input->data[i]);
            
        /* convert to brightness temperatures... */
	for (ii=0;ii<NBSCANS_1KM;ii++) {
	    cnvt_data_to_temp((uint16 *)(rad1km_input->data[i])+(ii*rad1km_input->nbcols), offset, scale, NBSPOTS_1KM, sat_values[i], local_lambdas[i-BAND20][ii]);
             }
	     
        /* make into coarse rez... */
	ucoarsen(rad1km_input->data[i], NBSCANS_1KM, rad1km_input->nbcols, SREFL_COARSESIZE, nblines, nbcols, output->data[i]);

        ostart[0] = j*nblines;
        SDwritedata(output->sdsid[i], ostart, NULL, odims, (VOID *)output->data[i]);
      
      }  /* for (j=0;j<n_scans;j++) */
     
    free(rad1km_input->data[i]);
    free(output->data[i]);

}  /* for (i=0;i<BANDPROCESS;i++) */

/* for lat and lon... */
/* for all geolocation data, one must simply remember the data is read in this order:
 *   Latitude, Longitude, Height, SensorZenith, SensorAzimuth, SolarZenith, SolarAzimuth, Land/SeaMask
 */
for (i=LAT;i<TRBAND1;i++) {
   
   if ((output_type[i].DN != NIGHT_ONLY)&&(output_type[i].DN != DNBOTH)) continue;
   if ((output_type[i].FC != COARSE_ONLY)&&(output_type[i].FC != FCBOTH)) continue;

   ii = i-LAT;
   if (i==CRSQA) ii = 7;   /* land/sea mask */
   
   estart[1] = 0;
   edims[0] = NBSCANS_1KM;
   edims[1] = geo_input->nbcols;
   
   if (ii < 2) {
      geo_input->data[ii] = (float *)AllocMem(NBSCANS_1KM*geo_input->nbcols*sizeof(geo_input->type[ii]), location);
      output->data[i] = (float *)AllocMem(nblines*nbcols*sizeof(geo_input->type[i]), location);
      }
   else {
      geo_input->data[ii] = (uint8 *)AllocMem(NBSCANS_1KM*geo_input->nbcols*sizeof(geo_input->type[ii]), location);
      output->data[i] = (uint8 *)AllocMem(nblines*nbcols*sizeof(geo_input->type[i]), location);
      }
      
   ostart[1] = 0;
   odims[0] = nblines;
   odims[1] = nbcols;
             
   /* for each scan... */
   for (j=0;j<n_scans;j++) {
   
        estart[0] = j*NBSCANS_1KM;
       
        /* read the data... */
        SDreaddata(geo_input->sdsid[ii], estart, NULL, edims, (VOID *)geo_input->data[ii]);
                    
        if (ii<2) /* make into coarse rez... */
	   fcoarsen(geo_input->data[ii], NBSCANS_1KM, geo_input->nbcols, SREFL_COARSESIZE, nblines, nbcols, output->data[i]);
        else
	   make_night_coarse_qa(geo_input->data[ii], NBSCANS_1KM, geo_input->nbcols, SREFL_COARSESIZE, nblines, nbcols, output->data[i]);

        ostart[0] = j*nblines;
        SDwritedata(output->sdsid[i], ostart, NULL, odims, (VOID *)output->data[i]);
      
      }  /* for (j=0;j<n_scans;j++) */
     
    free(geo_input->data[ii]);
    free(output->data[i]);

}  /* for (i=LAT;i<ALLBANDS;i++) */

}


void make_night_coarse_qa(uint8 *fine, int nlines_fine, int nbcols_fine, int factor, int nlines_coarse, int nbcols_coarse, uint8 *coarse)
/*
!C****************************************************************************

!Routine: make_night_coarse_qa()

!Description: Makes the QA for coarse resolution files at night (mainly, just a land-sea mask).

!Input Parameters:
  
!Input/Output Parameters:

!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END

**************************************************************************/
{
int h,i,j,ii,jj;
long k;
uint8 *n;

n = (uint8 *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(uint8));

jj=0;
k = 0L;
for(h=0;h<nlines_coarse;h++) {
  for(j=0;j<factor;j++) {
    for(i=0;i<nbcols_fine;i++) {
       ii = i/factor;
       if (fine[k] == 1) n[jj+ii]++;
       k++;
       }
    }
   jj = (h+1)*nbcols_coarse;
}

for(i=0;i<nlines_coarse*nbcols_coarse;i++)
   if (n[i] > 12)   /* majority */
       coarse[i] = (uint8)35;    /* land, cld not set, assumed clear */
   else
       coarse[i] = (uint8)3;     /* not land, cld not set, assumed clear */
      
free(n);
}


void fcoarsen(float *fine, int nlines_fine, int nbcols_fine, int factor, int nlines_coarse, int nbcols_coarse, float *coarse)
/*
!C****************************************************************************

!Routine: fcoarsen()

!Description: Coarsens up the floating-point data at fine, puts the results into coarse.

!Input Parameters:
      fine                     fine-resolution floating-point data
      nlines_fine              number of lines and
      nbcols_fine                        columns at the fine resolution
      factor                   
      nlines_coarse            number of lines and
      nbcols_coarse                      columns at the coarse resolution
      
!Input/Output Parameters:
       coarse                 IN: memory for coarse data, uninitialized
                              OUT: the coarse data.
!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END

**************************************************************************/
{
int h,i,j,ii,jj;
long k;
double *space;
int8 *n;

space = (double *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(double));
n = (int8 *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(int8));

jj=0;
k = 0L;
for(h=0;h<nlines_coarse;h++) {
  for(j=0;j<factor;j++) {
    for(i=0;i<nbcols_fine;i++) {
       ii = i/factor;
       space[jj+ii] += (double)fine[k];
       n[jj+ii]++;
       k++;
       }
    }
   jj = (h+1)*nbcols_coarse;
}

for(i=0;i<nlines_coarse*nbcols_coarse;i++)
   if (n[i] != 0)
       coarse[i] = (float)(space[i]/(double)n[i]);
      
free(n);
free(space);
}


void ucoarsen(uint16 *fine, int nlines_fine, int nbcols_fine, int factor, int nlines_coarse, int nbcols_coarse, uint16 *coarse)
/*
!C****************************************************************************

!Routine: ucoarsen()

!Description: Coarsens up the uint16 data at fine, puts the results into coarse.

!Input Parameters:
      fine                     fine-resolution uint16 data
      nlines_fine              number of lines and
      nbcols_fine                        columns at the fine resolution
      factor                   
      nlines_coarse            number of lines and
      nbcols_coarse                      columns at the coarse resolution
      
!Input/Output Parameters:
       coarse                 IN: memory for coarse data, uninitialized
                              OUT: the coarse data.
!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END

**************************************************************************/
{
int h,i,j,ii,jj;
long k;
long *space;
int8 *n;

space = (long *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(long));
n = (int8 *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(int8));

jj=0;
k = 0L;
for(h=0;h<nlines_coarse;h++) {
  for(j=0;j<factor;j++) {
    for(i=0;i<nbcols_fine;i++) {
       ii = i/factor;
       space[jj+ii] += (long)fine[k];
       n[jj+ii]++;
       k++;
       }
    }
   jj = (h+1)*nbcols_coarse;
}

for(i=0;i<nlines_coarse*nbcols_coarse;i++)
   if (n[i] != 0)
       coarse[i] = (uint16)(space[i]/(long)n[i]);
      
free(n);
free(space);
}


void u8coarsen(uint8 *fine, int nlines_fine, int nbcols_fine, int factor, int nlines_coarse, int nbcols_coarse, uint8 *coarse)
/*
!C****************************************************************************

!Routine: ucoarsen()

!Description: Coarsens up the uint8 data at fine, puts the results into coarse.

!Input Parameters:
      fine                     fine-resolution uint16 data
      nlines_fine              number of lines and
      nbcols_fine                        columns at the fine resolution
      factor                   
      nlines_coarse            number of lines and
      nbcols_coarse                      columns at the coarse resolution
      
!Input/Output Parameters:
       coarse                 IN: memory for coarse data, uninitialized
                              OUT: the coarse data.
!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END

**************************************************************************/
{
int h,i,j,ii,jj;
long k;
long *space;
int8 *n;

space = (long *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(long));
n = (int8 *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(int8));

jj=0;
k = 0L;
for(h=0;h<nlines_coarse;h++) {
  for(j=0;j<factor;j++) {
    for(i=0;i<nbcols_fine;i++) {
       ii = i/factor;
       space[jj+ii] += (long)fine[k];
       n[jj+ii]++;
       k++;
       }
    }
   jj = (h+1)*nbcols_coarse;
}

for(i=0;i<nlines_coarse*nbcols_coarse;i++)
   if (n[i] != 0)
       coarse[i] = (uint8)(space[i]/(long)n[i]);
      
free(n);
free(space);
}


void coarsen(int16 *fine, int nlines_fine, int nbcols_fine, int factor, int nlines_coarse, int nbcols_coarse, int16 *coarse)
/*
!C****************************************************************************

!Routine: coarsen()

!Description: Coarsens up the int16 data at fine, puts the results into coarse.

!Input Parameters:
      fine                     fine-resolution int16 data
      nlines_fine              number of lines and
      nbcols_fine                        columns at the fine resolution
      factor                   
      nlines_coarse            number of lines and
      nbcols_coarse                      columns at the coarse resolution
      
!Input/Output Parameters:
       coarse                 IN: memory for coarse data, uninitialized
                              OUT: the coarse data.
!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END

**************************************************************************/
{
int h,i,j,ii,jj;
long k;
long *space;
int8 *n;

space = (long *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(long));
n = (int8 *)CAllocMem(nlines_coarse*nbcols_coarse, sizeof(int8));

jj=0;
k = 0L;
for(h=0;h<nlines_coarse;h++) {
  for(j=0;j<factor;j++) {
    for(i=0;i<nbcols_fine;i++) {
       ii = i/factor;
       space[jj+ii] += (long)fine[k];
       n[jj+ii]++;
       k++;
       }
    }
   jj = (h+1)*nbcols_coarse;
}

for(i=0;i<nlines_coarse*nbcols_coarse;i++)
   if (n[i] != 0)
       coarse[i] = (int16)(space[i]/(long)n[i]);
      
free(n);
free(space);
}


void make_coarse_qa_and_cm(dims_struct *local_input, int nlines_fine, int nbcols_fine, int factor, int nlines_coarse, int nbcols_coarse, dims_struct *local_output)
/*
!C****************************************************************************

!Routine: make_coarse_qa_and_cm()

!Description: Coarsens up AOT QA and CM SDSs in the input.

!Input Parameters:
      local_input              structure holding the fine-resolution AOTQA, AOTCM data
      nlines_fine              number of lines and
      nbcols_fine                        columns at the fine resolution
      factor                   
      nlines_coarse            number of lines and
      nbcols_coarse                      columns at the coarse resolution
      
!Input/Output Parameters:
     local_output              structure holding the coarse-resolution AOTQA, AOTCM data

!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END

**************************************************************************/
{
#define NL 2
#define NC 271     /* Let's assume nlines_coarse = 2 and nbcols_coarse = 271, for now. */
int h,i,j,ii,jj,x,ij,n;
uint32 y;
long k;
uint16 *state;
uint32 *onekmqa;
uint8 *coarsecm;
uint8 *coarseqa;

uint8 nclear[NL*NC];
uint8 ncloud[NL*NC];
uint8 nmixed[NL*NC];
uint8 nntset[NL*NC];
uint8 ntermn[NL*NC];
uint8 nhighs[NL*NC];
uint8 nbadlb[NL*NC];
uint8 nldsea[NL*NC];
uint8 nlambe[NL*NC];
uint8 n_fire[NL*NC];
uint8 n_snow[NL*NC];

state = local_input->data[STATE];
onekmqa = local_input->data[OKMQA];
coarsecm = local_output->data[CRSCM];
coarseqa = local_output->data[CRSQA];

for(h=0;h<NL*NC;h++) {
   nclear[h] = 0;
   ncloud[h] = 0;
   nmixed[h] = 0;
   nntset[h] = 0;
   ntermn[h] = 0;
   nhighs[h] = 0;
   nbadlb[h] = 0;
   nldsea[h] = 0;
   nlambe[h] = 0;
   n_fire[h] = 0;
   n_snow[h] = 0;
   coarsecm[h] = coarseqa[h] = (uint8)0;
  }

jj=0;
k = 0L;
for(h=0;h<nlines_coarse;h++) {
  for(j=0;j<factor;j++) {
    for(i=0;i<nbcols_fine;i++) {
       ii = i/factor;
       
       x = state[k]&0x0003;     /* cloud mask */
       if (x==0) nclear[jj+ii]++;
       else if (x==1) ncloud[jj+ii]++;
       else if (x==2) nmixed[jj+ii]++;
       else if (x==3) nntset[jj+ii]++;
       
       x = (state[k]&0x0038)>>3;     /* landsea mask */
       if (x==1) nldsea[jj+ii]++;
       
       x = (state[k]&0x0800)>>11;     /* fire mask */
       if (x==1) n_fire[jj+ii]++;
       
       x = (state[k]&0x8000)>>15;     /* snow mask */
       if (x==1) n_snow[jj+ii]++;

       y = (onekmqa[k]&0x0000003c)>>2;   /* 1KM band 1 QA mask.  25-FEB-05, fixed bug (the ">>2") */
       if (y == 9) ntermn[jj+ii]++;
       else if (y == 10) nhighs[jj+ii]++;

       y = (onekmqa[k]&0x40000000)>>30;   /* 1KM atmcor performed */
       if (y == 1) nlambe[jj+ii]++;

       y = onekmqa[k];
       y = y>>2;    /* 25-FEB-05: fixed this too */
       n=0;
       for(ij=0;ij<7;ij++) {
           x = y&0xf;
	   if ((x==14)||(x==11))n++;  /* 01-MAR-05: bad L1B (14) OR MISSING L1B (11) */
           y = y>>4;
          }
       if (n>0) nbadlb[jj+ii]++;
       
       k++;
       }
    }
   jj = (h+1)*nbcols_coarse;
}

 for(h=0;h<NL*NC;h++) {
   n = 0;
   if ((nmixed[h] > 12)||
       ((nclear[h] > 0)&&(ncloud[h] > 0))) n=2;
   else if (ncloud[h] > 12 ) n=1;
   else if (nclear[h] > 12 ) n=0;
   else n=3;
   coarseqa[h] |= n;

   n = 0;
   if (ncloud[h] > 12 ) n=3;
   else if ((ncloud[h] > 2 ) && (ncloud[h] < 12)) n=2;
   else if ((ncloud[h] > 0 ) && (ncloud[h] < 2)) n=1;
   else n=0;
   coarsecm[h] |= n;

   if (n_snow[h] > 12 ) coarsecm[h] |= 0x4;
   
   if (ntermn[h] > 12 ) coarseqa[h] |= 0x4;
   if (nhighs[h] > 12 ) coarseqa[h] |= 0x8;
   if (nbadlb[h] > 12 ) coarseqa[h] |= 0x10;
   if (nldsea[h] > 12 ) coarseqa[h] |= 0x20;
   if (nlambe[h] > 12 ) coarseqa[h] |= 0x40;
   if (n_fire[h] > 0  ) coarseqa[h] |= 0x80;  /* ..."at least one..." */
  }

}


void cnvt_to_temp(dims_struct *input, int offset, int n_pixels, float sat_value, float64 lambda)
/*
!C****************************************************************************

!Routine: cnvt_to_temp()

!Description: Converts uint16 data in the input structure into brightness temperature data,
              AND PUTS IT BACK INTO THE SAME DATA STRUCTURE.

!Input Parameters:
      offset                   which band is being converted
      n_pixels
      sat_value
      lambda
      
!Input/Output Parameters:
      input                    IN: structure holding the raw radiance data at offset
                               OUT: structure holding the brightness temperature data at offset

!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END

**************************************************************************/
{
/* Note, does not check for dead bands */
int i;
int dead = 0;
uint16 value;
uint16 *values;
float64 rad, T;
float64 Tb(float64 B, float64 lambda);
const unsigned short SATURATED = 65533;

values = (uint16 *)input->data[offset];

for(i=0;i<n_pixels;i++) {
    value = values[i];
    if (dead || ((value > 32767) && (value != SATURATED))) {
	  values[i] = (uint16)0;
	  }
	else {
	  if (value == SATURATED)
	      T = (float64)sat_value;
	  else {
	      rad = ((float64)value - (float64)input->radoffset[offset]) * (float64)input->radscale[offset];
	      if (rad > 0.0F)
                 T = Tb(rad, lambda);
              else
                 T = (float64)0.0F;
	      }
	  values[i] = (uint16)(T * 100.0F);
	}
    }
}


void cnvt_data_to_temp(uint16 *input, float64 offset, float64 scale, int n_pixels, float sat_value, float64 lambda)
/*
!C****************************************************************************

!Routine: cnvt_data_to_temp()

!Description: Converts uint16 input array data into brightness temperature data,
              AND PUTS IT BACK INTO THE SAME ARRAY.

!Input Parameters:
      offset                   which band is being converted (unused)
      n_pixels
      sat_value
      lambda
      
!Input/Output Parameters:
      input                    IN: array holding the raw radiance data
                               OUT: array holding the brightness temperature data 

!Output Parameters:
  none

!Returns:
  nothing
  
!Revision History:
  Revision 1.0  21-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 

!END

**************************************************************************/
{
/* Note, does not check for dead bands */
int i;
int dead = 0;
uint16 value;
uint16 *values;
float64 rad, T;
float64 Tb(float64 B, float64 lambda);
const unsigned short SATURATED = 65533;

values = input;

for(i=0;i<n_pixels;i++) {
    value = values[i];
    if (dead || ((value > 32767) && (value != SATURATED))) {
	  values[i] = (uint16)0;
	  }
	else {
	  if (value == SATURATED)
	      T = (float64)sat_value;
	  else {
	      rad = ((float64)value - offset) * scale;
	      if (rad > 0.0F)
                 T = Tb(rad, lambda);
              else
                 T = (float64)0.0F;
	      }
	  values[i] = (uint16)(T * 100.0F);
	}
    }
}

float64 PlanckFunction(float64 c1, float64 c2, float64 T)
/*
!C**************************************************************************

!Description: calculates black-body radiance at temperature T
    OBSOLETE -- should not be used anymore (as of 4.4.1 on)
    Use newPlanckFunction() below, instead.

!Input Parameters:
     c1       Planck function constant, equal to (1.1910659e-5)*nu^3, 
                  where nu = T's wavenumber, in cm^-1; must 
                  be precomputed in the calling routine 
     c2       Planck function constant, equal to 1.438833*nu; must 
                  be precomputed in the calling routine 
     T3       brightness temperature, in Kelvin

!Output Parameters:
     none

!Input/Output Parameters:
     none

!Returns:
     black-body radiance in units mW/(m^2 sr cm^-1) (success)

!Revision History:

Revision 1.0, Jim Ray, August, 1999
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END
***************************************************************************/
{
float64 E = 0.0;

E = (c1/(exp(c2/T) - 1.0F));
return(E);  
}


float64 newPlanckFunction(float64 T, float64 lambda )
/*
!C*****************************************************************************
!Description:
	Calculates black-body radiance at temperature T.
!Input Parameters:
	T		temperature (Kelvin)
	lambda		wavelength (microns)

!Output Parameters:
	Returns radiance  (W/m^2/str/micron).

!Revision History:
        Inversion of function Tb() (below), 17-SEP-02, Jim Ray.

!Team-unique Header:
!References and Credits
!Design Notes
!END***************************************************************************
*/
{
	const float64 C1 = 1.19106e+8F;	/* W micron^4 / m^2 sr  -- updated 11-MAY-04 */
	const float64 C2 = 1.43879e+4F;	/* micron K  -- updated 11-MAY-04 */
        float64 x2;
        float64 E = 0.0;
	
	x2 = lambda*lambda;

        E = C1/(exp((C2 / lambda)/T) - 1.0F)/(x2*x2*lambda);

        return(E);  
}


float64 Tb(float64 B, float64 lambda)
/*
!C*****************************************************************************
!Description:
	Invert Planck Function to compute blackbody temperature.
!Input Parameters:
	B		radiance (W/m^2/str/micron)
	lambda		wavelength (microns)

!Output Parameters:
	Returns blackbody temperature (Kelvin).

!Revision History:
	Original version August 1996, L. Giglio (giglio@hades.gsfc.nasa.gov).

!Team-unique Header:
        References and Credits
        Design Notes
!END***************************************************************************
*/
{
	float64 num, denom;
	const float64 C1 = 1.19106e+8F;	/* W micron^4 / m^2 sr  -- updated 11-MAY-04 */
	const float64 C2 = 1.43879e+4F;	/* micron K  -- updated 11-MAY-04 */
        float64 x2;
	
	x2 = lambda*lambda;
	num = C2 / lambda;
	denom = log(1.0F + C1/(B * (x2*x2*lambda)));

	return num / denom;
}


void OLDget_ancillary_data(int mode, char *time) 
/*
!C****************************************************************************

!Routine: get_ancillary_data()

!Description: Gets the Ancillary Data for That Particular Time.

!Input Parameters:
  char time      time in this format: 2002-03-06T08:10:00.000000Z
 
!Input/Output Parameters:
  none

!Output Parameters:
  none

!Returns:
  none
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    updates global stuff.  (As of 11-JUN-04, superceded by new ozone handling code (below).)

!END**************************************************************************/
{
char location[100]="atmcor.c, get_ancillary_data";
char report[2000];
char source[100];

report[0] = '\0';
   read_ancillary_metadata(mode, time, &daowv, report);
   read_ancillary_metadata(mode, time, &daoozone, report);
   read_ancillary_metadata(mode, time, &daospres, report);
   read_ancillary_metadata(mode, time, &daotmp, report);
   read_ancillary_metadata(mode, time, &daouwnd, report);
   read_ancillary_metadata(mode, time, &daovwnd, report);
   PGS_SMF_GenerateStatusReport(report);

   if(read_plane(time, &daowv)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%sWater Vapor", daowv.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daowv.wasread = 0;
      }
   if(read_plane(time, &daoozone)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s Ozone", daoozone.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daoozone.wasread = 0;
      }
   if(read_plane(time, &daospres)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s Surface Pressure", daospres.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daospres.wasread = 0;
      }
   if(read_plane(time, &daotmp)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s Temperature", daotmp.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daotmp.wasread = 0;
      }
   if(read_plane(time, &daouwnd)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s U-Wind", daouwnd.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daouwnd.wasread = 0;
      }
   if(read_plane(time, &daovwnd)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s V-Wind", daovwnd.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daovwnd.wasread = 0;
      }

}

void get_ancillary_data(int mode, char *time) 
/*
!C****************************************************************************

!Routine: get_ancillary_data()

!Description: Gets the Ancillary Data for That Particular Time.

!Input Parameters:
  char time      time in this format: 2002-03-06T08:10:00.000000Z
 
!Input/Output Parameters:
  none

!Output Parameters:
  none

!Returns:
  none
  
!Revision History:
  Revision 1.0  06-FEB-2003
  Jim Ray

!Team-unique Header:
  This software was developed by:

    MODIS Science Data Support Team for the National Aeronautics and Space 
    Administration, Goddard Space Flight Center, under contract NAS5-32373.

  Developer:
      Jim Ray
      Science Systems and Applications, Inc.
      MODIS Land Science Team
      NASA Goddard Space Flight Center
      Greenbelt, Maryland 20771
      jim@cratmos.gsfc.nasa.gov

!References and Credits 

!Design Notes: 
    updates global stuff.

!END**************************************************************************/
{
char location[100]="atmcor.c, get_ancillary_data";
char report[2000];
char source[100];
int ii;

report[0] = '\0';
   read_ancillary_metadata(mode, time, &daowv, report);
   read_ancillary_metadata(mode, time, &daoozone, report);
   read_ancillary_metadata(mode, time, &gdasozone, report);
   read_ancillary_metadata(mode, time, &daospres, report);
   read_ancillary_metadata(mode, time, &daotmp, report);
   read_ancillary_metadata(mode, time, &daouwnd, report);
   read_ancillary_metadata(mode, time, &daovwnd, report);
   PGS_SMF_GenerateStatusReport(report);

   if(read_plane(time, &daowv)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s Water Vapor", daowv.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daowv.wasread = 0;
      }
   if(read_plane(time, &daoozone)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s Ozone", daoozone.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daoozone.wasread = 0;
      }
   if(read_plane(time, &gdasozone)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s Ozone", gdasozone.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        gdasozone.wasread = 0;
      }
   if(read_plane(time, &daospres)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s Surface Pressure", daospres.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daospres.wasread = 0;
      }
   if(read_plane(time, &daotmp)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s Temperature", daotmp.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daotmp.wasread = 0;
      }
   if(read_plane(time, &daouwnd)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s U-Wind", daouwnd.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daouwnd.wasread = 0;
      }
   if(read_plane(time, &daovwnd)!=MODIS_S_SUCCESS){ 
	sprintf(source, "%s V-Wind", daovwnd.anci_source);
	modsmf(MODIS_W_SREFL_ANCIL, source, location);
        daovwnd.wasread = 0;
      }

   /* Right here we need to fill zeros in the daoozone data set with gdasozone data;
      assuming they are the same dimensions... */
   if (gdasozone.wasread == 1)  {
       if (daoozone.wasread == 1) {
          for(ii=0;ii<gdasozone.dims[1]*gdasozone.dims[2];ii++) {
               if (daoozone.data[ii] == 0.0F)  daoozone.data[ii] = gdasozone.data[ii];
              }
          }
       else {
          daoozone.dims[0] = (int32)1;
          daoozone.dims[1] = gdasozone.dims[1];
          daoozone.dims[2] = gdasozone.dims[2];
          daoozone.lonres = gdasozone.lonres;
          daoozone.latres = gdasozone.latres;
	  daoozone.data = (float *) ReAllocMem(daoozone.data, daoozone.dims[1]*daoozone.dims[2]*sizeof(float));	 
          for(ii=0;ii<gdasozone.dims[1]*gdasozone.dims[2];ii++) {
               daoozone.data[ii] = gdasozone.data[ii];
              }
          }
      }
   else {
       /* We need to read in the ozone climatological table at LUN 209954, or /data/jim/database/toms_10yr.anc (on patmos);
          But FOR NOW (07-MAY-04), skip it... */
      }

}

int set_height_pressure(float *lat, float *lon, int16 *height, float *sp, float *slp)
/*
!C*****************************************************************************

!Description:   set_height_pressure; converts MOD03's height and NCEP/DAO's spres
                ancillary data into a 1km surface pressure product.

!Input Parameters:       lat/lon
 
!Output Parameters:      sp                fine-resolution (1km) surface pressure (in atm).
                         slp               fine-resolution (1km) sea level pressure (in atm).

!Input/Output Parameters: none

!Returns:   0 for success
            1 ????

!Revision History:

1. Original Version, Jim Ray, July 18, 2001

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062 and NAS5-31752

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
    Assumes:
    1. NCEP surface pressure (1 deg by 1 deg, float, mbar) is in daospres.
    2. Averaged exp(-z/8) values (1 deg by 1 deg, float) are in avg_z.
       (These values are contained in file 1_km_z8.hdf, SDS "average exp(-z/8)",
        read in init_height_pressure(), above).
    3. NCEP data has same dimensions as avg_z data; if not, routine puts out 
       suboptimal outputs.
    4. Height is 10 by 1354, int16, meters.
    5. Latitude & longitude are 10 by 1354, float, degrees.
    
    Algorithm:
    1. Get ratio of NCEP surface pressure and averaged exp(-z/8) values at 1 deg.
    2. Interpolate ratio at 1 deg. into ratio at 1km (10 by 1354).
    3. Multiply 1km ratio by exp(-height/8000) to get 1km pressure.
    4. Convert 1km pressure into atm., put into sp.
        
    NOTE ALSO: daospres, avg_z are GLOBAL!!!
!END
****************************************************************************/			
{
char tf_name[256];
char location[50]="atmcor.c, set_height_pressure";
float32 *one_deg_avg, *one_deg_ratio, *one_km_ratio, xx; 
int i, j, ii, jj, l, k, row, row1, col, colm1, colp1;
int32 iline, isamp, index;
long line, sample;
short *n;
float32 rowfactor, colfactor;
int32 get_cart_linesamp(float32 lat, float32 lon, float32 latres, int32 samps, float32 lonres, int32 *iline,
		       int32 *isamp, float32 *rowfactor, float32 *colfactor);
float32 local_interpolate(int32 iline, int32 lines, int32 isamp, int32 samps, float32 rowfactor, 
                          float32 colfactor, float32 *data);
FILE *fd;

/* make a local copy of the avg_z data -- shifted by 1 pixel to match daospres (which
   I assume is correct) */
one_deg_avg = (float32 *)CAllocMem(daospres.dims[2]*daospres.dims[1],sizeof(float32));

/*
 * Actually, no need to shift 
for (i=0;i<daospres.dims[1];i++) {
   l = i*daospres.dims[2];
   xx = avg_z.data[l];
   l++;
   for (j=1;j<daospres.dims[2];j++) {
      one_deg_avg[l-1] = avg_z.data[l];
      l++;
   }
   one_deg_avg[l-1] = xx;
}
 *
 */

/*********************************************
 *** 13-FEB-06: Use of PRMSL no longer *******
 *** requires correction by avg_z.   *********
for(i=0;i<daospres.dims[2]*daospres.dims[1];i++) one_deg_avg[i] = avg_z.data[i];
 *********************************************
 *********************************************/
for(i=0;i<daospres.dims[2]*daospres.dims[1];i++) one_deg_avg[i] = 1.0000F;

/* make 1-degree ratio of NCEP surface pressure and avg exp(-z/8) */
one_deg_ratio = (float32 *)CAllocMem(daospres.dims[2]*daospres.dims[1],sizeof(float32));
for(i=0;i<daospres.dims[2]*daospres.dims[1];i++) {
   one_deg_ratio[i] = daospres.data[i]/one_deg_avg[i];
    }
    
/* make 1km version of one_deg_ratio */
one_km_ratio=(float32 *)CAllocMem(NBSCANS_1KM*NBSPOTS_1KM,sizeof(float32));
for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++)
{

     /* will use just the line, sample values calculated in get_cart_linesamp() */
     get_cart_linesamp(lat[i], lon[i], 1.0F, daospres.dims[2], 
		       1.0F, &iline, &isamp, &rowfactor, &colfactor);
		        
     index = iline*daospres.dims[2] + isamp;
     one_km_ratio[i] = one_deg_ratio[index];

/*  09-DEC-04: will by-pass this interpolation... */
/*     one_km_ratio[i] = local_interpolate(iline, daospres.dims[1], isamp, daospres.dims[2], rowfactor, colfactor,
                                     one_deg_ratio);				      
 */
  
}

/* Now multiply the 1km version of the ratio by 
 * exp(-height/8) to get NCEP-corrected pressure 
 ****************************************************/
 
for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++)
{
if (height[i] < 0) height[i] *= -1;
     slp[i] = one_km_ratio[i]*ATMOS_PER_MBAR;
     xx = (float32)(expf(-((float)height[i])/8000.0F)); 
     one_km_ratio[i] *= xx; 
     sp[i] = one_km_ratio[i]*ATMOS_PER_MBAR;
}



free(one_km_ratio);
free(one_deg_avg);
free(one_deg_ratio);

return(0);
}

static float32 PrincipalAngle(float32 angle)
{
#define ONE_OVER_360 2.77777778e-3F
	if (angle < 0.0F) angle = -angle;
	/* only the SGI understands the float floorf function */
#ifdef IRIS4
	angle = angle - 360.0F * floorf(angle * ONE_OVER_360);
#else
	angle = angle - 360.0F * (float)floor((double)(angle * ONE_OVER_360));
#endif
	if (angle > 180.0F) angle = 360.0F - angle;

	return angle;
}

int32 initatmospars(t_atmospars *pars)
/*
!C*****************************************************************************

!Description:   initatmospars(): this initializes important variables in t_atmospars-type variable pars.

!Input Parameters:       
    none
 
!Output Parameters:
    none

!Input/Output Parameters: 
    pars

!Returns:   0   (only 0)

!Revision History:

1. Original Version, Jim Ray, July 18, 2001

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062 and NAS5-31752

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END

****************************************************************************/			
{
   pars->xaH2O[BAND1]=XA_H2O_M1;
   pars->xbH2O[BAND1]=XB_H2O_M1;
   pars->xcH2O[BAND1]=XC_H2O_M1;
   pars->xaH2O[BAND2]=XA_H2O_M2;
   pars->xbH2O[BAND2]=XB_H2O_M2;
   pars->xcH2O[BAND2]=XC_H2O_M2;
   pars->xaH2O[BAND3]=XA_H2O_M3;
   pars->xbH2O[BAND3]=XB_H2O_M3;
   pars->xcH2O[BAND3]=XC_H2O_M3;
   pars->xaH2O[BAND4]=XA_H2O_M4;
   pars->xbH2O[BAND4]=XB_H2O_M4;
   pars->xcH2O[BAND4]=XC_H2O_M4;
   pars->xaH2O[BAND5]=XA_H2O_M5;
   pars->xbH2O[BAND5]=XB_H2O_M5;
   pars->xcH2O[BAND5]=XC_H2O_M5;
   pars->xaH2O[BAND6]=XA_H2O_M6;
   pars->xbH2O[BAND6]=XB_H2O_M6;
   pars->xcH2O[BAND6]=XC_H2O_M6;
   pars->xaH2O[BAND7]=XA_H2O_M7;
   pars->xbH2O[BAND7]=XB_H2O_M7;
   pars->xcH2O[BAND7]=XC_H2O_M7;

   pars->xaO3[BAND1]=XA_O3_M1;
   pars->xaO3[BAND2]=XA_O3_M2;
   pars->xaO3[BAND3]=XA_O3_M3;
   pars->xaO3[BAND4]=XA_O3_M4;
   pars->xaO3[BAND5]=XA_O3_M5;
   pars->xaO3[BAND6]=XA_O3_M6;
   pars->xaO3[BAND7]=XA_O3_M7;

   pars->xaCO2[BAND1]=XA_CO2_M1;
   pars->xbCO2[BAND1]=XB_CO2_M1;
   pars->xcCO2[BAND1]=XC_CO2_M1;
   pars->xdCO2[BAND1]=XD_CO2_M1;
   pars->xaCO2[BAND2]=XA_CO2_M2;
   pars->xbCO2[BAND2]=XB_CO2_M2;
   pars->xcCO2[BAND2]=XC_CO2_M2;
   pars->xdCO2[BAND2]=XD_CO2_M2;
   pars->xaCO2[BAND3]=XA_CO2_M3;
   pars->xbCO2[BAND3]=XB_CO2_M3;
   pars->xcCO2[BAND3]=XC_CO2_M3;
   pars->xdCO2[BAND3]=XD_CO2_M3;
   pars->xaCO2[BAND4]=XA_CO2_M4;
   pars->xbCO2[BAND4]=XB_CO2_M4;
   pars->xcCO2[BAND4]=XC_CO2_M4;
   pars->xdCO2[BAND4]=XD_CO2_M4;
   pars->xaCO2[BAND5]=XA_CO2_M5;
   pars->xbCO2[BAND5]=XB_CO2_M5;
   pars->xcCO2[BAND5]=XC_CO2_M5;
   pars->xdCO2[BAND5]=XD_CO2_M5;
   pars->xaCO2[BAND6]=XA_CO2_M6;
   pars->xbCO2[BAND6]=XB_CO2_M6;
   pars->xcCO2[BAND6]=XC_CO2_M6;
   pars->xdCO2[BAND6]=XD_CO2_M6;
   pars->xaCO2[BAND7]=XA_CO2_M7;
   pars->xbCO2[BAND7]=XB_CO2_M7;
   pars->xcCO2[BAND7]=XC_CO2_M7;
   pars->xdCO2[BAND7]=XD_CO2_M7;

   pars->xaO2[BAND1]=XA_O2_M1;
   pars->xbO2[BAND1]=XB_O2_M1;
   pars->xcO2[BAND1]=XC_O2_M1;
   pars->xdO2[BAND1]=XD_O2_M1;
   pars->xaO2[BAND2]=XA_O2_M2;
   pars->xbO2[BAND2]=XB_O2_M2;
   pars->xcO2[BAND2]=XC_O2_M2;
   pars->xdO2[BAND2]=XD_O2_M2;
   pars->xaO2[BAND3]=XA_O2_M3;
   pars->xbO2[BAND3]=XB_O2_M3;
   pars->xcO2[BAND3]=XC_O2_M3;
   pars->xdO2[BAND3]=XD_O2_M3;
   pars->xaO2[BAND4]=XA_O2_M4;
   pars->xbO2[BAND4]=XB_O2_M4;
   pars->xcO2[BAND4]=XC_O2_M4;
   pars->xdO2[BAND4]=XD_O2_M4;
   pars->xaO2[BAND5]=XA_O2_M5;
   pars->xbO2[BAND5]=XB_O2_M5;
   pars->xcO2[BAND5]=XC_O2_M5;
   pars->xdO2[BAND5]=XD_O2_M5;
   pars->xaO2[BAND6]=XA_O2_M6;
   pars->xbO2[BAND6]=XB_O2_M6;
   pars->xcO2[BAND6]=XC_O2_M6;
   pars->xdO2[BAND6]=XD_O2_M6;
   pars->xaO2[BAND7]=XA_O2_M7;
   pars->xbO2[BAND7]=XB_O2_M7;
   pars->xcO2[BAND7]=XC_O2_M7;
   pars->xdO2[BAND7]=XD_O2_M7;

   pars->xaNO2[BAND1]=XA_NO2_M1;
   pars->xbNO2[BAND1]=XB_NO2_M1;
   pars->xcNO2[BAND1]=XC_NO2_M1;
   pars->xdNO2[BAND1]=XD_NO2_M1;
   pars->xaNO2[BAND2]=XA_NO2_M2;
   pars->xbNO2[BAND2]=XB_NO2_M2;
   pars->xcNO2[BAND2]=XC_NO2_M2;
   pars->xdNO2[BAND2]=XD_NO2_M2;
   pars->xaNO2[BAND3]=XA_NO2_M3;
   pars->xbNO2[BAND3]=XB_NO2_M3;
   pars->xcNO2[BAND3]=XC_NO2_M3;
   pars->xdNO2[BAND3]=XD_NO2_M3;
   pars->xaNO2[BAND4]=XA_NO2_M4;
   pars->xbNO2[BAND4]=XB_NO2_M4;
   pars->xcNO2[BAND4]=XC_NO2_M4;
   pars->xdNO2[BAND4]=XD_NO2_M4;
   pars->xaNO2[BAND5]=XA_NO2_M5;
   pars->xbNO2[BAND5]=XB_NO2_M5;
   pars->xcNO2[BAND5]=XC_NO2_M5;
   pars->xdNO2[BAND5]=XD_NO2_M5;
   pars->xaNO2[BAND6]=XA_NO2_M6;
   pars->xbNO2[BAND6]=XB_NO2_M6;
   pars->xcNO2[BAND6]=XC_NO2_M6;
   pars->xdNO2[BAND6]=XD_NO2_M6;
   pars->xaNO2[BAND7]=XA_NO2_M7;
   pars->xbNO2[BAND7]=XB_NO2_M7;
   pars->xcNO2[BAND7]=XC_NO2_M7;
   pars->xdNO2[BAND7]=XD_NO2_M7;

   pars->xaCH4[BAND1]=XA_CH4_M1;
   pars->xbCH4[BAND1]=XB_CH4_M1;
   pars->xcCH4[BAND1]=XC_CH4_M1;
   pars->xdCH4[BAND1]=XD_CH4_M1;
   pars->xaCH4[BAND2]=XA_CH4_M2;
   pars->xbCH4[BAND2]=XB_CH4_M2;
   pars->xcCH4[BAND2]=XC_CH4_M2;
   pars->xdCH4[BAND2]=XD_CH4_M2;
   pars->xaCH4[BAND3]=XA_CH4_M3;
   pars->xbCH4[BAND3]=XB_CH4_M3;
   pars->xcCH4[BAND3]=XC_CH4_M3;
   pars->xdCH4[BAND3]=XD_CH4_M3;
   pars->xaCH4[BAND4]=XA_CH4_M4;
   pars->xbCH4[BAND4]=XB_CH4_M4;
   pars->xcCH4[BAND4]=XC_CH4_M4;
   pars->xdCH4[BAND4]=XD_CH4_M4;
   pars->xaCH4[BAND5]=XA_CH4_M5;
   pars->xbCH4[BAND5]=XB_CH4_M5;
   pars->xcCH4[BAND5]=XC_CH4_M5;
   pars->xdCH4[BAND5]=XD_CH4_M5;
   pars->xaCH4[BAND6]=XA_CH4_M6;
   pars->xbCH4[BAND6]=XB_CH4_M6;
   pars->xcCH4[BAND6]=XC_CH4_M6;
   pars->xdCH4[BAND6]=XD_CH4_M6;
   pars->xaCH4[BAND7]=XA_CH4_M7;
   pars->xbCH4[BAND7]=XB_CH4_M7;
   pars->xcCH4[BAND7]=XC_CH4_M7;
   pars->xdCH4[BAND7]=XD_CH4_M7;

   pars->tau_r[BAND1]=0.05100;
   pars->tau_r[BAND2]=0.01631;
   pars->tau_r[BAND3]=0.19325;
   pars->tau_r[BAND4]=0.09536;
   pars->tau_r[BAND5]=0.00366;
   pars->tau_r[BAND6]=0.00123;
   pars->tau_r[BAND7]=0.00043;

   return 0;
   }

static int32 NearlyZero(float32 x)
/*
!C*****************************************************************************

!Description: NearlyZero()
 
!Input Parameters:

!Output Parameters:
consts

!Input/Output Parameters:
none

!Returns:
    0 if x is above/below +/- 1.0e-20F

!Revision History:

Revision 1.0, Jim Ray, February 2001
1. Original Version 

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END

****************************************************************************/
{
	const float32 limit = 1.0e-20F;

	return -(x < limit && x > -limit);
}

void half_km_copy(float **c_consts, float **consts, int onekm_or_500m)
{
/*
!C*****************************************************************************

!Description: half_km_copy()
   Copies 1km (or 500m) resolution scan line data within c_consts 
   array to half-km (or 250m) resolution within the consts array.

!Input Parameters:
c_consts
onekm_or_500m    flag for whether c_consts is 1km data (0) or 500m data (1).

!Output Parameters:
consts

!Input/Output Parameters:
none

!Returns:
none

!Revision History:

Revision 1.0, Jim Ray, February 2001
1. Original Version 

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
1.  Ignores the effects of pixel size variations and the scan bow-tie.
2.  Can be used for copying 1km data to 500m, or 500m to 250m.
3.  locator arrays locator500 and locator500_250 ARE GLOBAL.

!END
****************************************************************************/
  int i, ii, n_bands, ichannel, ich, index, rows, cols;
  int32 *locator;
  /*extern int32 locator500[], locator500_250[];*/
  int j;
  
  if (onekm_or_500m) {   /* we are doing 500m -> 250m */
     n_bands = 2;
     rows = NBSCANS_500M;
     cols = NBSPOTS_500M;
     locator = (int32 *)malloc(rows*cols*4*sizeof(int32));
     for(i=0;i<rows*cols*4;i++) locator[i] = locator500_250[i];
     }
  else {                 /* we are doing 1km -> 500m */
     n_bands = 7;
     rows = NBSCANS_1KM;
     cols = NBSPOTS_1KM;
     locator = (int32 *)malloc(rows*cols*4*sizeof(int32));
     for(i=0;i<rows*cols*4;i++) locator[i] = locator500[i];
     }

  for (ichannel=0; ichannel<n_bands; ichannel++) { 
    
    /* Copy the coarse data into the fine data */
    index=0;
    for(i=0;i<rows*cols;i++){
       for (ii=0;ii<4;ii++) {
	  consts[ichannel][locator[index]]=c_consts[ichannel][i];
	  index++;
	  }
       }
         
  }/* for (ichannel=0; ichannel<n_bands; ichannel++)... */
  
free(locator);
}

void half_km_interp(float **c_consts, float **consts, int onekm_or_500m)
{
/*
!C*****************************************************************************

!Description: half_km_interp()
   Interpolates 1km (or 500m) resolution scan line data within c_consts 
   array to half-km (or 250m) resolution within the consts array.

!Input Parameters:
c_consts
onekm_or_500m    flag for whether c_consts is 1km data (0) or 500m data (1).

!Output Parameters:
consts

!Input/Output Parameters:
none

!Returns:
none

!Revision History:

Revision 1.0, Jim Ray, February 2001
1. Original Version 

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes
1.  Ignores the effects of pixel size variations and the scan bow-tie.
2.  Can be used for copying 1km data to 500m, or 500m to 250m.
3.  locator arrays locator500 and locator500_250 ARE GLOBAL.

!END
****************************************************************************/
#define WEIGHT_3 0.0625  /* 0.25 * 0.25 */
#define WEIGHT_2 0.1875  /* 0.75 * 0.25 */
#define WEIGHT_1 0.5625  /* 0.75 * 0.75 */
  int i, ii, n_bands, ichannel, ich, index, rows, cols, temp_index, extrap;
  int32 *locator;
  int32 forfirstline;
  /*extern int32 locator500[], locator500_250[];*/
  int j;
  float32 *scratch1;
  float32 savesum1, sum1;
  typedef struct {
     int8 x,y;
  } rowcol_t;
  rowcol_t w[4] = {{-1,-1},{-1,1},{1,-1},{1,1}};
 
  if (onekm_or_500m) {   /* we are doing 500m -> 250m */
     forfirstline = (NBSCANS_250M-1)*NBSPOTS_250M;
     n_bands = 2;
     rows = NBSCANS_500M;
     cols = NBSPOTS_500M;
     locator = (int32 *)malloc(rows*cols*4*sizeof(int32));
     for(i=0;i<rows*cols*4;i++) locator[i] = locator500_250[i];
     }
  else {                 /* we are doing 1km -> 500m */
     forfirstline = (NBSCANS_500M-1)*NBSPOTS_500M;
     n_bands = 7;
     rows = NBSCANS_1KM;
     cols = NBSPOTS_1KM;
     locator = (int32 *)malloc(rows*cols*4*sizeof(int32));
     for(i=0;i<rows*cols*4;i++) locator[i] = locator500[i];
     }
  scratch1 = (float32 *)malloc(rows*cols*sizeof(float32));

  for (ichannel=0; ichannel<n_bands; ichannel++) { 
    
    if ((ichannel==5)||(ichannel==6)) {  /* then don't interpolate, just copy */
       index=0;
       for(i=0;i<rows*cols;i++){
          for (ii=0;ii<4;ii++) {
	     consts[ichannel][locator[index]]=c_consts[ichannel][i];
	     index++;
	     }
          }
       }
    else { 
       index=0;
       /* Get the coarse data into a temporary array */
       for(i=0;i<rows*cols;i++)
	     scratch1[i]=c_consts[ichannel][i];

       /******************************************/
    /* Read from scratch array */
    for(i=0;i<rows;i++){
      for(j=0;j<cols;j++){

        for (ii=0;ii<4;ii++) {
	  extrap = 0;
	  sum1 = 0.0F;
	  
	  /* weight 1 */
	  temp_index = i*cols + j;
	  sum1 += scratch1[temp_index]*WEIGHT_1;
	  
	  /* weight 2 (3) */
	  if ( (i + w[ii].x) < 0 ) {  
	     /* use pixels from the last line of consts, which should still have 
	        data from the last time this routine was called */
	     sum1 += consts[ichannel][locator[index]+forfirstline]*WEIGHT_2;

	     sum1 += consts[ichannel][locator[index]+forfirstline+w[ii].y]*WEIGHT_3; 
	  }
	  else if ( (i + w[ii].x) > (rows-1) ) { 
	     /* extrapolate data from last two lines (below) */ 
	     extrap = 1;
	  }
	  else {
	    temp_index = (i + w[ii].x)*cols + j;
	    sum1 += scratch1[temp_index]*WEIGHT_2;
	  
	    if ( ((j + w[ii].y) > -1 ) && ((j + w[ii].y) < cols ) ) {
	       temp_index = (i + w[ii].x)*cols + (j + w[ii].y);
	       sum1 += scratch1[temp_index]*WEIGHT_3;
	    }
	    else  {
	     /* presumably this situation will be caught below, so do nothing here */
	     extrap = 4;  /* a test */
	    }
          }
	  
	  /* weight 2 */
	  if ( ((j + w[ii].y) > -1 ) && ((j + w[ii].y) < cols ) ) {
	    temp_index = i*cols + (j + w[ii].y);
	    sum1 += scratch1[temp_index]*WEIGHT_2;
	  }
	  else  {
	     extrap = 3;
	     if ( (j + w[ii].y) < 0 ) extrap = 2;
	  }
	  
	  /* 19-NOV-02: will save these values in case the extrapolation doesn't work. */
	  savesum1 = sum1;

	  switch (extrap)
	  {
	  case(0):  /*  do nothing, no need for extrapolation. */
	     break;
	  case(1):  /*  (i + w[ii].x) > (rows-1) */
	     /* extrapolate data from last two lines */ 
	     sum1 = 2*consts[ichannel][locator[index]-(cols*2)];
	     sum1 -= consts[ichannel][locator[index]-(2*(cols*2))];
	     break;
	   case(2): /* (j + w[ii].y) < 0 ) */
	     sum1 = 2*consts[ichannel][locator[index]+1];
	     sum1 -= consts[ichannel][locator[index]+2];
	     break;
	   case(3): /* (j + w[ii].y) > cols ) */
	     sum1 = 2*consts[ichannel][locator[index]-1];
	     sum1 -= consts[ichannel][locator[index]-2];
	     break;
	   default: 
	     break;
		 
          }
	  
	  /* 19-NOV-02: if you've extrapolated and the sum is zero, maybe something went wrong; use the old value. */
	  if (extrap) {
	     if (sum1 == 0.0) sum1 = savesum1;
	  }
	  
	  consts[ichannel][locator[index]]=sum1;
	  
	  index++;
	  }
      }
    } /* for(i=0;i<rows;i++) */

       /******************************************/
       }
       
  }/* for (ichannel=0; ichannel<n_bands; ichannel++)... */
  
free(scratch1);
free(locator);
}

float split_window_s_temp(float fb31, float fb32, float fmuv)
/*
!C*************************************************************************

!Description: calculates surface temperature with the spilt window method

!Input Parameters:
     fb31       brightness temperature, band 31
     fb32       brightness temperature, band 32
     fmuv       cosine of the view zenith angle

!Output Parameters:
     none

!Input/Output Parameters:
     none

!Returns:
     surface temperature (success)

!Revision History:

Revision 1.0, Jim Ray, Oct. 2001
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END
****************************************************************************/
{
float surftemp;
float t31_t32;
float co1[3] = {1.11071F,   1.196099F,    0.00000F};
float co2[3] = {0.9586865F, 0.9888366F,   1.00000F};
float co3[3] = {0.1741229F, 0.1300626F,   0.00000F};
float co4[3] = {1.876752F,  1.627125F,    0.00000F};
int coeff_index;

 
t31_t32 = fb31-fb32;
   
if (t31_t32 <= 0.7F)      coeff_index = 0;
else if (t31_t32 <= 3.0F) coeff_index = 1;
else                      coeff_index = 2;

surftemp = co1[coeff_index];
surftemp += co2[coeff_index]*(fb31 - 273.15F);
surftemp += co3[coeff_index]*(fb31 - 273.15F)*t31_t32;
surftemp += co4[coeff_index]*t31_t32*((1.0F/fmuv) - 1.0F);
surftemp += 273.15F;
return(surftemp);
}


void clamp_ref_250(float *ref, uint16 *qc250mval, uint16 blank, uint16 qc250m_mask, uint16 modlandQA)
/*
!C*****************************************************************************
!Description:
	Clamp scaled reflectance to physically meaningful range.  If clamping
	was necessary, set appropriate qa.

!Input Parameters:
	ref		scaled reflectance
	qc250mval       250m qa band quality buffer
	blank           band-specific value with which QA must be reset, if clamping is necessary
	                (If QA is to be changed, QA has to be reset first.)
	qc250m_mask     band qa value to set if clamping is necessary
	modlandQA       modland qa value to set if clamping is necessary

!Output Parameters:
	ref		clamped scaled reflectance
	qc250mval       250m qa band quality buffer

!Revision History:
        Revision 1.1, May 1997, P. Fisher\SSAI\GSFC Code 923
	1.  Added qa functionality

	Original version June 1996, L. Giglio 

!Team-unique Header:

    This software developed by the MODIS Land Science Team for 
    the National Aeronautics and Space Administration, Goddard 
    Space Flight Center, under contract NAS5-96062

!References and Credits 

MODIS TEAM MEMBER
			Eric F Vermote
			Univerisity of MD.
		   	NASA's GSFC Code 923
		   	Greenbelt, MD , 20771
			eric@kratmos.gsfc.nasa.gov
			301-286-6232

DEVELOPERS:
		Paul Fisher
		Science Systems and Applications Inc.
		NASA's Goddard Space Flight Center Code 923
		Greenbelt MD, 20771
 		fisher@ltpmail.gsfc.nasa.gov, (301) 286-2980

		Louis Giglio
		Science Systems and Applications Inc.
		NASA's Goddard Space Flight Center Code 923
		Greenbelt MD, 20771
 		giglio@hades.gsfc.nasa.gov, (301) 286-2091

!Design Notes:

!END***************************************************************************
*/
{
  /* REFMINQAVALUE is always higher than REFMINVALUE */
  if(*ref<REFMINVALUE)*ref = REFMINVALUE;

  if(*ref<REFMINQAVALUE){
    *qc250mval &= ~(blank);
    *qc250mval |= qc250m_mask;
    *qc250mval |= modlandQA;
    return;
  }
  
  if (*ref > REFMAXVALUE) {
    *ref = REFMAXVALUE;
    *qc250mval &= ~(blank);
    *qc250mval |= qc250m_mask;
    *qc250mval |= modlandQA;
    return;
  }
}


void clamp_ref_1_OR_500(float *ref, uint32 *qc500mval, uint32 blank, uint32 qc500m_mask, uint32 modlandQA)
/*
!C*****************************************************************************
!Description:
	Clamp scaled reflectance to physically meaningful range.  If clamping
	was necessary, set appropriate qa.

!Input Parameters:
	ref		scaled reflectance
	qc500mval       500m qa band quality buffer
	blank           band-specific value with which QA must be reset, if clamping is necessary
	                (If QA is to be changed, QA has to be reset first.)
	qc500m_mask     band qa value to set if clamping is necessary
	modlandQA       modland qa value to set if clamping is necessary

!Output Parameters:
	ref		clamped scaled reflectance
	qc500mval       500m qa band quality buffer

!Revision History:
        Revision 1.1, May 1997, P. Fisher\SSAI\GSFC Code 923
	1.  Added qa functionality

	Original version June 1996, L. Giglio 

!Team-unique Header:

    This software developed by the MODIS Land Science Team for 
    the National Aeronautics and Space Administration, Goddard 
    Space Flight Center, under contract NAS5-96062

!References and Credits 

MODIS TEAM MEMBER
			Eric F Vermote
			Univerisity of MD.
		   	NASA's GSFC Code 923
		   	Greenbelt, MD , 20771
			eric@kratmos.gsfc.nasa.gov
			301-286-6232

DEVELOPERS:
		Paul Fisher
		Science Systems and Applications Inc.
		NASA's Goddard Space Flight Center Code 923
		Greenbelt MD, 20771
 		fisher@ltpmail.gsfc.nasa.gov, (301) 286-2980

		Louis Giglio
		Science Systems and Applications Inc.
		NASA's Goddard Space Flight Center Code 923
		Greenbelt MD, 20771
 		giglio@hades.gsfc.nasa.gov, (301) 286-2091

!Design Notes:

!END***************************************************************************
*/
{
   /* REFMINQAVALUE is always higher than REFMINVALUE */
  if (*ref<REFMINVALUE)*ref = REFMINVALUE;

  if(*ref<REFMINQAVALUE){
    *qc500mval &= ~(blank);
    *qc500mval |= qc500m_mask;
    *qc500mval |= modlandQA;
    return;
  }
  
  if (*ref > REFMAXVALUE) {
    *ref = REFMAXVALUE;
    *qc500mval &= ~(blank);
    *qc500mval |= qc500m_mask;
    *qc500mval |= modlandQA;
    return;
  }
}

void redo_fire_mask(int scan, dims_struct *local_output, float tmp1kband[7][NBSCANS_1KM*NBSPOTS_1KM], float tmp5band[7][NBSCANS_500M*NBSPOTS_500M], 
                    float *rhog, float *airtemp, float *surftemp, float *fmuv)
/*
!C*****************************************************************************

!Description: redoes the fire mask (and adds to the cloud masks)

!Input Parameters:
	     local_output,   which contains band 20 albedo
	     tmp1kband       floating-point versions of corrected 1km bands
	     tmp5band        floating-point versions of corrected 500m bands
	     airtemp
	     surftemp
	     fmuv            cosine of the view zenith angle

!Output Parameters:
             none

!Input/Output Parameters:
             local_output's  sqc1km_state, retr_cm

!Returns:
   nothing
   
!Revision History:

Revision 1.0, J. Ray, 07-SEP-01
1. Original Version

!Team-unique Header:

    This software developed by the MODIS Land Science Team for
    the National Aeronautics and Space Administration, Goddard
    Space Flight Center, under contract NAS5-96062

!References and Credits:
  
    MODIS Science Team Members:
			
	Eric F Vermote
	Univerisity of MD.
   	NASA's GSFC Code 923
   	Greenbelt, MD , 20771
	eric@kratmos.gsfc.nasa.gov
	301-286-6232

    Developers:
      Jim Ray
      MODIS Land Science Team           Science Systems and Applications Inc.
      jim@cratmos.gsfc.nasa.gov         NASA's GSFC Code 923 
      phone (301) 614-6684              Greenbelt, MD 20771
 

!Design Notes

!END
****************************************************************************/
{
int i, j, cloud, fire, row, col;
float b1, b2, b3, b5, b6, b7, RATIO, TA, T, rho_predicted;
float fb1, fb2, fb3, fb7;
double num, den;
int index500m;
int32 where;
int16 *band20a;
float *band1, *band3, *band6, *band7;
float *fband1, *fband2, *fband3, *fband7;
uint16 *sqc1km_state, *retr_cm;
int16 *aotband1, *aotband3, *aotband8;  /* 04-FEB-05 */
uint8 *retr_qa;
float RA, VRA;                      /* reflective anomaly, visible reflective anomaly */
float32 VRAC, MIRAF, NDVI;
extern float32 ALPHAF, BETAF, GAMMAF, DELTAF, MIRAFTOG, MIRAFTIG, TATOG, TATIG, ROGT;  
extern int ii;  /* 26-JUN-02 */

band20a = local_output->data[BAND20ALB];
sqc1km_state = local_output->data[STATE];
retr_cm = local_output->data[AOTCM];
retr_qa = local_output->data[AOTQA];
band1 = tmp1kband[0];
band3 = tmp1kband[2];
band6 = tmp1kband[5];
band7 = tmp1kband[6];
fband1 = tmp5band[0];
fband2 = tmp5band[1];
fband3 = tmp5band[2];
fband7 = tmp5band[6];
aotband1 = local_output->data[AOT_1]; /* 04-FEB-05 */ 
aotband3 = local_output->data[AOT_3];
aotband8 = local_output->data[AOT_8];

index500m=0;

for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++){

    fire = 0;
    b1=band1[i];
    b3=band3[i];
    b6=band6[i];
    b7=band7[i];

/*
    if (sat_type == 0) / * 26-JUN-02: terra * /
       rho_predicted = 0.82F*b7 - 0.32F*b6;
    else               / * 26-JUN-02: assume aqua, don't use band 6 * /
       rho_predicted = 0.22F*b7;
*/

    /* 01-FEB-05: new */
    rho_predicted = (0.149975F*b7 + (2.58535e-01*b7*b7)) ;
       
    RA = ((float)(band20a[i])/10000.0F) - rho_predicted;
    VRA = b3 - (b1/2.0F);
    MIRAF = ((RA - ALPHAF*(fabsf(VRA)))*(powf(fmuv[i],BETAF))) - 
               (GAMMAF*rho_predicted/(powf(fmuv[i],DELTAF)));  /* new, 31-MAY-02: GAMMAF = 0.25, DELTAF = 2.0 */
    TA = surftemp[i] - airtemp[i];
 
    if (rhog[i] > ROGT) {  /* inside the glint */
        if ((TA > TATIG) && (MIRAF > MIRAFTIG)) fire = 1;
    }
    else {               /* outside the glint */
        if ((TA > TATOG) && (MIRAF > MIRAFTOG)) fire = 1;
    }
    
    /* update sqc1km_state */
    sqc1km_state[i] = sqc1km_state[i] & ~QAINTFIRE;   /* clear the internal fire mask bit */
    retr_cm[i] = retr_cm[i] & ~ICM_FIREMASK;
    if (fire) {
        sqc1km_state[i] |= QAINTFIRE;
        retr_cm[i] |= ICM_FIREMASK;
	}
    

    /* update the cloud mask */
    
    if (((retr_cm[i]&0x000d) == 0)  /* not cloudy */
      &&((retr_cm[i]&0x0010) == 0) && (retr_qa[i] != 8) /* neither snow nor "snowy" */
      && (fire == 0)) { /* not fire */
         cloud = 0;
         for(j=0;j<4;j++){
         


	    where = locator500[index500m];   /* this is global */
            fb1 = fband1[where];
            fb2 = fband2[where];
            fb3 = fband3[where];
            fb7 = fband7[where];

	    RATIO = 0.000F;
	    if (fb1 > 0.000F) RATIO = fb3/fb1;
	    
	    VRAC = 2.0F*fb3 - fb1;
	    NDVI = (fb2-fb1)/(fb2+fb1);
	    
	    /*if (VRAC > 0.20F) cloud = 1;
	    else{*/
	       if ((fb7 > 0.15F)&&(RATIO > 0.75F)&&(VRAC > 0.05F)&&
	           /* 12-DEC-02: changed ^^^^^^^^ this from 0.85 to 0.75 */
	           /*(NDVI > 0.05)&&*/
		   (fb2 > 0.05)&&(TA < 6.0)) cloud = 1;
	    /*}*/
	    
	    index500m++;
	  }

	  if (cloud) {
             sqc1km_state[i] |= QAINTCM;  /* flag as cloud */
	     retr_qa[i] = 4;              /* FLAG AS CLOUD HERE TOO (09-FEB-05) */
             retr_cm[i] |= 0x0001;        /* flag as cloud */
             retr_cm[i] = retr_cm[i] & ~(0x0200);                   /* 06-MAY-05: CLEAR THIS ADJACENT-TO-CLOUD BIT */
             retr_cm[i] = retr_cm[i] & ~(0x0002);                   /* 06-MAY-05: UNSET THE "CLEAR" BIT */
             sqc1km_state[i] = sqc1km_state[i] & ~QAHIGHAEROSOL;    /* 25-JAN-05: CLEAR THESE AEROSOL QUANTITY BITS */
	     aotband1[i] = AOT1_FILL;                               /* 04-FEB-05: CLEAR THE AOT */
	     aotband3[i] = AOT3_FILL;  
	     aotband8[i] = AOT8_FILL;
             retr_cm[i] |= QACLIMATOLOGY;                           /* 16-MAY-05: set back the climatology bit 
	                                                               This is just to prevent the state QA's AOT quality bits
								       from being tinkered with in atmcorrect(). */
								       								       
	     /*if ((scan == 189) && (i == ((5*1354)+899))) printf("%d %d %d\n", sqc1km_state[i], retr_cm[i], retr_qa[i]);*/
	  }

/*if ((scan == 79)&&(i == 10307)) printf("7 HERE %d %d %d %d\n", cloud, sqc1km_state[i], retr_qa[i], retr_cm[i]);*/
	  
      } /* if not cloudy, not snowy, not firey */
      else 
         index500m += 4;  /* skip it */

    }  /*  for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++)  */
    

/* 06-MAY-05: Now, for each value of sqc1km_state flagged as cloudy, flag all 3 by 3 adjacent 
   RETR_CM values for "adjacent cloud" IF they aren't already clouds themselves. 
   Same as in get_internal_cloud_mask().  */
if (0==1) {   /* 05-JUN-06: No, this version of the code, we will do this immediately prior to 
                 interpolation */

  for(row=1;row<NBSCANS_1KM-1;row++){
     for(col=1;col<NBSPOTS_1KM-1;col++){
        i = row*NBSPOTS_1KM + col;
	if ( (sqc1km_state[i]&0x0400) != 0 ) {
	    if (!(retr_cm[i-1]%2)) retr_cm[i-1] |= 512;
	    if (!(retr_cm[i+1]%2)) retr_cm[i+1] |= 512;
	    j = i - NBSPOTS_1KM;
	    if (!(retr_cm[j-1]%2)) retr_cm[j-1] |= 512;
	    if (!(retr_cm[j]%2)) retr_cm[j]     |= 512;
	    if (!(retr_cm[j+1]%2)) retr_cm[j+1] |= 512;
	    j = i + NBSPOTS_1KM;
	    if (!(retr_cm[j-1]%2)) retr_cm[j-1] |= 512;
	    if (!(retr_cm[j]%2)) retr_cm[j]     |= 512;
	    if (!(retr_cm[j+1]%2)) retr_cm[j+1] |= 512;
	    }
     }
  }

      /* 26-JAN-05: de-aerosol "adjacent to cloud" pixels, which are cloud, FAIAP */
for(i=0;i<NBSCANS_1KM*NBSPOTS_1KM;i++) {
      if  ( (retr_cm[i]&0x0200) != 0x0 ) {  /* adj cloud */
	  retr_qa[i] = 19; 
          sqc1km_state[i] = sqc1km_state[i] & ~QAHIGHAEROSOL;     /* 04-FEB-05: CLEAR THESE AEROSOL QUANTITY BITS */
	  aotband1[i] = AOT1_FILL;                                /* 04-FEB-05: CLEAR THE AOT (these might be zero anyway...) */
	  aotband3[i] = AOT3_FILL;  
	  aotband8[i] = AOT8_FILL;
	  }
      }
}
}
  


